package test; 
import com.aelitis.azureus.ui.common.table.TableColumnCore;
import com.aelitis.azureus.ui.common.table.impl.TableColumnImpl;
import com.aelitis.azureus.ui.swt.views.list.*;

import static org.junit.Assert.*;

import java.lang.ref.PhantomReference;
import java.lang.ref.ReferenceQueue;

import junit.framework.TestCase;

import org.eclipse.swt.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.internal.runners.TestClass;

public class ListViewTest8  extends ListViewTest{
	
	@Test
	public void testHandleResizeH() {
		ListView target = new ListView("TEST CASE #1", null,
				comp, null,  SWT.NONE);
		
		assertTrue(target.listCanvas != null);
		target.listCanvas.setBounds(10, 10, 100, 100);
		
		target.allColumns = new TableColumnImpl[0];
		target.rows.add(new ListRow(target, comp, null));

		Image back;
		back = target.imgView;
		target.handleResize(true);
		assertTrue(back != target.imgView);
				
		target.handleResize(false);
		
		back = null;
		myGC();
		assertTrue(Image.numberOfNonDisposed() == 0);

	}
	
}

