package test;

import junit.framework.TestCase;
import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTError;
import org.eclipse.swt.SWTException;
import junit.framework.*;
import junit.textui.TestRunner;
import java.io.ByteArrayOutputStream;
import java.io.PrintStream;


import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class MyTestRunner extends TestCase {
    
	
    public static void main(String[] args) {
        TestRunner.run(suite(args));
    }
    
    private static Test suite(String[] args) {
	System.out.println(args);
	String[] parts = args[0].split(",");

	String className = parts[0];
	String methodName = parts[1];


        ClassLoader.getSystemClassLoader().setDefaultAssertionStatus(true);
	
	String desc = "Unit Test for SWT, Class:"+className+" method:"+methodName;
	System.out.println(desc);
	TestSuite suite = new TestSuite(desc);

	try{
	    Class cls = Class.forName(className);
	    suite.addTest(TestSuite.createTest(cls, methodName));
	} catch (java.lang.ClassNotFoundException e1) {
	    e1.printStackTrace();
	}
	return suite;
	
    }
    
	/*
	  public static void main(String[] args) {

	    TestSuite suite = new TestSuite();
	    
	    
	    suite.addTestSuite(Test_org_eclipse_swt_SWT.class);
	    suite.addTestSuite(Test_org_eclipse_swt_SWTError.class);
	    suite.addTestSuite(Test_org_eclipse_swt_SWTException.class);

	    suite.addTestSuite(Test_org_eclipse_swt_graphics_RGB.class);
	    suite.addTestSuite(Test_org_eclipse_swt_graphics_Region.class);
	    suite.addTestSuite(Test_org_eclipse_swt_graphics_Point.class);
	    //suite.addTestSuite(Test_org_eclipse_swt_graphics_ImageLoaderEvent.class);
	    suite.addTestSuite(Test_org_eclipse_swt_graphics_ImageLoader.class);
	    suite.addTestSuite(Test_org_eclipse_swt_graphics_FontMetrics.class);
	    suite.addTestSuite(Test_org_eclipse_swt_graphics_FontData.class);
	    suite.addTestSuite(Test_org_eclipse_swt_graphics_Font.class);
	    //suite.addTestSuite(Test_org_eclipse_swt_graphics_DeviceData.class);
	    suite.addTestSuite(Test_org_eclipse_swt_graphics_Cursor.class);
	    //suite.addTestSuite(Test_org_eclipse_swt_graphics_color.class);

	    suite.addTestSuite(Test_org_eclipse_swt_accessibility_AccessibleTextEvent.class);
	    suite.addTestSuite(Test_org_eclipse_swt_accessibility_AccessibleEvent.class);
	    suite.addTestSuite(Test_org_eclipse_swt_accessibility_AccessibleControlEvent.class);
	    suite.addTestSuite(Test_org_eclipse_swt_accessibility_Accessible.class);

	    
	    suite.addTestSuite(SWTBug322222Fail.class);

	    TestRunner.run(suite);
        }
	*/

  

}