/*
 * CairoStatus.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.freedesktop.cairo;

import org.freedesktop.cairo.Plumbing;

final class CairoStatus extends Plumbing
{
    private CairoStatus() {}

    static final int SUCCESS = 0;

    static final int NO_MEMORY = 1;

    static final int INVALID_RESTORE = 2;

    static final int INVALID_POP_GROUP = 3;

    static final int NO_CURRENT_POINT = 4;

    static final int INVALID_MATRIX = 5;

    static final int INVALID_STATUS = 6;

    static final int NULL_POINTER = 7;

    static final int INVALID_STRING = 8;

    static final int INVALID_PATH_DATA = 9;

    static final int READ_ERROR = 10;

    static final int WRITE_ERROR = 11;

    static final int SURFACE_FINISHED = 12;

    static final int SURFACE_TYPE_MISMATCH = 13;

    static final int PATTERN_TYPE_MISMATCH = 14;

    static final int INVALID_CONTENT = 15;

    static final int INVALID_FORMAT = 16;

    static final int INVALID_VISUAL = 17;

    static final int FILE_NOT_FOUND = 18;

    static final int INVALID_DASH = 19;

    static final int INVALID_DSC_COMMENT = 20;

    static final int INVALID_INDEX = 21;

    static final int CLIP_NOT_REPRESENTABLE = 22;
}

