/*
 * GdkCursorType.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkCursorType extends Plumbing
{
    private GdkCursorType() {}

    static final int LEFT_PTR = get_ordinal_left_ptr();

    private static native final int get_ordinal_left_ptr();

    static final int RIGHT_PTR = get_ordinal_right_ptr();

    private static native final int get_ordinal_right_ptr();

    static final int WATCH = get_ordinal_watch();

    private static native final int get_ordinal_watch();

    static final int XTERM = get_ordinal_xterm();

    private static native final int get_ordinal_xterm();

    static final int LEFT_SIDE = get_ordinal_left_side();

    private static native final int get_ordinal_left_side();

    static final int RIGHT_SIDE = get_ordinal_right_side();

    private static native final int get_ordinal_right_side();

    static final int TOP_LEFT_CORNER = get_ordinal_top_left_corner();

    private static native final int get_ordinal_top_left_corner();

    static final int TOP_RIGHT_CORNER = get_ordinal_top_right_corner();

    private static native final int get_ordinal_top_right_corner();

    static final int TOP_SIDE = get_ordinal_top_side();

    private static native final int get_ordinal_top_side();

    static final int BOTTOM_LEFT_CORNER = get_ordinal_bottom_left_corner();

    private static native final int get_ordinal_bottom_left_corner();

    static final int BOTTOM_RIGHT_CORNER = get_ordinal_bottom_right_corner();

    private static native final int get_ordinal_bottom_right_corner();

    static final int BOTTOM_SIDE = get_ordinal_bottom_side();

    private static native final int get_ordinal_bottom_side();

    static final int FLEUR = get_ordinal_fleur();

    private static native final int get_ordinal_fleur();

    static final int CURSOR_IS_PIXMAP = get_ordinal_cursor_is_pixmap();

    private static native final int get_ordinal_cursor_is_pixmap();
}

