/*
 * GdkModifierType.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkModifierType extends Plumbing
{
    private GdkModifierType() {}

    static final int SHIFT_MASK = get_ordinal_shift_mask();

    private static native final int get_ordinal_shift_mask();

    static final int LOCK_MASK = get_ordinal_lock_mask();

    private static native final int get_ordinal_lock_mask();

    static final int CONTROL_MASK = get_ordinal_control_mask();

    private static native final int get_ordinal_control_mask();

    static final int MOD1_MASK = get_ordinal_mod1_mask();

    private static native final int get_ordinal_mod1_mask();

    static final int MOD2_MASK = get_ordinal_mod2_mask();

    private static native final int get_ordinal_mod2_mask();

    static final int MOD3_MASK = get_ordinal_mod3_mask();

    private static native final int get_ordinal_mod3_mask();

    static final int MOD4_MASK = get_ordinal_mod4_mask();

    private static native final int get_ordinal_mod4_mask();

    static final int MOD5_MASK = get_ordinal_mod5_mask();

    private static native final int get_ordinal_mod5_mask();

    static final int BUTTON1_MASK = get_ordinal_button1_mask();

    private static native final int get_ordinal_button1_mask();

    static final int BUTTON2_MASK = get_ordinal_button2_mask();

    private static native final int get_ordinal_button2_mask();

    static final int BUTTON3_MASK = get_ordinal_button3_mask();

    private static native final int get_ordinal_button3_mask();

    static final int BUTTON4_MASK = get_ordinal_button4_mask();

    private static native final int get_ordinal_button4_mask();

    static final int BUTTON5_MASK = get_ordinal_button5_mask();

    private static native final int get_ordinal_button5_mask();

    static final int SUPER_MASK = get_ordinal_super_mask();

    private static native final int get_ordinal_super_mask();

    static final int HYPER_MASK = get_ordinal_hyper_mask();

    private static native final int get_ordinal_hyper_mask();

    static final int META_MASK = get_ordinal_meta_mask();

    private static native final int get_ordinal_meta_mask();

    static final int RELEASE_MASK = get_ordinal_release_mask();

    private static native final int get_ordinal_release_mask();

    static final int MODIFIER_MASK = get_ordinal_modifier_mask();

    private static native final int get_ordinal_modifier_mask();
}

