/*
 * GdkPixbufError.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkPixbufError extends Plumbing
{
    private GdkPixbufError() {}

    static final int HEADER_CORRUPT = 0;

    static final int PIXEL_CORRUPT = 1;

    static final int UNKNOWN_FORMAT = 2;

    static final int CORRUPT_IMAGE = 3;

    static final int INSUFFICIENT_MEMORY = 4;

    static final int BAD_OPTION_VALUE = 5;

    static final int UNKNOWN_TYPE = 6;

    static final int UNSUPPORTED_OPERATION = 7;

    static final int FAILED = 8;
}

