/*
 * GdkRgbCmap.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;
import org.gnome.gdk.RgbCmap;

final class GdkRgbCmap extends Plumbing
{
    private GdkRgbCmap() {}

    static final void free(RgbCmap self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_rgb_cmap_free(pointerOf(self));
        }
    }

    private static native final void gdk_rgb_cmap_free(long self);
}

