/*
 * GdkWindowHints.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkWindowHints extends Plumbing
{
    private GdkWindowHints() {}

    static final int POS = get_ordinal_pos();

    private static native final int get_ordinal_pos();

    static final int MIN_SIZE = get_ordinal_min_size();

    private static native final int get_ordinal_min_size();

    static final int MAX_SIZE = get_ordinal_max_size();

    private static native final int get_ordinal_max_size();

    static final int BASE_SIZE = get_ordinal_base_size();

    private static native final int get_ordinal_base_size();

    static final int ASPECT = get_ordinal_aspect();

    private static native final int get_ordinal_aspect();

    static final int RESIZE_INC = get_ordinal_resize_inc();

    private static native final int get_ordinal_resize_inc();

    static final int WIN_GRAVITY = get_ordinal_win_gravity();

    private static native final int get_ordinal_win_gravity();

    static final int USER_POS = get_ordinal_user_pos();

    private static native final int get_ordinal_user_pos();

    static final int USER_SIZE = get_ordinal_user_size();

    private static native final int get_ordinal_user_size();
}

