/*
 * GdkWindowState.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkWindowState extends Plumbing
{
    private GdkWindowState() {}

    static final int WITHDRAWN = get_ordinal_withdrawn();

    private static native final int get_ordinal_withdrawn();

    static final int ICONIFIED = get_ordinal_iconified();

    private static native final int get_ordinal_iconified();

    static final int MAXIMIZED = get_ordinal_maximized();

    private static native final int get_ordinal_maximized();

    static final int STICKY = get_ordinal_sticky();

    private static native final int get_ordinal_sticky();

    static final int FULLSCREEN = get_ordinal_fullscreen();

    private static native final int get_ordinal_fullscreen();

    static final int ABOVE = get_ordinal_above();

    private static native final int get_ordinal_above();

    static final int BELOW = get_ordinal_below();

    private static native final int get_ordinal_below();
}

