/*
 * GtkRecentChooserDialog.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Window;

final class GtkRecentChooserDialog extends Plumbing
{
    private GtkRecentChooserDialog() {}

    static final long createRecentChooserDialog(String title, Window parent, String firstButtonText) {
        long result;

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        if (firstButtonText == null) {
            throw new IllegalArgumentException("firstButtonText can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_chooser_dialog_new(title, pointerOf(parent), firstButtonText);

            return result;
        }
    }

    private static native final long gtk_recent_chooser_dialog_new(String title, long parent, String firstButtonText);
}

