/*
 * PangoStretch.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.gnome.pango.Plumbing;

final class PangoStretch extends Plumbing
{
    private PangoStretch() {}

    static final int ULTRA_CONDENSED = 0;

    static final int EXTRA_CONDENSED = 1;

    static final int CONDENSED = 2;

    static final int SEMI_CONDENSED = 3;

    static final int NORMAL = 4;

    static final int SEMI_EXPANDED = 5;

    static final int EXPANDED = 6;

    static final int EXTRA_EXPANDED = 7;

    static final int ULTRA_EXPANDED = 8;
}

