typedef unsigned int size_t;
typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef signed long long int __int64_t;
typedef unsigned long long int __uint64_t;
typedef long long int __quad_t;
typedef unsigned long long int __u_quad_t;
typedef __u_quad_t __dev_t;
typedef unsigned int __uid_t;
typedef unsigned int __gid_t;
typedef unsigned long int __ino_t;
typedef __u_quad_t __ino64_t;
typedef unsigned int __mode_t;
typedef unsigned int __nlink_t;
typedef long int __off_t;
typedef __quad_t __off64_t;
typedef int __pid_t;
typedef struct
{
  int __val[2];
} __fsid_t;
typedef long int __clock_t;
typedef unsigned long int __rlim_t;
typedef __u_quad_t __rlim64_t;
typedef unsigned int __id_t;
typedef long int __time_t;
typedef unsigned int __useconds_t;
typedef long int __suseconds_t;
typedef int __daddr_t;
typedef long int __swblk_t;
typedef int __key_t;
typedef int __clockid_t;
typedef void *__timer_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __quad_t __blkcnt64_t;
typedef unsigned long int __fsblkcnt_t;
typedef __u_quad_t __fsblkcnt64_t;
typedef unsigned long int __fsfilcnt_t;
typedef __u_quad_t __fsfilcnt64_t;
typedef int __ssize_t;
typedef __off64_t __loff_t;
typedef __quad_t *__qaddr_t;
typedef char *__caddr_t;
typedef int __intptr_t;
typedef unsigned int __socklen_t;
struct _IO_FILE;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef struct
{
  int __count;
  union
  {
    unsigned int __wch;
    char __wchb[4];
  } __value;
} __mbstate_t;
typedef struct
{
  __off_t __pos;
  __mbstate_t __state;
} _G_fpos_t;
typedef struct
{
  __off64_t __pos;
  __mbstate_t __state;
} _G_fpos64_t;
typedef int _G_int16_t;
typedef int _G_int32_t;
typedef unsigned int _G_uint16_t;
typedef unsigned int _G_uint32_t;
typedef void * __gnuc_va_list;
struct _IO_jump_t;
struct _IO_FILE;
typedef void _IO_lock_t;
struct _IO_marker
{
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
enum __codecvt_result
{
  __codecvt_ok,
  __codecvt_partial,
  __codecvt_error,
  __codecvt_noconv
};
struct _IO_FILE
{
  int _flags;
  char *_IO_read_ptr;
  char *_IO_read_end;
  char *_IO_read_base;
  char *_IO_write_base;
  char *_IO_write_ptr;
  char *_IO_write_end;
  char *_IO_buf_base;
  char *_IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _flags2;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  void *__pad3;
  void *__pad4;
  size_t __pad5;
  int _mode;
  char _unused2[15 * sizeof (int) - 4 * sizeof (void *) - sizeof (size_t)];
};
typedef struct _IO_FILE _IO_FILE;
struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_2_1_stdin_;
extern struct _IO_FILE_plus _IO_2_1_stdout_;
extern struct _IO_FILE_plus _IO_2_1_stderr_;
typedef __ssize_t __io_read_fn (void *__cookie, char *__buf, size_t __nbytes);
typedef __ssize_t __io_write_fn (void *__cookie, const char *__buf, size_t __n);
typedef int __io_seek_fn (void *__cookie, __off64_t * __pos, int __w);
typedef int __io_close_fn (void *__cookie);
extern int __underflow (_IO_FILE *);
extern int __uflow (_IO_FILE *);
extern int __overflow (_IO_FILE *, int);
extern int _IO_getc (_IO_FILE * __fp);
extern int _IO_putc (int __c, _IO_FILE * __fp);
extern int _IO_feof (_IO_FILE * __fp);
extern int _IO_ferror (_IO_FILE * __fp);
extern int _IO_peekc_locked (_IO_FILE * __fp);
extern void _IO_flockfile (_IO_FILE *);
extern void _IO_funlockfile (_IO_FILE *);
extern int _IO_ftrylockfile (_IO_FILE *);
extern int _IO_vfscanf (_IO_FILE *, const char *, __gnuc_va_list, int *);
extern int _IO_vfprintf (_IO_FILE *, const char *, __gnuc_va_list);
extern __ssize_t _IO_padn (_IO_FILE *, int, __ssize_t);
extern size_t _IO_sgetn (_IO_FILE *, void *, size_t);
extern __off64_t _IO_seekoff (_IO_FILE *, __off64_t, int, int);
extern __off64_t _IO_seekpos (_IO_FILE *, __off64_t, int);
extern void _IO_free_backup_area (_IO_FILE *);
typedef _G_fpos_t fpos_t;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stdout;
extern struct _IO_FILE *stderr;
extern int remove (const char *__filename);
extern int rename (const char *__old, const char *__new);
extern FILE *tmpfile (void);
extern char *tmpnam (char *__s);
extern char *tmpnam_r (char *__s);
extern char *tempnam (const char *__dir, const char *__pfx);
extern int fclose (FILE * __stream);
extern int fflush (FILE * __stream);
extern int fflush_unlocked (FILE * __stream);
extern FILE *fopen (const char *__filename, const char *__modes);
extern FILE *freopen (const char *__filename, const char *__modes, FILE * __stream);
extern FILE *fdopen (int __fd, const char *__modes);
extern void setbuf (FILE * __stream, char *__buf);
extern int setvbuf (FILE * __stream, char *__buf, int __modes, size_t __n);
extern void setbuffer (FILE * __stream, char *__buf, size_t __size);
extern void setlinebuf (FILE * __stream);
extern int fprintf (FILE * __stream, const char *__format, ...);
extern int printf (const char *__format, ...);
extern int sprintf (char *__s, const char *__format, ...);
extern int vfprintf (FILE * __s, const char *__format, __gnuc_va_list __arg);
extern int vprintf (const char *__format, __gnuc_va_list __arg);
extern int vsprintf (char *__s, const char *__format, __gnuc_va_list __arg);
extern int snprintf (char *__s, size_t __maxlen, const char *__format, ...);
extern int vsnprintf (char *__s, size_t __maxlen, const char *__format, __gnuc_va_list __arg);
extern int fscanf (FILE * __stream, const char *__format, ...);
extern int scanf (const char *__format, ...);
extern int sscanf (const char *__s, const char *__format, ...);
extern int fgetc (FILE * __stream);
extern int getc (FILE * __stream);
extern int getchar (void);
extern int getc_unlocked (FILE * __stream);
extern int getchar_unlocked (void);
extern int fgetc_unlocked (FILE * __stream);
extern int fputc (int __c, FILE * __stream);
extern int putc (int __c, FILE * __stream);
extern int putchar (int __c);
extern int fputc_unlocked (int __c, FILE * __stream);
extern int putc_unlocked (int __c, FILE * __stream);
extern int putchar_unlocked (int __c);
extern int getw (FILE * __stream);
extern int putw (int __w, FILE * __stream);
extern char *fgets (char *__s, int __n, FILE * __stream);
extern char *gets (char *__s);
extern int fputs (const char *__s, FILE * __stream);
extern int puts (const char *__s);
extern int ungetc (int __c, FILE * __stream);
extern size_t fread (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t fwrite (const void *__ptr, size_t __size, size_t __n, FILE * __s);
extern size_t fread_unlocked (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t fwrite_unlocked (const void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern int fseek (FILE * __stream, long int __off, int __whence);
extern long int ftell (FILE * __stream);
extern void rewind (FILE * __stream);
extern int fseeko (FILE * __stream, __off_t __off, int __whence);
extern __off_t ftello (FILE * __stream);
extern int fgetpos (FILE * __stream, fpos_t * __pos);
extern int fsetpos (FILE * __stream, const fpos_t * __pos);
extern void clearerr (FILE * __stream);
extern int feof (FILE * __stream);
extern int ferror (FILE * __stream);
extern void clearerr_unlocked (FILE * __stream);
extern int feof_unlocked (FILE * __stream);
extern int ferror_unlocked (FILE * __stream);
extern void perror (const char *__s);
extern int sys_nerr;
extern const char *const sys_errlist[];
extern int fileno (FILE * __stream);
extern int fileno_unlocked (FILE * __stream);
extern FILE *popen (const char *__command, const char *__modes);
extern int pclose (FILE * __stream);
extern char *ctermid (char *__s);
extern void flockfile (FILE * __stream);
extern int ftrylockfile (FILE * __stream);
extern void funlockfile (FILE * __stream);
extern int __sprintf_chk (char *__s, int __flag, size_t __slen, const char *__format, ...);
extern int __vsprintf_chk (char *__s, int __flag, size_t __slen, const char *__format, __gnuc_va_list __ap);
extern int __snprintf_chk (char *__s, size_t __n, int __flag, size_t __slen, const char *__format, ...);
extern int __vsnprintf_chk (char *__s, size_t __n, int __flag, size_t __slen, const char *__format, __gnuc_va_list __ap);
extern int __fprintf_chk (FILE * __stream, int __flag, const char *__format, ...);
extern int __printf_chk (int __flag, const char *__format, ...);
extern int __vfprintf_chk (FILE * __stream, int __flag, const char *__format, __gnuc_va_list __ap);
extern int __vprintf_chk (int __flag, const char *__format, __gnuc_va_list __ap);
extern char *__gets_chk (char *__str, size_t);
extern char *__gets_warn (char *__str);
extern char *__fgets_chk (char *__s, size_t __size, int __n, FILE * __stream);
extern char *__fgets_alias (char *__s, int __n, FILE * __stream);
extern char *__fgets_chk_warn (char *__s, size_t __size, int __n, FILE * __stream);
extern size_t __fread_chk (void *__ptr, size_t __ptrlen, size_t __size, size_t __n, FILE * __stream);
extern size_t __fread_alias (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t __fread_chk_warn (void *__ptr, size_t __ptrlen, size_t __size, size_t __n, FILE * __stream);
extern size_t __fread_unlocked_chk (void *__ptr, size_t __ptrlen, size_t __size, size_t __n, FILE * __stream);
extern size_t __fread_unlocked_alias (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t __fread_unlocked_chk_warn (void *__ptr, size_t __ptrlen, size_t __size, size_t __n, FILE * __stream);
typedef __gnuc_va_list va_list;
typedef int jint;
typedef long long jlong;
typedef signed char jbyte;
typedef unsigned char jboolean;
typedef unsigned short jchar;
typedef short jshort;
typedef float jfloat;
typedef double jdouble;
typedef jint jsize;
struct _jobject;
typedef struct _jobject *jobject;
typedef jobject jclass;
typedef jobject jthrowable;
typedef jobject jstring;
typedef jobject jarray;
typedef jarray jbooleanArray;
typedef jarray jbyteArray;
typedef jarray jcharArray;
typedef jarray jshortArray;
typedef jarray jintArray;
typedef jarray jlongArray;
typedef jarray jfloatArray;
typedef jarray jdoubleArray;
typedef jarray jobjectArray;
typedef jobject jweak;
typedef union jvalue
{
  jboolean z;
  jbyte b;
  jchar c;
  jshort s;
  jint i;
  jlong j;
  jfloat f;
  jdouble d;
  jobject l;
} jvalue;
struct _jfieldID;
typedef struct _jfieldID *jfieldID;
struct _jmethodID;
typedef struct _jmethodID *jmethodID;
typedef enum _jobjectType
{
  JNIInvalidRefType = 0,
  JNILocalRefType = 1,
  JNIGlobalRefType = 2,
  JNIWeakGlobalRefType = 3
} jobjectRefType;
typedef struct
{
  char *name;
  char *signature;
  void *fnPtr;
} JNINativeMethod;
struct JNINativeInterface_;
struct JNIEnv_;
typedef const struct JNINativeInterface_ *JNIEnv;
struct JNIInvokeInterface_;
struct JavaVM_;
typedef const struct JNIInvokeInterface_ *JavaVM;
struct JNINativeInterface_
{
  void *reserved0;
  void *reserved1;
  void *reserved2;
  void *reserved3;
    jint (*GetVersion) (JNIEnv * env);
    jclass (*DefineClass) (JNIEnv * env, const char *name, jobject loader, const jbyte * buf, jsize len);
    jclass (*FindClass) (JNIEnv * env, const char *name);
    jmethodID (*FromReflectedMethod) (JNIEnv * env, jobject method);
    jfieldID (*FromReflectedField) (JNIEnv * env, jobject field);
    jobject (*ToReflectedMethod) (JNIEnv * env, jclass cls, jmethodID methodID, jboolean isStatic);
    jclass (*GetSuperclass) (JNIEnv * env, jclass sub);
    jboolean (*IsAssignableFrom) (JNIEnv * env, jclass sub, jclass sup);
    jobject (*ToReflectedField) (JNIEnv * env, jclass cls, jfieldID fieldID, jboolean isStatic);
    jint (*Throw) (JNIEnv * env, jthrowable obj);
    jint (*ThrowNew) (JNIEnv * env, jclass clazz, const char *msg);
    jthrowable (*ExceptionOccurred) (JNIEnv * env);
  void (*ExceptionDescribe) (JNIEnv * env);
  void (*ExceptionClear) (JNIEnv * env);
  void (*FatalError) (JNIEnv * env, const char *msg);
    jint (*PushLocalFrame) (JNIEnv * env, jint capacity);
    jobject (*PopLocalFrame) (JNIEnv * env, jobject result);
    jobject (*NewGlobalRef) (JNIEnv * env, jobject lobj);
  void (*DeleteGlobalRef) (JNIEnv * env, jobject gref);
  void (*DeleteLocalRef) (JNIEnv * env, jobject obj);
    jboolean (*IsSameObject) (JNIEnv * env, jobject obj1, jobject obj2);
    jobject (*NewLocalRef) (JNIEnv * env, jobject ref);
    jint (*EnsureLocalCapacity) (JNIEnv * env, jint capacity);
    jobject (*AllocObject) (JNIEnv * env, jclass clazz);
    jobject (*NewObject) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jobject (*NewObjectV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jobject (*NewObjectA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jclass (*GetObjectClass) (JNIEnv * env, jobject obj);
    jboolean (*IsInstanceOf) (JNIEnv * env, jobject obj, jclass clazz);
    jmethodID (*GetMethodID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*CallObjectMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jobject (*CallObjectMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jobject (*CallObjectMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jboolean (*CallBooleanMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jboolean (*CallBooleanMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jboolean (*CallBooleanMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jbyte (*CallByteMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jbyte (*CallByteMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jbyte (*CallByteMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jchar (*CallCharMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jchar (*CallCharMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jchar (*CallCharMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jshort (*CallShortMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jshort (*CallShortMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jshort (*CallShortMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jint (*CallIntMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jint (*CallIntMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jint (*CallIntMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jlong (*CallLongMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jlong (*CallLongMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jlong (*CallLongMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jfloat (*CallFloatMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jfloat (*CallFloatMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jfloat (*CallFloatMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jdouble (*CallDoubleMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jdouble (*CallDoubleMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jdouble (*CallDoubleMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
  void (*CallVoidMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
  void (*CallVoidMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
  void (*CallVoidMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jobject (*CallNonvirtualObjectMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jobject (*CallNonvirtualObjectMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jobject (*CallNonvirtualObjectMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jboolean (*CallNonvirtualBooleanMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jboolean (*CallNonvirtualBooleanMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jboolean (*CallNonvirtualBooleanMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jbyte (*CallNonvirtualByteMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jbyte (*CallNonvirtualByteMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jbyte (*CallNonvirtualByteMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jchar (*CallNonvirtualCharMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jchar (*CallNonvirtualCharMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jchar (*CallNonvirtualCharMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jshort (*CallNonvirtualShortMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jshort (*CallNonvirtualShortMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jshort (*CallNonvirtualShortMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jint (*CallNonvirtualIntMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jint (*CallNonvirtualIntMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jint (*CallNonvirtualIntMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jlong (*CallNonvirtualLongMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jlong (*CallNonvirtualLongMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jlong (*CallNonvirtualLongMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jfloat (*CallNonvirtualFloatMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jfloat (*CallNonvirtualFloatMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jfloat (*CallNonvirtualFloatMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jdouble (*CallNonvirtualDoubleMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jdouble (*CallNonvirtualDoubleMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jdouble (*CallNonvirtualDoubleMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
  void (*CallNonvirtualVoidMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
  void (*CallNonvirtualVoidMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
  void (*CallNonvirtualVoidMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jfieldID (*GetFieldID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*GetObjectField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jboolean (*GetBooleanField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jbyte (*GetByteField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jchar (*GetCharField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jshort (*GetShortField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jint (*GetIntField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jlong (*GetLongField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jfloat (*GetFloatField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jdouble (*GetDoubleField) (JNIEnv * env, jobject obj, jfieldID fieldID);
  void (*SetObjectField) (JNIEnv * env, jobject obj, jfieldID fieldID, jobject val);
  void (*SetBooleanField) (JNIEnv * env, jobject obj, jfieldID fieldID, jboolean val);
  void (*SetByteField) (JNIEnv * env, jobject obj, jfieldID fieldID, jbyte val);
  void (*SetCharField) (JNIEnv * env, jobject obj, jfieldID fieldID, jchar val);
  void (*SetShortField) (JNIEnv * env, jobject obj, jfieldID fieldID, jshort val);
  void (*SetIntField) (JNIEnv * env, jobject obj, jfieldID fieldID, jint val);
  void (*SetLongField) (JNIEnv * env, jobject obj, jfieldID fieldID, jlong val);
  void (*SetFloatField) (JNIEnv * env, jobject obj, jfieldID fieldID, jfloat val);
  void (*SetDoubleField) (JNIEnv * env, jobject obj, jfieldID fieldID, jdouble val);
    jmethodID (*GetStaticMethodID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*CallStaticObjectMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jobject (*CallStaticObjectMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jobject (*CallStaticObjectMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jboolean (*CallStaticBooleanMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jboolean (*CallStaticBooleanMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jboolean (*CallStaticBooleanMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jbyte (*CallStaticByteMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jbyte (*CallStaticByteMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jbyte (*CallStaticByteMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jchar (*CallStaticCharMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jchar (*CallStaticCharMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jchar (*CallStaticCharMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jshort (*CallStaticShortMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jshort (*CallStaticShortMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jshort (*CallStaticShortMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jint (*CallStaticIntMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jint (*CallStaticIntMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jint (*CallStaticIntMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jlong (*CallStaticLongMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jlong (*CallStaticLongMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jlong (*CallStaticLongMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jfloat (*CallStaticFloatMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jfloat (*CallStaticFloatMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jfloat (*CallStaticFloatMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jdouble (*CallStaticDoubleMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jdouble (*CallStaticDoubleMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jdouble (*CallStaticDoubleMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
  void (*CallStaticVoidMethod) (JNIEnv * env, jclass cls, jmethodID methodID, ...);
  void (*CallStaticVoidMethodV) (JNIEnv * env, jclass cls, jmethodID methodID, va_list args);
  void (*CallStaticVoidMethodA) (JNIEnv * env, jclass cls, jmethodID methodID, const jvalue * args);
    jfieldID (*GetStaticFieldID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*GetStaticObjectField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jboolean (*GetStaticBooleanField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jbyte (*GetStaticByteField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jchar (*GetStaticCharField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jshort (*GetStaticShortField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jint (*GetStaticIntField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jlong (*GetStaticLongField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jfloat (*GetStaticFloatField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jdouble (*GetStaticDoubleField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
  void (*SetStaticObjectField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jobject value);
  void (*SetStaticBooleanField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jboolean value);
  void (*SetStaticByteField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jbyte value);
  void (*SetStaticCharField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jchar value);
  void (*SetStaticShortField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jshort value);
  void (*SetStaticIntField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jint value);
  void (*SetStaticLongField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jlong value);
  void (*SetStaticFloatField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jfloat value);
  void (*SetStaticDoubleField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jdouble value);
    jstring (*NewString) (JNIEnv * env, const jchar * unicode, jsize len);
    jsize (*GetStringLength) (JNIEnv * env, jstring str);
  const jchar *(*GetStringChars) (JNIEnv * env, jstring str, jboolean * isCopy);
  void (*ReleaseStringChars) (JNIEnv * env, jstring str, const jchar * chars);
    jstring (*NewStringUTF) (JNIEnv * env, const char *utf);
    jsize (*GetStringUTFLength) (JNIEnv * env, jstring str);
  const char *(*GetStringUTFChars) (JNIEnv * env, jstring str, jboolean * isCopy);
  void (*ReleaseStringUTFChars) (JNIEnv * env, jstring str, const char *chars);
    jsize (*GetArrayLength) (JNIEnv * env, jarray array);
    jobjectArray (*NewObjectArray) (JNIEnv * env, jsize len, jclass clazz, jobject init);
    jobject (*GetObjectArrayElement) (JNIEnv * env, jobjectArray array, jsize index);
  void (*SetObjectArrayElement) (JNIEnv * env, jobjectArray array, jsize index, jobject val);
    jbooleanArray (*NewBooleanArray) (JNIEnv * env, jsize len);
    jbyteArray (*NewByteArray) (JNIEnv * env, jsize len);
    jcharArray (*NewCharArray) (JNIEnv * env, jsize len);
    jshortArray (*NewShortArray) (JNIEnv * env, jsize len);
    jintArray (*NewIntArray) (JNIEnv * env, jsize len);
    jlongArray (*NewLongArray) (JNIEnv * env, jsize len);
    jfloatArray (*NewFloatArray) (JNIEnv * env, jsize len);
    jdoubleArray (*NewDoubleArray) (JNIEnv * env, jsize len);
  jboolean *(*GetBooleanArrayElements) (JNIEnv * env, jbooleanArray array, jboolean * isCopy);
  jbyte *(*GetByteArrayElements) (JNIEnv * env, jbyteArray array, jboolean * isCopy);
  jchar *(*GetCharArrayElements) (JNIEnv * env, jcharArray array, jboolean * isCopy);
  jshort *(*GetShortArrayElements) (JNIEnv * env, jshortArray array, jboolean * isCopy);
  jint *(*GetIntArrayElements) (JNIEnv * env, jintArray array, jboolean * isCopy);
  jlong *(*GetLongArrayElements) (JNIEnv * env, jlongArray array, jboolean * isCopy);
  jfloat *(*GetFloatArrayElements) (JNIEnv * env, jfloatArray array, jboolean * isCopy);
  jdouble *(*GetDoubleArrayElements) (JNIEnv * env, jdoubleArray array, jboolean * isCopy);
  void (*ReleaseBooleanArrayElements) (JNIEnv * env, jbooleanArray array, jboolean * elems, jint mode);
  void (*ReleaseByteArrayElements) (JNIEnv * env, jbyteArray array, jbyte * elems, jint mode);
  void (*ReleaseCharArrayElements) (JNIEnv * env, jcharArray array, jchar * elems, jint mode);
  void (*ReleaseShortArrayElements) (JNIEnv * env, jshortArray array, jshort * elems, jint mode);
  void (*ReleaseIntArrayElements) (JNIEnv * env, jintArray array, jint * elems, jint mode);
  void (*ReleaseLongArrayElements) (JNIEnv * env, jlongArray array, jlong * elems, jint mode);
  void (*ReleaseFloatArrayElements) (JNIEnv * env, jfloatArray array, jfloat * elems, jint mode);
  void (*ReleaseDoubleArrayElements) (JNIEnv * env, jdoubleArray array, jdouble * elems, jint mode);
  void (*GetBooleanArrayRegion) (JNIEnv * env, jbooleanArray array, jsize start, jsize l, jboolean * buf);
  void (*GetByteArrayRegion) (JNIEnv * env, jbyteArray array, jsize start, jsize len, jbyte * buf);
  void (*GetCharArrayRegion) (JNIEnv * env, jcharArray array, jsize start, jsize len, jchar * buf);
  void (*GetShortArrayRegion) (JNIEnv * env, jshortArray array, jsize start, jsize len, jshort * buf);
  void (*GetIntArrayRegion) (JNIEnv * env, jintArray array, jsize start, jsize len, jint * buf);
  void (*GetLongArrayRegion) (JNIEnv * env, jlongArray array, jsize start, jsize len, jlong * buf);
  void (*GetFloatArrayRegion) (JNIEnv * env, jfloatArray array, jsize start, jsize len, jfloat * buf);
  void (*GetDoubleArrayRegion) (JNIEnv * env, jdoubleArray array, jsize start, jsize len, jdouble * buf);
  void (*SetBooleanArrayRegion) (JNIEnv * env, jbooleanArray array, jsize start, jsize l, const jboolean * buf);
  void (*SetByteArrayRegion) (JNIEnv * env, jbyteArray array, jsize start, jsize len, const jbyte * buf);
  void (*SetCharArrayRegion) (JNIEnv * env, jcharArray array, jsize start, jsize len, const jchar * buf);
  void (*SetShortArrayRegion) (JNIEnv * env, jshortArray array, jsize start, jsize len, const jshort * buf);
  void (*SetIntArrayRegion) (JNIEnv * env, jintArray array, jsize start, jsize len, const jint * buf);
  void (*SetLongArrayRegion) (JNIEnv * env, jlongArray array, jsize start, jsize len, const jlong * buf);
  void (*SetFloatArrayRegion) (JNIEnv * env, jfloatArray array, jsize start, jsize len, const jfloat * buf);
  void (*SetDoubleArrayRegion) (JNIEnv * env, jdoubleArray array, jsize start, jsize len, const jdouble * buf);
    jint (*RegisterNatives) (JNIEnv * env, jclass clazz, const JNINativeMethod * methods, jint nMethods);
    jint (*UnregisterNatives) (JNIEnv * env, jclass clazz);
    jint (*MonitorEnter) (JNIEnv * env, jobject obj);
    jint (*MonitorExit) (JNIEnv * env, jobject obj);
    jint (*GetJavaVM) (JNIEnv * env, JavaVM ** vm);
  void (*GetStringRegion) (JNIEnv * env, jstring str, jsize start, jsize len, jchar * buf);
  void (*GetStringUTFRegion) (JNIEnv * env, jstring str, jsize start, jsize len, char *buf);
  void *(*GetPrimitiveArrayCritical) (JNIEnv * env, jarray array, jboolean * isCopy);
  void (*ReleasePrimitiveArrayCritical) (JNIEnv * env, jarray array, void *carray, jint mode);
  const jchar *(*GetStringCritical) (JNIEnv * env, jstring string, jboolean * isCopy);
  void (*ReleaseStringCritical) (JNIEnv * env, jstring string, const jchar * cstring);
    jweak (*NewWeakGlobalRef) (JNIEnv * env, jobject obj);
  void (*DeleteWeakGlobalRef) (JNIEnv * env, jweak ref);
    jboolean (*ExceptionCheck) (JNIEnv * env);
    jobject (*NewDirectByteBuffer) (JNIEnv * env, void *address, jlong capacity);
  void *(*GetDirectBufferAddress) (JNIEnv * env, jobject buf);
    jlong (*GetDirectBufferCapacity) (JNIEnv * env, jobject buf);
    jobjectRefType (*GetObjectRefType) (JNIEnv * env, jobject obj);
};
struct JNIEnv_
{
  const struct JNINativeInterface_ *functions;
};
typedef struct JavaVMOption
{
  char *optionString;
  void *extraInfo;
} JavaVMOption;
typedef struct JavaVMInitArgs
{
  jint version;
  jint nOptions;
  JavaVMOption *options;
  jboolean ignoreUnrecognized;
} JavaVMInitArgs;
typedef struct JavaVMAttachArgs
{
  jint version;
  char *name;
  jobject group;
} JavaVMAttachArgs;
struct JNIInvokeInterface_
{
  void *reserved0;
  void *reserved1;
  void *reserved2;
    jint (*DestroyJavaVM) (JavaVM * vm);
    jint (*AttachCurrentThread) (JavaVM * vm, void **penv, void *args);
    jint (*DetachCurrentThread) (JavaVM * vm);
    jint (*GetEnv) (JavaVM * vm, void **penv, jint version);
    jint (*AttachCurrentThreadAsDaemon) (JavaVM * vm, void **penv, void *args);
};
struct JavaVM_
{
  const struct JNIInvokeInterface_ *functions;
};
jint JNI_GetDefaultJavaVMInitArgs (void *args);
jint JNI_CreateJavaVM (JavaVM ** pvm, void **penv, void *args);
jint JNI_GetCreatedJavaVMs (JavaVM **, jsize, jsize *);
jint JNI_OnLoad (JavaVM * vm, void *reserved);
void JNI_OnUnload (JavaVM * vm, void *reserved);
void mut_ThrowByName(JNIEnv *env, const char *name, const char *msg);
jbooleanArray mut_jbooleanArray(JNIEnv * env);
jbyteArray mut_jbyteArray(JNIEnv * env);
jcharArray mut_jcharArray(JNIEnv * env);
jshortArray mut_jshortArray(JNIEnv * env);
jintArray mut_jintArray(JNIEnv * env);
jlongArray mut_jlongArray(JNIEnv * env);
jfloatArray mut_jfloatArray(JNIEnv * env);
jdoubleArray mut_jdoubleArray(JNIEnv * env);
extern int IS_JNI_1_2;
void throwOutOfMemory (JNIEnv * env);
typedef __ssize_t ssize_t;
typedef __gid_t gid_t;
typedef __uid_t uid_t;
typedef __off_t off_t;
typedef __useconds_t useconds_t;
typedef __pid_t pid_t;
typedef __intptr_t intptr_t;
typedef __socklen_t socklen_t;
extern int access (const char *__name, int __type);
extern __off_t lseek (int __fd, __off_t __offset, int __whence);
extern int close (int __fd);
extern ssize_t read (int __fd, void *__buf, size_t __nbytes);
extern ssize_t write (int __fd, const void *__buf, size_t __n);
extern int pipe (int __pipedes[2]);
extern unsigned int alarm (unsigned int __seconds);
extern unsigned int sleep (unsigned int __seconds);
extern __useconds_t ualarm (__useconds_t __value, __useconds_t __interval);
extern int usleep (__useconds_t __useconds);
extern int pause (void);
extern int chown (const char *__file, __uid_t __owner, __gid_t __group);
extern int fchown (int __fd, __uid_t __owner, __gid_t __group);
extern int lchown (const char *__file, __uid_t __owner, __gid_t __group);
extern int chdir (const char *__path);
extern int fchdir (int __fd);
extern char *getcwd (char *__buf, size_t __size);
extern char *getwd (char *__buf);
extern int dup (int __fd);
extern int dup2 (int __fd, int __fd2);
extern char **__environ;
extern int execve (const char *__path, char *const __argv[], char *const __envp[]);
extern int execv (const char *__path, char *const __argv[]);
extern int execle (const char *__path, const char *__arg, ...);
extern int execl (const char *__path, const char *__arg, ...);
extern int execvp (const char *__file, char *const __argv[]);
extern int execlp (const char *__file, const char *__arg, ...);
extern int nice (int __inc);
extern void _exit (int __status);
enum
{
  _PC_LINK_MAX,
  _PC_MAX_CANON,
  _PC_MAX_INPUT,
  _PC_NAME_MAX,
  _PC_PATH_MAX,
  _PC_PIPE_BUF,
  _PC_CHOWN_RESTRICTED,
  _PC_NO_TRUNC,
  _PC_VDISABLE,
  _PC_SYNC_IO,
  _PC_ASYNC_IO,
  _PC_PRIO_IO,
  _PC_SOCK_MAXBUF,
  _PC_FILESIZEBITS,
  _PC_REC_INCR_XFER_SIZE,
  _PC_REC_MAX_XFER_SIZE,
  _PC_REC_MIN_XFER_SIZE,
  _PC_REC_XFER_ALIGN,
  _PC_ALLOC_SIZE_MIN,
  _PC_SYMLINK_MAX,
  _PC_2_SYMLINKS
};
enum
{
  _SC_ARG_MAX,
  _SC_CHILD_MAX,
  _SC_CLK_TCK,
  _SC_NGROUPS_MAX,
  _SC_OPEN_MAX,
  _SC_STREAM_MAX,
  _SC_TZNAME_MAX,
  _SC_JOB_CONTROL,
  _SC_SAVED_IDS,
  _SC_REALTIME_SIGNALS,
  _SC_PRIORITY_SCHEDULING,
  _SC_TIMERS,
  _SC_ASYNCHRONOUS_IO,
  _SC_PRIORITIZED_IO,
  _SC_SYNCHRONIZED_IO,
  _SC_FSYNC,
  _SC_MAPPED_FILES,
  _SC_MEMLOCK,
  _SC_MEMLOCK_RANGE,
  _SC_MEMORY_PROTECTION,
  _SC_MESSAGE_PASSING,
  _SC_SEMAPHORES,
  _SC_SHARED_MEMORY_OBJECTS,
  _SC_AIO_LISTIO_MAX,
  _SC_AIO_MAX,
  _SC_AIO_PRIO_DELTA_MAX,
  _SC_DELAYTIMER_MAX,
  _SC_MQ_OPEN_MAX,
  _SC_MQ_PRIO_MAX,
  _SC_VERSION,
  _SC_PAGESIZE,
  _SC_RTSIG_MAX,
  _SC_SEM_NSEMS_MAX,
  _SC_SEM_VALUE_MAX,
  _SC_SIGQUEUE_MAX,
  _SC_TIMER_MAX,
  _SC_BC_BASE_MAX,
  _SC_BC_DIM_MAX,
  _SC_BC_SCALE_MAX,
  _SC_BC_STRING_MAX,
  _SC_COLL_WEIGHTS_MAX,
  _SC_EQUIV_CLASS_MAX,
  _SC_EXPR_NEST_MAX,
  _SC_LINE_MAX,
  _SC_RE_DUP_MAX,
  _SC_CHARCLASS_NAME_MAX,
  _SC_2_VERSION,
  _SC_2_C_BIND,
  _SC_2_C_DEV,
  _SC_2_FORT_DEV,
  _SC_2_FORT_RUN,
  _SC_2_SW_DEV,
  _SC_2_LOCALEDEF,
  _SC_PII,
  _SC_PII_XTI,
  _SC_PII_SOCKET,
  _SC_PII_INTERNET,
  _SC_PII_OSI,
  _SC_POLL,
  _SC_SELECT,
  _SC_UIO_MAXIOV,
  _SC_IOV_MAX = _SC_UIO_MAXIOV,
  _SC_PII_INTERNET_STREAM,
  _SC_PII_INTERNET_DGRAM,
  _SC_PII_OSI_COTS,
  _SC_PII_OSI_CLTS,
  _SC_PII_OSI_M,
  _SC_T_IOV_MAX,
  _SC_THREADS,
  _SC_THREAD_SAFE_FUNCTIONS,
  _SC_GETGR_R_SIZE_MAX,
  _SC_GETPW_R_SIZE_MAX,
  _SC_LOGIN_NAME_MAX,
  _SC_TTY_NAME_MAX,
  _SC_THREAD_DESTRUCTOR_ITERATIONS,
  _SC_THREAD_KEYS_MAX,
  _SC_THREAD_STACK_MIN,
  _SC_THREAD_THREADS_MAX,
  _SC_THREAD_ATTR_STACKADDR,
  _SC_THREAD_ATTR_STACKSIZE,
  _SC_THREAD_PRIORITY_SCHEDULING,
  _SC_THREAD_PRIO_INHERIT,
  _SC_THREAD_PRIO_PROTECT,
  _SC_THREAD_PROCESS_SHARED,
  _SC_NPROCESSORS_CONF,
  _SC_NPROCESSORS_ONLN,
  _SC_PHYS_PAGES,
  _SC_AVPHYS_PAGES,
  _SC_ATEXIT_MAX,
  _SC_PASS_MAX,
  _SC_XOPEN_VERSION,
  _SC_XOPEN_XCU_VERSION,
  _SC_XOPEN_UNIX,
  _SC_XOPEN_CRYPT,
  _SC_XOPEN_ENH_I18N,
  _SC_XOPEN_SHM,
  _SC_2_CHAR_TERM,
  _SC_2_C_VERSION,
  _SC_2_UPE,
  _SC_XOPEN_XPG2,
  _SC_XOPEN_XPG3,
  _SC_XOPEN_XPG4,
  _SC_CHAR_BIT,
  _SC_CHAR_MAX,
  _SC_CHAR_MIN,
  _SC_INT_MAX,
  _SC_INT_MIN,
  _SC_LONG_BIT,
  _SC_WORD_BIT,
  _SC_MB_LEN_MAX,
  _SC_NZERO,
  _SC_SSIZE_MAX,
  _SC_SCHAR_MAX,
  _SC_SCHAR_MIN,
  _SC_SHRT_MAX,
  _SC_SHRT_MIN,
  _SC_UCHAR_MAX,
  _SC_UINT_MAX,
  _SC_ULONG_MAX,
  _SC_USHRT_MAX,
  _SC_NL_ARGMAX,
  _SC_NL_LANGMAX,
  _SC_NL_MSGMAX,
  _SC_NL_NMAX,
  _SC_NL_SETMAX,
  _SC_NL_TEXTMAX,
  _SC_XBS5_ILP32_OFF32,
  _SC_XBS5_ILP32_OFFBIG,
  _SC_XBS5_LP64_OFF64,
  _SC_XBS5_LPBIG_OFFBIG,
  _SC_XOPEN_LEGACY,
  _SC_XOPEN_REALTIME,
  _SC_XOPEN_REALTIME_THREADS,
  _SC_ADVISORY_INFO,
  _SC_BARRIERS,
  _SC_BASE,
  _SC_C_LANG_SUPPORT,
  _SC_C_LANG_SUPPORT_R,
  _SC_CLOCK_SELECTION,
  _SC_CPUTIME,
  _SC_THREAD_CPUTIME,
  _SC_DEVICE_IO,
  _SC_DEVICE_SPECIFIC,
  _SC_DEVICE_SPECIFIC_R,
  _SC_FD_MGMT,
  _SC_FIFO,
  _SC_PIPE,
  _SC_FILE_ATTRIBUTES,
  _SC_FILE_LOCKING,
  _SC_FILE_SYSTEM,
  _SC_MONOTONIC_CLOCK,
  _SC_MULTI_PROCESS,
  _SC_SINGLE_PROCESS,
  _SC_NETWORKING,
  _SC_READER_WRITER_LOCKS,
  _SC_SPIN_LOCKS,
  _SC_REGEXP,
  _SC_REGEX_VERSION,
  _SC_SHELL,
  _SC_SIGNALS,
  _SC_SPAWN,
  _SC_SPORADIC_SERVER,
  _SC_THREAD_SPORADIC_SERVER,
  _SC_SYSTEM_DATABASE,
  _SC_SYSTEM_DATABASE_R,
  _SC_TIMEOUTS,
  _SC_TYPED_MEMORY_OBJECTS,
  _SC_USER_GROUPS,
  _SC_USER_GROUPS_R,
  _SC_2_PBS,
  _SC_2_PBS_ACCOUNTING,
  _SC_2_PBS_LOCATE,
  _SC_2_PBS_MESSAGE,
  _SC_2_PBS_TRACK,
  _SC_SYMLOOP_MAX,
  _SC_STREAMS,
  _SC_2_PBS_CHECKPOINT,
  _SC_V6_ILP32_OFF32,
  _SC_V6_ILP32_OFFBIG,
  _SC_V6_LP64_OFF64,
  _SC_V6_LPBIG_OFFBIG,
  _SC_HOST_NAME_MAX,
  _SC_TRACE,
  _SC_TRACE_EVENT_FILTER,
  _SC_TRACE_INHERIT,
  _SC_TRACE_LOG,
  _SC_LEVEL1_ICACHE_SIZE,
  _SC_LEVEL1_ICACHE_ASSOC,
  _SC_LEVEL1_ICACHE_LINESIZE,
  _SC_LEVEL1_DCACHE_SIZE,
  _SC_LEVEL1_DCACHE_ASSOC,
  _SC_LEVEL1_DCACHE_LINESIZE,
  _SC_LEVEL2_CACHE_SIZE,
  _SC_LEVEL2_CACHE_ASSOC,
  _SC_LEVEL2_CACHE_LINESIZE,
  _SC_LEVEL3_CACHE_SIZE,
  _SC_LEVEL3_CACHE_ASSOC,
  _SC_LEVEL3_CACHE_LINESIZE,
  _SC_LEVEL4_CACHE_SIZE,
  _SC_LEVEL4_CACHE_ASSOC,
  _SC_LEVEL4_CACHE_LINESIZE,
  _SC_IPV6 = _SC_LEVEL1_ICACHE_SIZE + 50,
  _SC_RAW_SOCKETS
};
enum
{
  _CS_PATH,
  _CS_V6_WIDTH_RESTRICTED_ENVS,
  _CS_GNU_LIBC_VERSION,
  _CS_GNU_LIBPTHREAD_VERSION,
  _CS_LFS_CFLAGS = 1000,
  _CS_LFS_LDFLAGS,
  _CS_LFS_LIBS,
  _CS_LFS_LINTFLAGS,
  _CS_LFS64_CFLAGS,
  _CS_LFS64_LDFLAGS,
  _CS_LFS64_LIBS,
  _CS_LFS64_LINTFLAGS,
  _CS_XBS5_ILP32_OFF32_CFLAGS = 1100,
  _CS_XBS5_ILP32_OFF32_LDFLAGS,
  _CS_XBS5_ILP32_OFF32_LIBS,
  _CS_XBS5_ILP32_OFF32_LINTFLAGS,
  _CS_XBS5_ILP32_OFFBIG_CFLAGS,
  _CS_XBS5_ILP32_OFFBIG_LDFLAGS,
  _CS_XBS5_ILP32_OFFBIG_LIBS,
  _CS_XBS5_ILP32_OFFBIG_LINTFLAGS,
  _CS_XBS5_LP64_OFF64_CFLAGS,
  _CS_XBS5_LP64_OFF64_LDFLAGS,
  _CS_XBS5_LP64_OFF64_LIBS,
  _CS_XBS5_LP64_OFF64_LINTFLAGS,
  _CS_XBS5_LPBIG_OFFBIG_CFLAGS,
  _CS_XBS5_LPBIG_OFFBIG_LDFLAGS,
  _CS_XBS5_LPBIG_OFFBIG_LIBS,
  _CS_XBS5_LPBIG_OFFBIG_LINTFLAGS,
  _CS_POSIX_V6_ILP32_OFF32_CFLAGS,
  _CS_POSIX_V6_ILP32_OFF32_LDFLAGS,
  _CS_POSIX_V6_ILP32_OFF32_LIBS,
  _CS_POSIX_V6_ILP32_OFF32_LINTFLAGS,
  _CS_POSIX_V6_ILP32_OFFBIG_CFLAGS,
  _CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS,
  _CS_POSIX_V6_ILP32_OFFBIG_LIBS,
  _CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS,
  _CS_POSIX_V6_LP64_OFF64_CFLAGS,
  _CS_POSIX_V6_LP64_OFF64_LDFLAGS,
  _CS_POSIX_V6_LP64_OFF64_LIBS,
  _CS_POSIX_V6_LP64_OFF64_LINTFLAGS,
  _CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS,
  _CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS,
  _CS_POSIX_V6_LPBIG_OFFBIG_LIBS,
  _CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS
};
extern long int pathconf (const char *__path, int __name);
extern long int fpathconf (int __fd, int __name);
extern long int sysconf (int __name);
extern size_t confstr (int __name, char *__buf, size_t __len);
extern __pid_t getpid (void);
extern __pid_t getppid (void);
extern __pid_t getpgrp (void);
extern __pid_t __getpgid (__pid_t __pid);
extern int setpgid (__pid_t __pid, __pid_t __pgid);
extern int setpgrp (void);
extern __pid_t setsid (void);
extern __uid_t getuid (void);
extern __uid_t geteuid (void);
extern __gid_t getgid (void);
extern __gid_t getegid (void);
extern int getgroups (int __size, __gid_t __list[]);
extern int setuid (__uid_t __uid);
extern int setreuid (__uid_t __ruid, __uid_t __euid);
extern int seteuid (__uid_t __uid);
extern int setgid (__gid_t __gid);
extern int setregid (__gid_t __rgid, __gid_t __egid);
extern int setegid (__gid_t __gid);
extern __pid_t fork (void);
extern __pid_t vfork (void);
extern char *ttyname (int __fd);
extern int ttyname_r (int __fd, char *__buf, size_t __buflen);
extern int isatty (int __fd);
extern int ttyslot (void);
extern int link (const char *__from, const char *__to);
extern int symlink (const char *__from, const char *__to);
extern ssize_t readlink (const char *__path, char *__buf, size_t __len);
extern int unlink (const char *__name);
extern int rmdir (const char *__path);
extern __pid_t tcgetpgrp (int __fd);
extern int tcsetpgrp (int __fd, __pid_t __pgrp_id);
extern char *getlogin (void);
extern int getlogin_r (char *__name, size_t __name_len);
extern int setlogin (const char *__name);
extern char *optarg;
extern int optind;
extern int opterr;
extern int optopt;
extern int getopt (int ___argc, char *const *___argv, const char *__shortopts);
extern int gethostname (char *__name, size_t __len);
extern int sethostname (const char *__name, size_t __len);
extern int sethostid (long int __id);
extern int getdomainname (char *__name, size_t __len);
extern int setdomainname (const char *__name, size_t __len);
extern int vhangup (void);
extern int revoke (const char *__file);
extern int profil (unsigned short int *__sample_buffer, size_t __size, size_t __offset, unsigned int __scale);
extern int acct (const char *__name);
extern char *getusershell (void);
extern void endusershell (void);
extern void setusershell (void);
extern int daemon (int __nochdir, int __noclose);
extern int chroot (const char *__path);
extern char *getpass (const char *__prompt);
extern int fsync (int __fd);
extern long int gethostid (void);
extern void sync (void);
extern int getpagesize (void);
extern int getdtablesize (void);
extern int truncate (const char *__file, __off_t __length);
extern int ftruncate (int __fd, __off_t __length);
extern int brk (void *__addr);
extern void *sbrk (intptr_t __delta);
extern long int syscall (long int __sysno, ...);
extern int lockf (int __fd, int __cmd, __off_t __len);
extern int fdatasync (int __fildes);
extern ssize_t __read_chk (int __fd, void *__buf, size_t __nbytes, size_t __buflen);
extern ssize_t __read_alias (int __fd, void *__buf, size_t __nbytes);
extern ssize_t __read_chk_warn (int __fd, void *__buf, size_t __nbytes, size_t __buflen);
extern ssize_t __readlink_chk (const char *__path, char *__buf, size_t __len, size_t __buflen);
extern ssize_t __readlink_alias (const char *__path, char *__buf, size_t __len);
extern ssize_t __readlink_chk_warn (const char *__path, char *__buf, size_t __len, size_t __buflen);
extern char *__getcwd_chk (char *__buf, size_t __size, size_t __buflen);
extern char *__getcwd_alias (char *__buf, size_t __size);
extern char *__getcwd_chk_warn (char *__buf, size_t __size, size_t __buflen);
extern char *__getwd_chk (char *__buf, size_t buflen);
extern char *__getwd_warn (char *__buf);
extern size_t __confstr_chk (int __name, char *__buf, size_t __len, size_t __buflen);
extern size_t __confstr_alias (int __name, char *__buf, size_t __len);
extern size_t __confstr_chk_warn (int __name, char *__buf, size_t __len, size_t __buflen);
extern int __getgroups_chk (int __size, __gid_t __list[], size_t __listlen);
extern int __getgroups_alias (int __size, __gid_t __list[]);
extern int __getgroups_chk_warn (int __size, __gid_t __list[], size_t __listlen);
extern int __ttyname_r_chk (int __fd, char *__buf, size_t __buflen, size_t __nreal);
extern int __ttyname_r_alias (int __fd, char *__buf, size_t __buflen);
extern int __ttyname_r_chk_warn (int __fd, char *__buf, size_t __buflen, size_t __nreal);
extern int __getlogin_r_chk (char *__buf, size_t __buflen, size_t __nreal);
extern int __getlogin_r_alias (char *__buf, size_t __buflen);
extern int __getlogin_r_chk_warn (char *__buf, size_t __buflen, size_t __nreal);
extern int __gethostname_chk (char *__buf, size_t __buflen, size_t __nreal);
extern int __gethostname_alias (char *__buf, size_t __buflen);
extern int __gethostname_chk_warn (char *__buf, size_t __buflen, size_t __nreal);
extern int __getdomainname_chk (char *__buf, size_t __buflen, size_t __nreal);
extern int __getdomainname_alias (char *__buf, size_t __buflen);
extern int __getdomainname_chk_warn (char *__buf, size_t __buflen, size_t __nreal);
typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __id_t id_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;
typedef __time_t time_t;
typedef __clockid_t clockid_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef int int8_t;
typedef int int16_t;
typedef int int32_t;
typedef int int64_t;
typedef unsigned int u_int8_t;
typedef unsigned int u_int16_t;
typedef unsigned int u_int32_t;
typedef unsigned int u_int64_t;
typedef int register_t;
typedef int __sig_atomic_t;
typedef struct
{
  unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
} __sigset_t;
typedef __sigset_t sigset_t;
struct timespec
{
  __time_t tv_sec;
  long int tv_nsec;
};
struct timeval
{
  __time_t tv_sec;
  __suseconds_t tv_usec;
};
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
{
  __fd_mask __fds_bits[1024 / (8 * sizeof (__fd_mask))];
}
fd_set;
typedef __fd_mask fd_mask;
extern int select (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, struct timeval *__timeout);
extern int pselect (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, const struct timespec *__timeout, const __sigset_t * __sigmask);
extern unsigned int gnu_dev_major (unsigned long long int __dev);
extern unsigned int gnu_dev_minor (unsigned long long int __dev);
extern unsigned long long int gnu_dev_makedev (unsigned int __major, unsigned int __minor);
typedef __blkcnt_t blkcnt_t;
typedef __fsblkcnt_t fsblkcnt_t;
typedef __fsfilcnt_t fsfilcnt_t;
typedef unsigned long int pthread_t;
typedef union
{
  char __size[36];
  long int __align;
} pthread_attr_t;
typedef struct __pthread_internal_slist
{
  struct __pthread_internal_slist *__next;
} __pthread_slist_t;
typedef union
{
  struct __pthread_mutex_s
  {
    int __lock;
    unsigned int __count;
    int __owner;
    int __kind;
    unsigned int __nusers;
    union
    {
      int __spins;
      __pthread_slist_t __list;
    };
  } __data;
  char __size[24];
  long int __align;
} pthread_mutex_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_mutexattr_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __futex;
    unsigned long long int __total_seq;
    unsigned long long int __wakeup_seq;
    unsigned long long int __woken_seq;
    void *__mutex;
    unsigned int __nwaiters;
    unsigned int __broadcast_seq;
  } __data;
  char __size[48];
  long long int __align;
} pthread_cond_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef int pthread_once_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __nr_readers;
    unsigned int __readers_wakeup;
    unsigned int __writer_wakeup;
    unsigned int __nr_readers_queued;
    unsigned int __nr_writers_queued;
    unsigned char __flags;
    unsigned char __shared;
    unsigned char __pad1;
    unsigned char __pad2;
    int __writer;
  } __data;
  char __size[32];
  long int __align;
} pthread_rwlock_t;
typedef union
{
  char __size[8];
  long int __align;
} pthread_rwlockattr_t;
typedef volatile int pthread_spinlock_t;
typedef union
{
  char __size[20];
  long int __align;
} pthread_barrier_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_barrierattr_t;
int IS_JNI_1_2 = 0;
jint
JNI_OnLoad (JavaVM * vm, void *reserved)
{
  IS_JNI_1_2 = 1;
  return 0x00010002;
}
void
throwOutOfMemory (JNIEnv * env)
{
  jclass clazz = (*env)->FindClass (env, "java/lang/OutOfMemoryError");
  if (clazz != ((void *) 0))
    {
      (*env)->ThrowNew (env, clazz, "");
    }
}
