package org.sqlite;

import org.junit.BeforeClass;
import org.junit.AfterClass;
import org.junit.Test;
import org.junit.Rule;
import org.junit.rules.TestRule;
import org.junit.rules.Timeout;
import org.junit.rules.TestWatcher;
import org.junit.runner.Description;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.FileOutputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

public class MUSEListener
{
	private static String watchedLog;
	private static PrintWriter out = null;

	@Rule
	public Timeout to = new Timeout(5000);

	@Rule
	public TestRule watchman = new TestWatcher(){
		@Override
		protected final void succeeded(Description description){
			watchedLog = description.toString()+",1";
			System.out.println(watchedLog);
			out.println(watchedLog);
		}

		@Override
		protected final void failed(Throwable e, Description description){
			watchedLog = description.toString()+",0";
			System.out.println(watchedLog);
			out.println(watchedLog);
		}
	};

	@BeforeClass
	public static void fileopen() throws Exception{
		out = new PrintWriter(new FileOutputStream(new File("testresult"), true));
	}

	@AfterClass
	public static void fileClose(){
		out.close();
	}

}
