package test; 
import com.aelitis.azureus.ui.common.table.TableColumnCore;
import com.aelitis.azureus.ui.common.table.impl.TableColumnImpl;
import com.aelitis.azureus.ui.swt.views.list.*;

import static org.junit.Assert.*;

import java.lang.ref.PhantomReference;
import java.lang.ref.ReferenceQueue;

import junit.framework.TestCase;

import org.eclipse.swt.*;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.internal.gtk.OS;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.internal.runners.TestClass;

public class ListViewTest15  extends ListViewTest{
	
	@Test
	public void testHandleResizeO() {
		ListView target = new ListView("TEST CASE #1", null,
				comp, null,  SWT.V_SCROLL);
		
		assertTrue(target.listCanvas != null);
		target.listCanvas.setBounds(1, 1, 1, 1);
		
		target.allColumns = new TableColumnImpl[0];
		target.viewVisible = true;
		target.rows.add(new ListRow(target, comp, null));
		target.rows.add(new ListRow(target, comp, null));
		target.rows.add(new ListRow(target, comp, null));
		target.rows.add(new ListRow(target, comp, null));

		Image back;
		back = target.imgView;
		target.handleResize(true);
		assertTrue(back != target.imgView);
		
		target.handleResize(false);

		back = null;
		myGC();
		assertTrue(Image.numberOfNonDisposed() == 0);
	}
	
}

