/*
 * AtkGObjectAccessible.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.GObjectAccessible;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Object;

final class AtkGObjectAccessible extends Plumbing
{
    private AtkGObjectAccessible() {}

    static final Object getObject(GObjectAccessible self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_gobject_accessible_get_object(pointerOf(self));

            return (Object) objectFor(result);
        }
    }

    private static native final long atk_gobject_accessible_get_object(long self);
}

