/*
 * AtkTextAttribute.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.Plumbing;

final class AtkTextAttribute extends Plumbing
{
    private AtkTextAttribute() {}

    static final int LEFT_MARGIN = 0;

    static final int RIGHT_MARGIN = 1;

    static final int INDENT = 2;

    static final int INVISIBLE = 3;

    static final int EDITABLE = 4;

    static final int PIXELS_ABOVE_LINES = 5;

    static final int PIXELS_BELOW_LINES = 6;

    static final int PIXELS_INSIDE_WRAP = 7;

    static final int BG_FULL_HEIGHT = 8;

    static final int RISE = 9;

    static final int UNDERLINE = 10;

    static final int STRIKETHROUGH = 11;

    static final int SIZE = 12;

    static final int SCALE = 13;

    static final int WEIGHT = 14;

    static final int LANGUAGE = 15;

    static final int FAMILY_NAME = 16;

    static final int BG_COLOR = 17;

    static final int FG_COLOR = 18;

    static final int BG_STIPPLE = 19;

    static final int FG_STIPPLE = 20;

    static final int WRAP_MODE = 21;

    static final int DIRECTION = 22;

    static final int JUSTIFICATION = 23;

    static final int STRETCH = 24;

    static final int VARIANT = 25;

    static final int STYLE = 26;
}

