/*
 * GdkGCValuesMask.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkGCValuesMask extends Plumbing
{
    private GdkGCValuesMask() {}

    static final int FOREGROUND = get_ordinal_foreground();

    private static native final int get_ordinal_foreground();

    static final int BACKGROUND = get_ordinal_background();

    private static native final int get_ordinal_background();

    static final int FONT = get_ordinal_font();

    private static native final int get_ordinal_font();

    static final int FUNCTION = get_ordinal_function();

    private static native final int get_ordinal_function();

    static final int FILL = get_ordinal_fill();

    private static native final int get_ordinal_fill();

    static final int TILE = get_ordinal_tile();

    private static native final int get_ordinal_tile();

    static final int STIPPLE = get_ordinal_stipple();

    private static native final int get_ordinal_stipple();

    static final int CLIP_MASK = get_ordinal_clip_mask();

    private static native final int get_ordinal_clip_mask();

    static final int SUBWINDOW = get_ordinal_subwindow();

    private static native final int get_ordinal_subwindow();

    static final int TS_X_ORIGIN = get_ordinal_ts_x_origin();

    private static native final int get_ordinal_ts_x_origin();

    static final int TS_Y_ORIGIN = get_ordinal_ts_y_origin();

    private static native final int get_ordinal_ts_y_origin();

    static final int CLIP_X_ORIGIN = get_ordinal_clip_x_origin();

    private static native final int get_ordinal_clip_x_origin();

    static final int CLIP_Y_ORIGIN = get_ordinal_clip_y_origin();

    private static native final int get_ordinal_clip_y_origin();

    static final int EXPOSURES = get_ordinal_exposures();

    private static native final int get_ordinal_exposures();

    static final int LINE_WIDTH = get_ordinal_line_width();

    private static native final int get_ordinal_line_width();

    static final int LINE_STYLE = get_ordinal_line_style();

    private static native final int get_ordinal_line_style();

    static final int CAP_STYLE = get_ordinal_cap_style();

    private static native final int get_ordinal_cap_style();

    static final int JOIN_STYLE = get_ordinal_join_style();

    private static native final int get_ordinal_join_style();
}

