/*
 * GtkSeparatorToolItem.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SeparatorToolItem;

final class GtkSeparatorToolItem extends Plumbing
{
    private GtkSeparatorToolItem() {}

    static final long createSeparatorToolItem() {
        long result;

        synchronized (lock) {
            result = gtk_separator_tool_item_new();

            return result;
        }
    }

    private static native final long gtk_separator_tool_item_new();

    static final boolean getDraw(SeparatorToolItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_separator_tool_item_get_draw(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_separator_tool_item_get_draw(long self);

    static final void setDraw(SeparatorToolItem self, boolean draw) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_separator_tool_item_set_draw(pointerOf(self), draw);
        }
    }

    private static native final void gtk_separator_tool_item_set_draw(long self, boolean draw);
}

