/*
 * GtkWidgetFlags.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;

final class GtkWidgetFlags extends Plumbing
{
    private GtkWidgetFlags() {}

    static final int TOPLEVEL = get_ordinal_toplevel();

    private static native final int get_ordinal_toplevel();

    static final int NO_WINDOW = get_ordinal_no_window();

    private static native final int get_ordinal_no_window();

    static final int REALIZED = get_ordinal_realized();

    private static native final int get_ordinal_realized();

    static final int MAPPED = get_ordinal_mapped();

    private static native final int get_ordinal_mapped();

    static final int VISIBLE = get_ordinal_visible();

    private static native final int get_ordinal_visible();

    static final int SENSITIVE = get_ordinal_sensitive();

    private static native final int get_ordinal_sensitive();

    static final int PARENT_SENSITIVE = get_ordinal_parent_sensitive();

    private static native final int get_ordinal_parent_sensitive();

    static final int CAN_FOCUS = get_ordinal_can_focus();

    private static native final int get_ordinal_can_focus();

    static final int HAS_FOCUS = get_ordinal_has_focus();

    private static native final int get_ordinal_has_focus();

    static final int CAN_DEFAULT = get_ordinal_can_default();

    private static native final int get_ordinal_can_default();

    static final int HAS_DEFAULT = get_ordinal_has_default();

    private static native final int get_ordinal_has_default();

    static final int HAS_GRAB = get_ordinal_has_grab();

    private static native final int get_ordinal_has_grab();

    static final int RC_STYLE = get_ordinal_rc_style();

    private static native final int get_ordinal_rc_style();

    static final int COMPOSITE_CHILD = get_ordinal_composite_child();

    private static native final int get_ordinal_composite_child();

    static final int NO_REPARENT = get_ordinal_no_reparent();

    private static native final int get_ordinal_no_reparent();

    static final int APP_PAINTABLE = get_ordinal_app_paintable();

    private static native final int get_ordinal_app_paintable();

    static final int RECEIVES_DEFAULT = get_ordinal_receives_default();

    private static native final int get_ordinal_receives_default();

    static final int DOUBLE_BUFFERED = get_ordinal_double_buffered();

    private static native final int get_ordinal_double_buffered();

    static final int NO_SHOW_ALL = get_ordinal_no_show_all();

    private static native final int get_ordinal_no_show_all();
}

