typedef long unsigned int size_t;
typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef signed long int __int64_t;
typedef unsigned long int __uint64_t;
typedef long int __quad_t;
typedef unsigned long int __u_quad_t;
typedef unsigned long int __dev_t;
typedef unsigned int __uid_t;
typedef unsigned int __gid_t;
typedef unsigned long int __ino_t;
typedef unsigned long int __ino64_t;
typedef unsigned int __mode_t;
typedef unsigned long int __nlink_t;
typedef long int __off_t;
typedef long int __off64_t;
typedef int __pid_t;
typedef struct
{
  int __val[2];
} __fsid_t;
typedef long int __clock_t;
typedef unsigned long int __rlim_t;
typedef unsigned long int __rlim64_t;
typedef unsigned int __id_t;
typedef long int __time_t;
typedef unsigned int __useconds_t;
typedef long int __suseconds_t;
typedef int __daddr_t;
typedef int __key_t;
typedef int __clockid_t;
typedef void *__timer_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef long int __blkcnt64_t;
typedef unsigned long int __fsblkcnt_t;
typedef unsigned long int __fsblkcnt64_t;
typedef unsigned long int __fsfilcnt_t;
typedef unsigned long int __fsfilcnt64_t;
typedef long int __fsword_t;
typedef long int __ssize_t;
typedef long int __syscall_slong_t;
typedef unsigned long int __syscall_ulong_t;
typedef __off64_t __loff_t;
typedef __quad_t *__qaddr_t;
typedef char *__caddr_t;
typedef long int __intptr_t;
typedef unsigned int __socklen_t;
struct _IO_FILE;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef struct
{
  int __count;
  union
  {
    unsigned int __wch;
    char __wchb[4];
  } __value;
} __mbstate_t;
typedef struct
{
  __off_t __pos;
  __mbstate_t __state;
} _G_fpos_t;
typedef struct
{
  __off64_t __pos;
  __mbstate_t __state;
} _G_fpos64_t;
typedef __gnuc_va_list;
struct _IO_jump_t;
struct _IO_FILE;
typedef void _IO_lock_t;
struct _IO_marker
{
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
enum __codecvt_result
{
  __codecvt_ok,
  __codecvt_partial,
  __codecvt_error,
  __codecvt_noconv
};
struct _IO_FILE
{
  int _flags;
  char *_IO_read_ptr;
  char *_IO_read_end;
  char *_IO_read_base;
  char *_IO_write_base;
  char *_IO_write_ptr;
  char *_IO_write_end;
  char *_IO_buf_base;
  char *_IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _flags2;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  void *__pad3;
  void *__pad4;
  size_t __pad5;
  int _mode;
  char _unused2[15 * sizeof (int) - 4 * sizeof (void *) - sizeof (size_t)];
};
typedef struct _IO_FILE _IO_FILE;
struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_2_1_stdin_;
extern struct _IO_FILE_plus _IO_2_1_stdout_;
extern struct _IO_FILE_plus _IO_2_1_stderr_;
typedef __ssize_t __io_read_fn (void *__cookie, char *__buf, size_t __nbytes);
typedef __ssize_t __io_write_fn (void *__cookie, const char *__buf, size_t __n);
typedef int __io_seek_fn (void *__cookie, __off64_t * __pos, int __w);
typedef int __io_close_fn (void *__cookie);
extern int __underflow (_IO_FILE *);
extern int __uflow (_IO_FILE *);
extern int __overflow (_IO_FILE *, int);
extern int _IO_getc (_IO_FILE * __fp);
extern int _IO_putc (int __c, _IO_FILE * __fp);
extern int _IO_feof (_IO_FILE * __fp);
extern int _IO_ferror (_IO_FILE * __fp);
extern int _IO_peekc_locked (_IO_FILE * __fp);
extern void _IO_flockfile (_IO_FILE *);
extern void _IO_funlockfile (_IO_FILE *);
extern int _IO_ftrylockfile (_IO_FILE *);
extern int _IO_vfscanf (_IO_FILE *, const char *, __gnuc_va_list, int *);
extern int _IO_vfprintf (_IO_FILE *, const char *, __gnuc_va_list);
extern __ssize_t _IO_padn (_IO_FILE *, int, __ssize_t);
extern size_t _IO_sgetn (_IO_FILE *, void *, size_t);
extern __off64_t _IO_seekoff (_IO_FILE *, __off64_t, int, int);
extern __off64_t _IO_seekpos (_IO_FILE *, __off64_t, int);
extern void _IO_free_backup_area (_IO_FILE *);
typedef __gnuc_va_list va_list;
typedef __off_t off_t;
typedef __ssize_t ssize_t;
typedef _G_fpos_t fpos_t;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stdout;
extern struct _IO_FILE *stderr;
extern int remove (const char *__filename);
extern int rename (const char *__old, const char *__new);
extern int renameat (int __oldfd, const char *__old, int __newfd, const char *__new);
extern FILE *tmpfile (void);
extern char *tmpnam (char *__s);
extern char *tmpnam_r (char *__s);
extern char *tempnam (const char *__dir, const char *__pfx);
extern int fclose (FILE * __stream);
extern int fflush (FILE * __stream);
extern int fflush_unlocked (FILE * __stream);
extern FILE *fopen (const char *__filename, const char *__modes);
extern FILE *freopen (const char *__filename, const char *__modes, FILE * __stream);
extern FILE *fdopen (int __fd, const char *__modes);
extern FILE *fmemopen (void *__s, size_t __len, const char *__modes);
extern FILE *open_memstream (char **__bufloc, size_t * __sizeloc);
extern void setbuf (FILE * __stream, char *__buf);
extern int setvbuf (FILE * __stream, char *__buf, int __modes, size_t __n);
extern void setbuffer (FILE * __stream, char *__buf, size_t __size);
extern void setlinebuf (FILE * __stream);
extern int fprintf (FILE * __stream, const char *__format, ...);
extern int printf (const char *__format, ...);
extern int sprintf (char *__s, const char *__format, ...);
extern int vfprintf (FILE * __s, const char *__format, __gnuc_va_list __arg);
extern int vprintf (const char *__format, __gnuc_va_list __arg);
extern int vsprintf (char *__s, const char *__format, __gnuc_va_list __arg);
extern int snprintf (char *__s, size_t __maxlen, const char *__format, ...);
extern int vsnprintf (char *__s, size_t __maxlen, const char *__format, __gnuc_va_list __arg);
extern int vdprintf (int __fd, const char *__fmt, __gnuc_va_list __arg);
extern int dprintf (int __fd, const char *__fmt, ...);
extern int fscanf (FILE * __stream, const char *__format, ...);
extern int scanf (const char *__format, ...);
extern int sscanf (const char *__s, const char *__format, ...);
extern int fscanf (FILE * __stream, const char *__format, ...);
extern int scanf (const char *__format, ...);
extern int sscanf (const char *__s, const char *__format, ...);
extern int vfscanf (FILE * __s, const char *__format, __gnuc_va_list __arg);
extern int vscanf (const char *__format, __gnuc_va_list __arg);
extern int vsscanf (const char *__s, const char *__format, __gnuc_va_list __arg);
extern int vfscanf (FILE * __s, const char *__format, __gnuc_va_list __arg);
extern int vscanf (const char *__format, __gnuc_va_list __arg);
extern int vsscanf (const char *__s, const char *__format, __gnuc_va_list __arg);
extern int fgetc (FILE * __stream);
extern int getc (FILE * __stream);
extern int getchar (void);
extern int getc_unlocked (FILE * __stream);
extern int getchar_unlocked (void);
extern int fgetc_unlocked (FILE * __stream);
extern int fputc (int __c, FILE * __stream);
extern int putc (int __c, FILE * __stream);
extern int putchar (int __c);
extern int fputc_unlocked (int __c, FILE * __stream);
extern int putc_unlocked (int __c, FILE * __stream);
extern int putchar_unlocked (int __c);
extern int getw (FILE * __stream);
extern int putw (int __w, FILE * __stream);
extern char *fgets (char *__s, int __n, FILE * __stream);
extern char *gets (char *__s);
extern __ssize_t __getdelim (char **__lineptr, size_t * __n, int __delimiter, FILE * __stream);
extern __ssize_t getdelim (char **__lineptr, size_t * __n, int __delimiter, FILE * __stream);
extern __ssize_t getline (char **__lineptr, size_t * __n, FILE * __stream);
extern int fputs (const char *__s, FILE * __stream);
extern int puts (const char *__s);
extern int ungetc (int __c, FILE * __stream);
extern size_t fread (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t fwrite (const void *__ptr, size_t __size, size_t __n, FILE * __s);
extern size_t fread_unlocked (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t fwrite_unlocked (const void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern int fseek (FILE * __stream, long int __off, int __whence);
extern long int ftell (FILE * __stream);
extern void rewind (FILE * __stream);
extern int fseeko (FILE * __stream, __off_t __off, int __whence);
extern __off_t ftello (FILE * __stream);
extern int fgetpos (FILE * __stream, fpos_t * __pos);
extern int fsetpos (FILE * __stream, const fpos_t * __pos);
extern void clearerr (FILE * __stream);
extern int feof (FILE * __stream);
extern int ferror (FILE * __stream);
extern void clearerr_unlocked (FILE * __stream);
extern int feof_unlocked (FILE * __stream);
extern int ferror_unlocked (FILE * __stream);
extern void perror (const char *__s);
extern int sys_nerr;
extern const char *const sys_errlist[];
extern int fileno (FILE * __stream);
extern int fileno_unlocked (FILE * __stream);
extern FILE *popen (const char *__command, const char *__modes);
extern int pclose (FILE * __stream);
extern char *ctermid (char *__s);
extern void flockfile (FILE * __stream);
extern int ftrylockfile (FILE * __stream);
extern void funlockfile (FILE * __stream);
typedef int jint;
typedef long jlong;
typedef signed char jbyte;
typedef unsigned char jboolean;
typedef unsigned short jchar;
typedef short jshort;
typedef float jfloat;
typedef double jdouble;
typedef jint jsize;
struct _jobject;
typedef struct _jobject *jobject;
typedef jobject jclass;
typedef jobject jthrowable;
typedef jobject jstring;
typedef jobject jarray;
typedef jarray jbooleanArray;
typedef jarray jbyteArray;
typedef jarray jcharArray;
typedef jarray jshortArray;
typedef jarray jintArray;
typedef jarray jlongArray;
typedef jarray jfloatArray;
typedef jarray jdoubleArray;
typedef jarray jobjectArray;
typedef jobject jweak;
typedef union jvalue
{
  jboolean z;
  jbyte b;
  jchar c;
  jshort s;
  jint i;
  jlong j;
  jfloat f;
  jdouble d;
  jobject l;
} jvalue;
struct _jfieldID;
typedef struct _jfieldID *jfieldID;
struct _jmethodID;
typedef struct _jmethodID *jmethodID;
typedef enum _jobjectType
{
  JNIInvalidRefType = 0,
  JNILocalRefType = 1,
  JNIGlobalRefType = 2,
  JNIWeakGlobalRefType = 3
} jobjectRefType;
typedef struct
{
  char *name;
  char *signature;
  void *fnPtr;
} JNINativeMethod;
struct JNINativeInterface_;
struct JNIEnv_;
typedef const struct JNINativeInterface_ *JNIEnv;
struct JNIInvokeInterface_;
struct JavaVM_;
typedef const struct JNIInvokeInterface_ *JavaVM;
struct JNINativeInterface_
{
  void *reserved0;
  void *reserved1;
  void *reserved2;
  void *reserved3;
    jint (*GetVersion) (JNIEnv * env);
    jclass (*DefineClass) (JNIEnv * env, const char *name, jobject loader, const jbyte * buf, jsize len);
    jclass (*FindClass) (JNIEnv * env, const char *name);
    jmethodID (*FromReflectedMethod) (JNIEnv * env, jobject method);
    jfieldID (*FromReflectedField) (JNIEnv * env, jobject field);
    jobject (*ToReflectedMethod) (JNIEnv * env, jclass cls, jmethodID methodID, jboolean isStatic);
    jclass (*GetSuperclass) (JNIEnv * env, jclass sub);
    jboolean (*IsAssignableFrom) (JNIEnv * env, jclass sub, jclass sup);
    jobject (*ToReflectedField) (JNIEnv * env, jclass cls, jfieldID fieldID, jboolean isStatic);
    jint (*Throw) (JNIEnv * env, jthrowable obj);
    jint (*ThrowNew) (JNIEnv * env, jclass clazz, const char *msg);
    jthrowable (*ExceptionOccurred) (JNIEnv * env);
  void (*ExceptionDescribe) (JNIEnv * env);
  void (*ExceptionClear) (JNIEnv * env);
  void (*FatalError) (JNIEnv * env, const char *msg);
    jint (*PushLocalFrame) (JNIEnv * env, jint capacity);
    jobject (*PopLocalFrame) (JNIEnv * env, jobject result);
    jobject (*NewGlobalRef) (JNIEnv * env, jobject lobj);
  void (*DeleteGlobalRef) (JNIEnv * env, jobject gref);
  void (*DeleteLocalRef) (JNIEnv * env, jobject obj);
    jboolean (*IsSameObject) (JNIEnv * env, jobject obj1, jobject obj2);
    jobject (*NewLocalRef) (JNIEnv * env, jobject ref);
    jint (*EnsureLocalCapacity) (JNIEnv * env, jint capacity);
    jobject (*AllocObject) (JNIEnv * env, jclass clazz);
    jobject (*NewObject) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jobject (*NewObjectV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jobject (*NewObjectA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jclass (*GetObjectClass) (JNIEnv * env, jobject obj);
    jboolean (*IsInstanceOf) (JNIEnv * env, jobject obj, jclass clazz);
    jmethodID (*GetMethodID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*CallObjectMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jobject (*CallObjectMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jobject (*CallObjectMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jboolean (*CallBooleanMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jboolean (*CallBooleanMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jboolean (*CallBooleanMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jbyte (*CallByteMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jbyte (*CallByteMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jbyte (*CallByteMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jchar (*CallCharMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jchar (*CallCharMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jchar (*CallCharMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jshort (*CallShortMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jshort (*CallShortMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jshort (*CallShortMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jint (*CallIntMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jint (*CallIntMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jint (*CallIntMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jlong (*CallLongMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jlong (*CallLongMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jlong (*CallLongMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jfloat (*CallFloatMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jfloat (*CallFloatMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jfloat (*CallFloatMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jdouble (*CallDoubleMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jdouble (*CallDoubleMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jdouble (*CallDoubleMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
  void (*CallVoidMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
  void (*CallVoidMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
  void (*CallVoidMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jobject (*CallNonvirtualObjectMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jobject (*CallNonvirtualObjectMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jobject (*CallNonvirtualObjectMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jboolean (*CallNonvirtualBooleanMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jboolean (*CallNonvirtualBooleanMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jboolean (*CallNonvirtualBooleanMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jbyte (*CallNonvirtualByteMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jbyte (*CallNonvirtualByteMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jbyte (*CallNonvirtualByteMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jchar (*CallNonvirtualCharMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jchar (*CallNonvirtualCharMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jchar (*CallNonvirtualCharMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jshort (*CallNonvirtualShortMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jshort (*CallNonvirtualShortMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jshort (*CallNonvirtualShortMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jint (*CallNonvirtualIntMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jint (*CallNonvirtualIntMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jint (*CallNonvirtualIntMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jlong (*CallNonvirtualLongMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jlong (*CallNonvirtualLongMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jlong (*CallNonvirtualLongMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jfloat (*CallNonvirtualFloatMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jfloat (*CallNonvirtualFloatMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jfloat (*CallNonvirtualFloatMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jdouble (*CallNonvirtualDoubleMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jdouble (*CallNonvirtualDoubleMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jdouble (*CallNonvirtualDoubleMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
  void (*CallNonvirtualVoidMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
  void (*CallNonvirtualVoidMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
  void (*CallNonvirtualVoidMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jfieldID (*GetFieldID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*GetObjectField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jboolean (*GetBooleanField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jbyte (*GetByteField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jchar (*GetCharField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jshort (*GetShortField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jint (*GetIntField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jlong (*GetLongField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jfloat (*GetFloatField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jdouble (*GetDoubleField) (JNIEnv * env, jobject obj, jfieldID fieldID);
  void (*SetObjectField) (JNIEnv * env, jobject obj, jfieldID fieldID, jobject val);
  void (*SetBooleanField) (JNIEnv * env, jobject obj, jfieldID fieldID, jboolean val);
  void (*SetByteField) (JNIEnv * env, jobject obj, jfieldID fieldID, jbyte val);
  void (*SetCharField) (JNIEnv * env, jobject obj, jfieldID fieldID, jchar val);
  void (*SetShortField) (JNIEnv * env, jobject obj, jfieldID fieldID, jshort val);
  void (*SetIntField) (JNIEnv * env, jobject obj, jfieldID fieldID, jint val);
  void (*SetLongField) (JNIEnv * env, jobject obj, jfieldID fieldID, jlong val);
  void (*SetFloatField) (JNIEnv * env, jobject obj, jfieldID fieldID, jfloat val);
  void (*SetDoubleField) (JNIEnv * env, jobject obj, jfieldID fieldID, jdouble val);
    jmethodID (*GetStaticMethodID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*CallStaticObjectMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jobject (*CallStaticObjectMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jobject (*CallStaticObjectMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jboolean (*CallStaticBooleanMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jboolean (*CallStaticBooleanMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jboolean (*CallStaticBooleanMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jbyte (*CallStaticByteMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jbyte (*CallStaticByteMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jbyte (*CallStaticByteMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jchar (*CallStaticCharMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jchar (*CallStaticCharMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jchar (*CallStaticCharMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jshort (*CallStaticShortMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jshort (*CallStaticShortMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jshort (*CallStaticShortMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jint (*CallStaticIntMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jint (*CallStaticIntMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jint (*CallStaticIntMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jlong (*CallStaticLongMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jlong (*CallStaticLongMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jlong (*CallStaticLongMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jfloat (*CallStaticFloatMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jfloat (*CallStaticFloatMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jfloat (*CallStaticFloatMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jdouble (*CallStaticDoubleMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jdouble (*CallStaticDoubleMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jdouble (*CallStaticDoubleMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
  void (*CallStaticVoidMethod) (JNIEnv * env, jclass cls, jmethodID methodID, ...);
  void (*CallStaticVoidMethodV) (JNIEnv * env, jclass cls, jmethodID methodID, va_list args);
  void (*CallStaticVoidMethodA) (JNIEnv * env, jclass cls, jmethodID methodID, const jvalue * args);
    jfieldID (*GetStaticFieldID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*GetStaticObjectField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jboolean (*GetStaticBooleanField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jbyte (*GetStaticByteField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jchar (*GetStaticCharField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jshort (*GetStaticShortField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jint (*GetStaticIntField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jlong (*GetStaticLongField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jfloat (*GetStaticFloatField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jdouble (*GetStaticDoubleField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
  void (*SetStaticObjectField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jobject value);
  void (*SetStaticBooleanField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jboolean value);
  void (*SetStaticByteField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jbyte value);
  void (*SetStaticCharField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jchar value);
  void (*SetStaticShortField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jshort value);
  void (*SetStaticIntField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jint value);
  void (*SetStaticLongField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jlong value);
  void (*SetStaticFloatField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jfloat value);
  void (*SetStaticDoubleField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jdouble value);
    jstring (*NewString) (JNIEnv * env, const jchar * unicode, jsize len);
    jsize (*GetStringLength) (JNIEnv * env, jstring str);
  const jchar *(*GetStringChars) (JNIEnv * env, jstring str, jboolean * isCopy);
  void (*ReleaseStringChars) (JNIEnv * env, jstring str, const jchar * chars);
    jstring (*NewStringUTF) (JNIEnv * env, const char *utf);
    jsize (*GetStringUTFLength) (JNIEnv * env, jstring str);
  const char *(*GetStringUTFChars) (JNIEnv * env, jstring str, jboolean * isCopy);
  void (*ReleaseStringUTFChars) (JNIEnv * env, jstring str, const char *chars);
    jsize (*GetArrayLength) (JNIEnv * env, jarray array);
    jobjectArray (*NewObjectArray) (JNIEnv * env, jsize len, jclass clazz, jobject init);
    jobject (*GetObjectArrayElement) (JNIEnv * env, jobjectArray array, jsize index);
  void (*SetObjectArrayElement) (JNIEnv * env, jobjectArray array, jsize index, jobject val);
    jbooleanArray (*NewBooleanArray) (JNIEnv * env, jsize len);
    jbyteArray (*NewByteArray) (JNIEnv * env, jsize len);
    jcharArray (*NewCharArray) (JNIEnv * env, jsize len);
    jshortArray (*NewShortArray) (JNIEnv * env, jsize len);
    jintArray (*NewIntArray) (JNIEnv * env, jsize len);
    jlongArray (*NewLongArray) (JNIEnv * env, jsize len);
    jfloatArray (*NewFloatArray) (JNIEnv * env, jsize len);
    jdoubleArray (*NewDoubleArray) (JNIEnv * env, jsize len);
  jboolean *(*GetBooleanArrayElements) (JNIEnv * env, jbooleanArray array, jboolean * isCopy);
  jbyte *(*GetByteArrayElements) (JNIEnv * env, jbyteArray array, jboolean * isCopy);
  jchar *(*GetCharArrayElements) (JNIEnv * env, jcharArray array, jboolean * isCopy);
  jshort *(*GetShortArrayElements) (JNIEnv * env, jshortArray array, jboolean * isCopy);
  jint *(*GetIntArrayElements) (JNIEnv * env, jintArray array, jboolean * isCopy);
  jlong *(*GetLongArrayElements) (JNIEnv * env, jlongArray array, jboolean * isCopy);
  jfloat *(*GetFloatArrayElements) (JNIEnv * env, jfloatArray array, jboolean * isCopy);
  jdouble *(*GetDoubleArrayElements) (JNIEnv * env, jdoubleArray array, jboolean * isCopy);
  void (*ReleaseBooleanArrayElements) (JNIEnv * env, jbooleanArray array, jboolean * elems, jint mode);
  void (*ReleaseByteArrayElements) (JNIEnv * env, jbyteArray array, jbyte * elems, jint mode);
  void (*ReleaseCharArrayElements) (JNIEnv * env, jcharArray array, jchar * elems, jint mode);
  void (*ReleaseShortArrayElements) (JNIEnv * env, jshortArray array, jshort * elems, jint mode);
  void (*ReleaseIntArrayElements) (JNIEnv * env, jintArray array, jint * elems, jint mode);
  void (*ReleaseLongArrayElements) (JNIEnv * env, jlongArray array, jlong * elems, jint mode);
  void (*ReleaseFloatArrayElements) (JNIEnv * env, jfloatArray array, jfloat * elems, jint mode);
  void (*ReleaseDoubleArrayElements) (JNIEnv * env, jdoubleArray array, jdouble * elems, jint mode);
  void (*GetBooleanArrayRegion) (JNIEnv * env, jbooleanArray array, jsize start, jsize l, jboolean * buf);
  void (*GetByteArrayRegion) (JNIEnv * env, jbyteArray array, jsize start, jsize len, jbyte * buf);
  void (*GetCharArrayRegion) (JNIEnv * env, jcharArray array, jsize start, jsize len, jchar * buf);
  void (*GetShortArrayRegion) (JNIEnv * env, jshortArray array, jsize start, jsize len, jshort * buf);
  void (*GetIntArrayRegion) (JNIEnv * env, jintArray array, jsize start, jsize len, jint * buf);
  void (*GetLongArrayRegion) (JNIEnv * env, jlongArray array, jsize start, jsize len, jlong * buf);
  void (*GetFloatArrayRegion) (JNIEnv * env, jfloatArray array, jsize start, jsize len, jfloat * buf);
  void (*GetDoubleArrayRegion) (JNIEnv * env, jdoubleArray array, jsize start, jsize len, jdouble * buf);
  void (*SetBooleanArrayRegion) (JNIEnv * env, jbooleanArray array, jsize start, jsize l, const jboolean * buf);
  void (*SetByteArrayRegion) (JNIEnv * env, jbyteArray array, jsize start, jsize len, const jbyte * buf);
  void (*SetCharArrayRegion) (JNIEnv * env, jcharArray array, jsize start, jsize len, const jchar * buf);
  void (*SetShortArrayRegion) (JNIEnv * env, jshortArray array, jsize start, jsize len, const jshort * buf);
  void (*SetIntArrayRegion) (JNIEnv * env, jintArray array, jsize start, jsize len, const jint * buf);
  void (*SetLongArrayRegion) (JNIEnv * env, jlongArray array, jsize start, jsize len, const jlong * buf);
  void (*SetFloatArrayRegion) (JNIEnv * env, jfloatArray array, jsize start, jsize len, const jfloat * buf);
  void (*SetDoubleArrayRegion) (JNIEnv * env, jdoubleArray array, jsize start, jsize len, const jdouble * buf);
    jint (*RegisterNatives) (JNIEnv * env, jclass clazz, const JNINativeMethod * methods, jint nMethods);
    jint (*UnregisterNatives) (JNIEnv * env, jclass clazz);
    jint (*MonitorEnter) (JNIEnv * env, jobject obj);
    jint (*MonitorExit) (JNIEnv * env, jobject obj);
    jint (*GetJavaVM) (JNIEnv * env, JavaVM ** vm);
  void (*GetStringRegion) (JNIEnv * env, jstring str, jsize start, jsize len, jchar * buf);
  void (*GetStringUTFRegion) (JNIEnv * env, jstring str, jsize start, jsize len, char *buf);
  void *(*GetPrimitiveArrayCritical) (JNIEnv * env, jarray array, jboolean * isCopy);
  void (*ReleasePrimitiveArrayCritical) (JNIEnv * env, jarray array, void *carray, jint mode);
  const jchar *(*GetStringCritical) (JNIEnv * env, jstring string, jboolean * isCopy);
  void (*ReleaseStringCritical) (JNIEnv * env, jstring string, const jchar * cstring);
    jweak (*NewWeakGlobalRef) (JNIEnv * env, jobject obj);
  void (*DeleteWeakGlobalRef) (JNIEnv * env, jweak ref);
    jboolean (*ExceptionCheck) (JNIEnv * env);
    jobject (*NewDirectByteBuffer) (JNIEnv * env, void *address, jlong capacity);
  void *(*GetDirectBufferAddress) (JNIEnv * env, jobject buf);
    jlong (*GetDirectBufferCapacity) (JNIEnv * env, jobject buf);
    jobjectRefType (*GetObjectRefType) (JNIEnv * env, jobject obj);
};
struct JNIEnv_
{
  const struct JNINativeInterface_ *functions;
};
typedef struct JavaVMOption
{
  char *optionString;
  void *extraInfo;
} JavaVMOption;
typedef struct JavaVMInitArgs
{
  jint version;
  jint nOptions;
  JavaVMOption *options;
  jboolean ignoreUnrecognized;
} JavaVMInitArgs;
typedef struct JavaVMAttachArgs
{
  jint version;
  char *name;
  jobject group;
} JavaVMAttachArgs;
struct JNIInvokeInterface_
{
  void *reserved0;
  void *reserved1;
  void *reserved2;
    jint (*DestroyJavaVM) (JavaVM * vm);
    jint (*AttachCurrentThread) (JavaVM * vm, void **penv, void *args);
    jint (*DetachCurrentThread) (JavaVM * vm);
    jint (*GetEnv) (JavaVM * vm, void **penv, jint version);
    jint (*AttachCurrentThreadAsDaemon) (JavaVM * vm, void **penv, void *args);
};
struct JavaVM_
{
  const struct JNIInvokeInterface_ *functions;
};
jint JNI_GetDefaultJavaVMInitArgs (void *args);
jint JNI_CreateJavaVM (JavaVM ** pvm, void **penv, void *args);
jint JNI_GetCreatedJavaVMs (JavaVM **, jsize, jsize *);
jint JNI_OnLoad (JavaVM * vm, void *reserved);
void JNI_OnUnload (JavaVM * vm, void *reserved);
extern int IS_JNI_1_2;
void throwOutOfMemory (JNIEnv * env);
jbooleanArray mut_jbooleanArray(JNIEnv * env);
jbyteArray mut_jbyteArray(JNIEnv * env);
jcharArray mut_jcharArray(JNIEnv * env);
jshortArray mut_jshortArray(JNIEnv * env);
jintArray mut_jintArray(JNIEnv * env);
jlongArray mut_jlongArray(JNIEnv * env);
jfloatArray mut_jfloatArray(JNIEnv * env);
jdoubleArray mut_jdoubleArray(JNIEnv * env);
typedef int wchar_t;
typedef enum
{
  P_ALL,
  P_PID,
  P_PGID
} idtype_t;
typedef union
{
  union wait *__uptr;
  int *__iptr;
} __WAIT_STATUS;
typedef struct
{
  int quot;
  int rem;
} div_t;
typedef struct
{
  long int quot;
  long int rem;
} ldiv_t;
typedef struct
{
  long long int quot;
  long long int rem;
} lldiv_t;
extern size_t __ctype_get_mb_cur_max (void);
extern double atof (const char *__nptr);
extern int atoi (const char *__nptr);
extern long int atol (const char *__nptr);
extern long long int atoll (const char *__nptr);
extern double strtod (const char *__nptr, char **__endptr);
extern float strtof (const char *__nptr, char **__endptr);
extern long double strtold (const char *__nptr, char **__endptr);
extern long int strtol (const char *__nptr, char **__endptr, int __base);
extern unsigned long int strtoul (const char *__nptr, char **__endptr, int __base);
extern long long int strtoq (const char *__nptr, char **__endptr, int __base);
extern unsigned long long int strtouq (const char *__nptr, char **__endptr, int __base);
extern long long int strtoll (const char *__nptr, char **__endptr, int __base);
extern unsigned long long int strtoull (const char *__nptr, char **__endptr, int __base);
extern char *l64a (long int __n);
extern long int a64l (const char *__s);
typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __uid_t uid_t;
typedef __pid_t pid_t;
typedef __id_t id_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;
typedef __clock_t clock_t;
typedef __time_t time_t;
typedef __clockid_t clockid_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef int int8_t;
typedef int int16_t;
typedef int int32_t;
typedef int int64_t;
typedef unsigned int u_int8_t;
typedef unsigned int u_int16_t;
typedef unsigned int u_int32_t;
typedef unsigned int u_int64_t;
typedef int register_t;
typedef int __sig_atomic_t;
typedef struct
{
  unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
} __sigset_t;
typedef __sigset_t sigset_t;
struct timespec
{
  __time_t tv_sec;
  __syscall_slong_t tv_nsec;
};
struct timeval
{
  __time_t tv_sec;
  __suseconds_t tv_usec;
};
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
{
  __fd_mask __fds_bits[1024 / (8 * (int) sizeof (__fd_mask))];
}
fd_set;
typedef __fd_mask fd_mask;
extern int select (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, struct timeval *__timeout);
extern int pselect (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, const struct timespec *__timeout, const __sigset_t * __sigmask);
extern long int __fdelt_chk (long int __d);
extern long int __fdelt_warn (long int __d);
extern unsigned int gnu_dev_major (unsigned long long int __dev);
extern unsigned int gnu_dev_minor (unsigned long long int __dev);
extern unsigned long long int gnu_dev_makedev (unsigned int __major, unsigned int __minor);
typedef __blksize_t blksize_t;
typedef __blkcnt_t blkcnt_t;
typedef __fsblkcnt_t fsblkcnt_t;
typedef __fsfilcnt_t fsfilcnt_t;
typedef unsigned long int pthread_t;
union pthread_attr_t
{
  char __size[56];
  long int __align;
};
typedef union pthread_attr_t pthread_attr_t;
typedef struct __pthread_internal_list
{
  struct __pthread_internal_list *__prev;
  struct __pthread_internal_list *__next;
} __pthread_list_t;
typedef union
{
  struct __pthread_mutex_s
  {
    int __lock;
    unsigned int __count;
    int __owner;
    unsigned int __nusers;
    int __kind;
    short __spins;
    short __elision;
    __pthread_list_t __list;
  } __data;
  char __size[40];
  long int __align;
} pthread_mutex_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_mutexattr_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __futex;
    unsigned long long int __total_seq;
    unsigned long long int __wakeup_seq;
    unsigned long long int __woken_seq;
    void *__mutex;
    unsigned int __nwaiters;
    unsigned int __broadcast_seq;
  } __data;
  char __size[48];
  long long int __align;
} pthread_cond_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef int pthread_once_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __nr_readers;
    unsigned int __readers_wakeup;
    unsigned int __writer_wakeup;
    unsigned int __nr_readers_queued;
    unsigned int __nr_writers_queued;
    int __writer;
    int __shared;
    unsigned long int __pad1;
    unsigned long int __pad2;
    unsigned int __flags;
  } __data;
  char __size[56];
  long int __align;
} pthread_rwlock_t;
typedef union
{
  char __size[8];
  long int __align;
} pthread_rwlockattr_t;
typedef volatile int pthread_spinlock_t;
typedef union
{
  char __size[32];
  long int __align;
} pthread_barrier_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_barrierattr_t;
extern long int random (void);
extern void srandom (unsigned int __seed);
extern char *initstate (unsigned int __seed, char *__statebuf, size_t __statelen);
extern char *setstate (char *__statebuf);
struct random_data
{
  int32_t *fptr;
  int32_t *rptr;
  int32_t *state;
  int rand_type;
  int rand_deg;
  int rand_sep;
  int32_t *end_ptr;
};
extern int random_r (struct random_data *__buf, int32_t * __result);
extern int srandom_r (unsigned int __seed, struct random_data *__buf);
extern int initstate_r (unsigned int __seed, char *__statebuf, size_t __statelen, struct random_data *__buf);
extern int setstate_r (char *__statebuf, struct random_data *__buf);
extern int rand (void);
extern void srand (unsigned int __seed);
extern int rand_r (unsigned int *__seed);
extern double drand48 (void);
extern double erand48 (unsigned short int __xsubi[3]);
extern long int lrand48 (void);
extern long int nrand48 (unsigned short int __xsubi[3]);
extern long int mrand48 (void);
extern long int jrand48 (unsigned short int __xsubi[3]);
extern void srand48 (long int __seedval);
extern unsigned short int *seed48 (unsigned short int __seed16v[3]);
extern void lcong48 (unsigned short int __param[7]);
struct drand48_data
{
  unsigned short int __x[3];
  unsigned short int __old_x[3];
  unsigned short int __c;
  unsigned short int __init;
  unsigned long long int __a;
};
extern int drand48_r (struct drand48_data *__buffer, double *__result);
extern int erand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, double *__result);
extern int lrand48_r (struct drand48_data *__buffer, long int *__result);
extern int nrand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, long int *__result);
extern int mrand48_r (struct drand48_data *__buffer, long int *__result);
extern int jrand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, long int *__result);
extern int srand48_r (long int __seedval, struct drand48_data *__buffer);
extern int seed48_r (unsigned short int __seed16v[3], struct drand48_data *__buffer);
extern int lcong48_r (unsigned short int __param[7], struct drand48_data *__buffer);
extern void *malloc (size_t __size);
extern void *calloc (size_t __nmemb, size_t __size);
extern void *realloc (void *__ptr, size_t __size);
extern void free (void *__ptr);
extern void cfree (void *__ptr);
extern void *alloca (size_t __size);
extern void *valloc (size_t __size);
extern int posix_memalign (void **__memptr, size_t __alignment, size_t __size);
extern void abort (void);
extern int atexit (void (*__func) (void));
extern int on_exit (void (*__func) (int __status, void *__arg), void *__arg);
extern void exit (int __status);
extern void _Exit (int __status);
extern char *getenv (const char *__name);
extern int putenv (char *__string);
extern int setenv (const char *__name, const char *__value, int __replace);
extern int unsetenv (const char *__name);
extern int clearenv (void);
extern char *mktemp (char *__template);
extern int mkstemp (char *__template);
extern int mkstemps (char *__template, int __suffixlen);
extern char *mkdtemp (char *__template);
extern int system (const char *__command);
extern char *realpath (const char *__name, char *__resolved);
typedef int (*__compar_fn_t) (const void *, const void *);
extern void *bsearch (const void *__key, const void *__base, size_t __nmemb, size_t __size, __compar_fn_t __compar);
extern void qsort (void *__base, size_t __nmemb, size_t __size, __compar_fn_t __compar);
extern int abs (int __x);
extern long int labs (long int __x);
extern long long int llabs (long long int __x);
extern div_t div (int __numer, int __denom);
extern ldiv_t ldiv (long int __numer, long int __denom);
extern lldiv_t lldiv (long long int __numer, long long int __denom);
extern char *ecvt (double __value, int __ndigit, int *__decpt, int *__sign);
extern char *fcvt (double __value, int __ndigit, int *__decpt, int *__sign);
extern char *gcvt (double __value, int __ndigit, char *__buf);
extern char *qecvt (long double __value, int __ndigit, int *__decpt, int *__sign);
extern char *qfcvt (long double __value, int __ndigit, int *__decpt, int *__sign);
extern char *qgcvt (long double __value, int __ndigit, char *__buf);
extern int ecvt_r (double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int fcvt_r (double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int qecvt_r (long double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int qfcvt_r (long double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int mblen (const char *__s, size_t __n);
extern int mbtowc (wchar_t * __pwc, const char *__s, size_t __n);
extern int wctomb (char *__s, wchar_t __wchar);
extern size_t mbstowcs (wchar_t * __pwcs, const char *__s, size_t __n);
extern size_t wcstombs (char *__s, const wchar_t * __pwcs, size_t __n);
extern int rpmatch (const char *__response);
extern int getsubopt (char **__optionp, char *const *__tokens, char **__valuep);
extern int getloadavg (double __loadavg[], int __nelem);
extern void *memcpy (void *__dest, const void *__src, size_t __n);
extern void *memmove (void *__dest, const void *__src, size_t __n);
extern void *memccpy (void *__dest, const void *__src, int __c, size_t __n);
extern void *memset (void *__s, int __c, size_t __n);
extern int memcmp (const void *__s1, const void *__s2, size_t __n);
extern void *memchr (const void *__s, int __c, size_t __n);
extern char *strcpy (char *__dest, const char *__src);
extern char *strncpy (char *__dest, const char *__src, size_t __n);
extern char *strcat (char *__dest, const char *__src);
extern char *strncat (char *__dest, const char *__src, size_t __n);
extern int strcmp (const char *__s1, const char *__s2);
extern int strncmp (const char *__s1, const char *__s2, size_t __n);
extern int strcoll (const char *__s1, const char *__s2);
extern size_t strxfrm (char *__dest, const char *__src, size_t __n);
typedef struct __locale_struct
{
  struct __locale_data *__locales[13];
  const unsigned short int *__ctype_b;
  const int *__ctype_tolower;
  const int *__ctype_toupper;
  const char *__names[13];
} *__locale_t;
typedef __locale_t locale_t;
extern int strcoll_l (const char *__s1, const char *__s2, __locale_t __l);
extern size_t strxfrm_l (char *__dest, const char *__src, size_t __n, __locale_t __l);
extern char *strdup (const char *__s);
extern char *strndup (const char *__string, size_t __n);
extern char *strchr (const char *__s, int __c);
extern char *strrchr (const char *__s, int __c);
extern size_t strcspn (const char *__s, const char *__reject);
extern size_t strspn (const char *__s, const char *__accept);
extern char *strpbrk (const char *__s, const char *__accept);
extern char *strstr (const char *__haystack, const char *__needle);
extern char *strtok (char *__s, const char *__delim);
extern char *__strtok_r (char *__s, const char *__delim, char **__save_ptr);
extern char *strtok_r (char *__s, const char *__delim, char **__save_ptr);
extern size_t strlen (const char *__s);
extern size_t strnlen (const char *__string, size_t __maxlen);
extern char *strerror (int __errnum);
extern int strerror_r (int __errnum, char *__buf, size_t __buflen);
extern char *strerror_l (int __errnum, __locale_t __l);
extern void __bzero (void *__s, size_t __n);
extern void bcopy (const void *__src, void *__dest, size_t __n);
extern void bzero (void *__s, size_t __n);
extern int bcmp (const void *__s1, const void *__s2, size_t __n);
extern char *index (const char *__s, int __c);
extern char *rindex (const char *__s, int __c);
extern int ffs (int __i);
extern int strcasecmp (const char *__s1, const char *__s2);
extern int strncasecmp (const char *__s1, const char *__s2, size_t __n);
extern char *strsep (char **__stringp, const char *__delim);
extern char *strsignal (int __sig);
extern char *__stpcpy (char *__dest, const char *__src);
extern char *stpcpy (char *__dest, const char *__src);
extern char *__stpncpy (char *__dest, const char *__src, size_t __n);
extern char *stpncpy (char *__dest, const char *__src, size_t __n);
extern void *__rawmemchr (const void *__s, int __c);
extern char *__strdup (const char *__string);
extern char *__strndup (const char *__string, size_t __n);
typedef enum
{
  PTR_1sizeof_FUNC,
  free_FUNC,
  getenv_FUNC,
  malloc_FUNC,
  memmove__JJJ_FUNC,
  memmove__J_3BJ_FUNC,
  memmove__J_3CJ_FUNC,
  memmove__J_3DJ_FUNC,
  memmove__J_3FJ_FUNC,
  memmove__J_3IJ_FUNC,
  memmove__J_3JJ_FUNC,
  memmove__J_3SJ_FUNC,
  memmove___3BJJ_FUNC,
  memmove___3B_3CJ_FUNC,
  memmove___3CJJ_FUNC,
  memmove___3DJJ_FUNC,
  memmove___3FJJ_FUNC,
  memmove___3IJJ_FUNC,
  memmove___3I_3BJ_FUNC,
  memmove___3JJJ_FUNC,
  memmove___3SJJ_FUNC,
  memset_FUNC,
  strlen_FUNC
} C_FUNCS;
jint Java_org_eclipse_swt_internal_C_PTR_1sizeof (JNIEnv * env, jclass that)
{
  jint rc = 0;
  rc = (jint) sizeof (void *);
  return rc;
}
void Java_org_eclipse_swt_internal_C_free (JNIEnv * env, jclass that, jlong arg0)
{
  free ((void *) arg0);
}
jlong Java_org_eclipse_swt_internal_C_getenv (JNIEnv * env, jclass that, jbyteArray arg0)
{
  jbyte *lparg0 = ((void *) 0);
  jlong rc = 0;
  if (arg0)
    if ((lparg0 = (*env)->GetByteArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
      goto fail;
  rc = (jlong) getenv ((const char *) lparg0);
fail:
  if (arg0 && lparg0)
    (*env)->ReleaseByteArrayElements (env, arg0, lparg0, 0);
  return rc;
}
jlong Java_org_eclipse_swt_internal_C_malloc (JNIEnv * env, jclass that, jlong arg0)
{
  jlong rc = 0;
  rc = (jlong) malloc (arg0);
  return rc;
}
void
Java_org_eclipse_swt_internal_C_memmove__JJJ (JNIEnv * env, jclass that, jlong arg0, jlong arg1, jlong arg2)
{
  memmove ((void *) arg0, (const void *) arg1, (size_t) arg2);
}
void
Java_org_eclipse_swt_internal_C_memmove__J_3BJ (JNIEnv * env, jclass that, jlong arg0, jbyteArray arg1, jlong arg2)
{
  jbyte *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg1)
	if ((lparg1 = (*env)->GetByteArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) arg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseByteArrayElements (env, arg1, lparg1, 2);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove__J_3CJ (JNIEnv * env, jclass that, jlong arg0, jcharArray arg1, jlong arg2)
{
  jchar *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg1)
	if ((lparg1 = (*env)->GetCharArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) arg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseCharArrayElements (env, arg1, lparg1, 2);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove__J_3DJ (JNIEnv * env, jclass that, jlong arg0, jdoubleArray arg1, jlong arg2)
{
  jdouble *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg1)
	if ((lparg1 = (*env)->GetDoubleArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) arg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseDoubleArrayElements (env, arg1, lparg1, 2);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove__J_3FJ (JNIEnv * env, jclass that, jlong arg0, jfloatArray arg1, jlong arg2)
{
  jfloat *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg1)
	if ((lparg1 = (*env)->GetFloatArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) arg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseFloatArrayElements (env, arg1, lparg1, 2);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove__J_3IJ (JNIEnv * env, jclass that, jlong arg0, jintArray arg1, jlong arg2)
{
  jint *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg1)
	if ((lparg1 = (*env)->GetIntArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) arg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseIntArrayElements (env, arg1, lparg1, 2);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove__J_3JJ (JNIEnv * env, jclass that, jlong arg0, jlongArray arg1, jlong arg2)
{
  jlong *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg1)
	if ((lparg1 = (*env)->GetLongArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) arg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseLongArrayElements (env, arg1, lparg1, 2);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove__J_3SJ (JNIEnv * env, jclass that, jlong arg0, jshortArray arg1, jlong arg2)
{
  jshort *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg1)
	if ((lparg1 = (*env)->GetShortArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) arg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseShortArrayElements (env, arg1, lparg1, 2);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3BJJ (JNIEnv * env, jclass that, jbyteArray arg0, jlong arg1, jlong arg2)
{
  jbyte *lparg0 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetByteArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) arg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseByteArrayElements (env, arg0, lparg0, 0);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3B_3CJ (JNIEnv * env, jclass that, jbyteArray arg0, jcharArray arg1, jlong arg2)
{
  jbyte *lparg0 = ((void *) 0);
  jchar *lparg1 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
      if (arg1)
	if ((lparg1 = (*env)->GetPrimitiveArrayCritical (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetByteArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
      if (arg1)
	if ((lparg1 = (*env)->GetCharArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg1 && lparg1)
	(*env)->ReleasePrimitiveArrayCritical (env, arg1, lparg1, 2);
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg1 && lparg1)
	(*env)->ReleaseCharArrayElements (env, arg1, lparg1, 2);
      if (arg0 && lparg0)
	(*env)->ReleaseByteArrayElements (env, arg0, lparg0, 0);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3CJJ (JNIEnv * env, jclass that, jcharArray arg0, jlong arg1, jlong arg2)
{
  jchar *lparg0 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetCharArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) arg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseCharArrayElements (env, arg0, lparg0, 0);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3DJJ (JNIEnv * env, jclass that, jdoubleArray arg0, jlong arg1, jlong arg2)
{
  jdouble *lparg0 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetDoubleArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) arg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseDoubleArrayElements (env, arg0, lparg0, 0);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3FJJ (JNIEnv * env, jclass that, jfloatArray arg0, jlong arg1, jlong arg2)
{
  jfloat *lparg0 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetFloatArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) arg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseFloatArrayElements (env, arg0, lparg0, 0);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3IJJ (JNIEnv * env, jclass that, jintArray arg0, jlong arg1, jlong arg2)
{
  jint *lparg0 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetIntArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) arg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseIntArrayElements (env, arg0, lparg0, 0);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3I_3BJ (JNIEnv * env, jclass that, jintArray arg0, jbyteArray arg1, jlong arg2)
{
  jint *lparg0 = ((void *) 0);
  jbyte *lparg1 = ((void *) 0);
  if (arg1)
    if ((lparg1 = (*env)->GetByteArrayElements (env, arg1, ((void *) 0))) == ((void *) 0))
      goto fail;
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetIntArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) lparg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseIntArrayElements (env, arg0, lparg0, 0);
    }
  if (arg1 && lparg1)
    (*env)->ReleaseByteArrayElements (env, arg1, lparg1, 0);
}
void
Java_org_eclipse_swt_internal_C_memmove___3JJJ (JNIEnv * env, jclass that, jlongArray arg0, jlong arg1, jlong arg2)
{
  jlong *lparg0 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetLongArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) arg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseLongArrayElements (env, arg0, lparg0, 0);
    }
}
void
Java_org_eclipse_swt_internal_C_memmove___3SJJ (JNIEnv * env, jclass that, jshortArray arg0, jlong arg1, jlong arg2)
{
  jshort *lparg0 = ((void *) 0);
  if (IS_JNI_1_2)
    {
      if (arg0)
	if ((lparg0 = (*env)->GetPrimitiveArrayCritical (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  else
    {
      if (arg0)
	if ((lparg0 = (*env)->GetShortArrayElements (env, arg0, ((void *) 0))) == ((void *) 0))
	  goto fail;
    }
  memmove ((void *) lparg0, (const void *) arg1, (size_t) arg2);
fail:
  if (IS_JNI_1_2)
    {
      if (arg0 && lparg0)
	(*env)->ReleasePrimitiveArrayCritical (env, arg0, lparg0, 0);
    }
  else
    {
      if (arg0 && lparg0)
	(*env)->ReleaseShortArrayElements (env, arg0, lparg0, 0);
    }
}
jlong Java_org_eclipse_swt_internal_C_memset (JNIEnv * env, jclass that, jlong arg0, jint arg1, jlong arg2)
{
  jlong rc = 0;
  rc = (jlong) memset ((void *) arg0, arg1, (size_t) arg2);
  return rc;
}
jint Java_org_eclipse_swt_internal_C_strlen (JNIEnv * env, jclass that, jlong arg0)
{
  jint rc = 0;
  rc = (jint) strlen ((char *) arg0);
  return rc;
}
