typedef unsigned int size_t;
typedef int wchar_t;
typedef struct
{
  int quot;
  int rem;
} div_t;
typedef struct
{
  long int quot;
  long int rem;
} ldiv_t;
extern size_t __ctype_get_mb_cur_max (void);
extern double atof (const char *__nptr);
extern int atoi (const char *__nptr);
extern long int atol (const char *__nptr);
extern long long int atoll (const char *__nptr);
extern double strtod (const char *__nptr, char **__endptr);
extern long int strtol (const char *__nptr, char **__endptr, int __base);
extern unsigned long int strtoul (const char *__nptr, char **__endptr, int __base);
extern long long int strtoq (const char *__nptr, char **__endptr, int __base);
extern unsigned long long int strtouq (const char *__nptr, char **__endptr, int __base);
extern long long int strtoll (const char *__nptr, char **__endptr, int __base);
extern unsigned long long int strtoull (const char *__nptr, char **__endptr, int __base);
extern char *l64a (long int __n);
extern long int a64l (const char *__s);
typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef signed long long int __int64_t;
typedef unsigned long long int __uint64_t;
typedef long long int __quad_t;
typedef unsigned long long int __u_quad_t;
typedef __u_quad_t __dev_t;
typedef unsigned int __uid_t;
typedef unsigned int __gid_t;
typedef unsigned long int __ino_t;
typedef __u_quad_t __ino64_t;
typedef unsigned int __mode_t;
typedef unsigned int __nlink_t;
typedef long int __off_t;
typedef __quad_t __off64_t;
typedef int __pid_t;
typedef struct
{
  int __val[2];
} __fsid_t;
typedef long int __clock_t;
typedef unsigned long int __rlim_t;
typedef __u_quad_t __rlim64_t;
typedef unsigned int __id_t;
typedef long int __time_t;
typedef unsigned int __useconds_t;
typedef long int __suseconds_t;
typedef int __daddr_t;
typedef long int __swblk_t;
typedef int __key_t;
typedef int __clockid_t;
typedef void *__timer_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __quad_t __blkcnt64_t;
typedef unsigned long int __fsblkcnt_t;
typedef __u_quad_t __fsblkcnt64_t;
typedef unsigned long int __fsfilcnt_t;
typedef __u_quad_t __fsfilcnt64_t;
typedef int __ssize_t;
typedef __off64_t __loff_t;
typedef __quad_t *__qaddr_t;
typedef char *__caddr_t;
typedef int __intptr_t;
typedef unsigned int __socklen_t;
typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __uid_t uid_t;
typedef __off_t off_t;
typedef __pid_t pid_t;
typedef __id_t id_t;
typedef __ssize_t ssize_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;
typedef __time_t time_t;
typedef __clockid_t clockid_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef int int8_t;
typedef int int16_t;
typedef int int32_t;
typedef int int64_t;
typedef unsigned int u_int8_t;
typedef unsigned int u_int16_t;
typedef unsigned int u_int32_t;
typedef unsigned int u_int64_t;
typedef int register_t;
typedef int __sig_atomic_t;
typedef struct
{
  unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
} __sigset_t;
typedef __sigset_t sigset_t;
struct timespec
{
  __time_t tv_sec;
  long int tv_nsec;
};
struct timeval
{
  __time_t tv_sec;
  __suseconds_t tv_usec;
};
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
{
  __fd_mask __fds_bits[1024 / (8 * sizeof (__fd_mask))];
}
fd_set;
typedef __fd_mask fd_mask;
extern int select (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, struct timeval *__timeout);
extern int pselect (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, const struct timespec *__timeout, const __sigset_t * __sigmask);
extern unsigned int gnu_dev_major (unsigned long long int __dev);
extern unsigned int gnu_dev_minor (unsigned long long int __dev);
extern unsigned long long int gnu_dev_makedev (unsigned int __major, unsigned int __minor);
typedef __blkcnt_t blkcnt_t;
typedef __fsblkcnt_t fsblkcnt_t;
typedef __fsfilcnt_t fsfilcnt_t;
typedef unsigned long int pthread_t;
typedef union
{
  char __size[36];
  long int __align;
} pthread_attr_t;
typedef struct __pthread_internal_slist
{
  struct __pthread_internal_slist *__next;
} __pthread_slist_t;
typedef union
{
  struct __pthread_mutex_s
  {
    int __lock;
    unsigned int __count;
    int __owner;
    int __kind;
    unsigned int __nusers;
    union
    {
      int __spins;
      __pthread_slist_t __list;
    };
  } __data;
  char __size[24];
  long int __align;
} pthread_mutex_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_mutexattr_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __futex;
    unsigned long long int __total_seq;
    unsigned long long int __wakeup_seq;
    unsigned long long int __woken_seq;
    void *__mutex;
    unsigned int __nwaiters;
    unsigned int __broadcast_seq;
  } __data;
  char __size[48];
  long long int __align;
} pthread_cond_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef int pthread_once_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __nr_readers;
    unsigned int __readers_wakeup;
    unsigned int __writer_wakeup;
    unsigned int __nr_readers_queued;
    unsigned int __nr_writers_queued;
    unsigned char __flags;
    unsigned char __shared;
    unsigned char __pad1;
    unsigned char __pad2;
    int __writer;
  } __data;
  char __size[32];
  long int __align;
} pthread_rwlock_t;
typedef union
{
  char __size[8];
  long int __align;
} pthread_rwlockattr_t;
typedef volatile int pthread_spinlock_t;
typedef union
{
  char __size[20];
  long int __align;
} pthread_barrier_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_barrierattr_t;
extern long int random (void);
extern void srandom (unsigned int __seed);
extern char *initstate (unsigned int __seed, char *__statebuf, size_t __statelen);
extern char *setstate (char *__statebuf);
struct random_data
{
  int32_t *fptr;
  int32_t *rptr;
  int32_t *state;
  int rand_type;
  int rand_deg;
  int rand_sep;
  int32_t *end_ptr;
};
extern int random_r (struct random_data *__buf, int32_t * __result);
extern int srandom_r (unsigned int __seed, struct random_data *__buf);
extern int initstate_r (unsigned int __seed, char *__statebuf, size_t __statelen, struct random_data *__buf);
extern int setstate_r (char *__statebuf, struct random_data *__buf);
extern int rand (void);
extern void srand (unsigned int __seed);
extern int rand_r (unsigned int *__seed);
extern double drand48 (void);
extern double erand48 (unsigned short int __xsubi[3]);
extern long int lrand48 (void);
extern long int nrand48 (unsigned short int __xsubi[3]);
extern long int mrand48 (void);
extern long int jrand48 (unsigned short int __xsubi[3]);
extern void srand48 (long int __seedval);
extern unsigned short int *seed48 (unsigned short int __seed16v[3]);
extern void lcong48 (unsigned short int __param[7]);
struct drand48_data
{
  unsigned short int __x[3];
  unsigned short int __old_x[3];
  unsigned short int __c;
  unsigned short int __init;
  unsigned long long int __a;
};
extern int drand48_r (struct drand48_data *__buffer, double *__result);
extern int erand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, double *__result);
extern int lrand48_r (struct drand48_data *__buffer, long int *__result);
extern int nrand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, long int *__result);
extern int mrand48_r (struct drand48_data *__buffer, long int *__result);
extern int jrand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, long int *__result);
extern int srand48_r (long int __seedval, struct drand48_data *__buffer);
extern int seed48_r (unsigned short int __seed16v[3], struct drand48_data *__buffer);
extern int lcong48_r (unsigned short int __param[7], struct drand48_data *__buffer);
extern void *malloc (size_t __size);
extern void *calloc (size_t __nmemb, size_t __size);
extern void *realloc (void *__ptr, size_t __size);
extern void free (void *__ptr);
extern void cfree (void *__ptr);
extern void *alloca (size_t __size);
extern void *valloc (size_t __size);
extern int posix_memalign (void **__memptr, size_t __alignment, size_t __size);
extern void abort (void);
extern int atexit (void (*__func) (void));
extern int on_exit (void (*__func) (int __status, void *__arg), void *__arg);
extern void exit (int __status);
extern char *getenv (const char *__name);
extern char *__secure_getenv (const char *__name);
extern int putenv (char *__string);
extern int setenv (const char *__name, const char *__value, int __replace);
extern int unsetenv (const char *__name);
extern int clearenv (void);
extern char *mktemp (char *__template);
extern int mkstemp (char *__template);
extern char *mkdtemp (char *__template);
extern int system (const char *__command);
extern char *realpath (const char *__name, char *__resolved);
typedef int (*__compar_fn_t) (const void *, const void *);
extern void *bsearch (const void *__key, const void *__base, size_t __nmemb, size_t __size, __compar_fn_t __compar);
extern void qsort (void *__base, size_t __nmemb, size_t __size, __compar_fn_t __compar);
extern int abs (int __x);
extern long int labs (long int __x);
extern div_t div (int __numer, int __denom);
extern ldiv_t ldiv (long int __numer, long int __denom);
extern char *ecvt (double __value, int __ndigit, int *__decpt, int *__sign);
extern char *fcvt (double __value, int __ndigit, int *__decpt, int *__sign);
extern char *gcvt (double __value, int __ndigit, char *__buf);
extern char *qecvt (long double __value, int __ndigit, int *__decpt, int *__sign);
extern char *qfcvt (long double __value, int __ndigit, int *__decpt, int *__sign);
extern char *qgcvt (long double __value, int __ndigit, char *__buf);
extern int ecvt_r (double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int fcvt_r (double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int qecvt_r (long double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int qfcvt_r (long double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int mblen (const char *__s, size_t __n);
extern int mbtowc (wchar_t * __pwc, const char *__s, size_t __n);
extern int wctomb (char *__s, wchar_t __wchar);
extern size_t mbstowcs (wchar_t * __pwcs, const char *__s, size_t __n);
extern size_t wcstombs (char *__s, const wchar_t * __pwcs, size_t __n);
extern int rpmatch (const char *__response);
extern int posix_openpt (int __oflag);
extern int getloadavg (double __loadavg[], int __nelem);
extern void __assert_fail (const char *__assertion, const char *__file, unsigned int __line, const char *__function);
extern void __assert_perror_fail (int __errnum, const char *__file, unsigned int __line, const char *__function);
extern void __assert (const char *__assertion, const char *__file, int __line);
struct _IO_FILE;
typedef struct _IO_FILE FILE;
typedef struct _IO_FILE __FILE;
typedef struct
{
  int __count;
  union
  {
    unsigned int __wch;
    char __wchb[4];
  } __value;
} __mbstate_t;
typedef struct
{
  __off_t __pos;
  __mbstate_t __state;
} _G_fpos_t;
typedef struct
{
  __off64_t __pos;
  __mbstate_t __state;
} _G_fpos64_t;
typedef int _G_int16_t;
typedef int _G_int32_t;
typedef unsigned int _G_uint16_t;
typedef unsigned int _G_uint32_t;
typedef __builtin_va_list __gnuc_va_list;
struct _IO_jump_t;
struct _IO_FILE;
typedef void _IO_lock_t;
struct _IO_marker
{
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
enum __codecvt_result
{
  __codecvt_ok,
  __codecvt_partial,
  __codecvt_error,
  __codecvt_noconv
};
struct _IO_FILE
{
  int _flags;
  char *_IO_read_ptr;
  char *_IO_read_end;
  char *_IO_read_base;
  char *_IO_write_base;
  char *_IO_write_ptr;
  char *_IO_write_end;
  char *_IO_buf_base;
  char *_IO_buf_end;
  char *_IO_save_base;
  char *_IO_backup_base;
  char *_IO_save_end;
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _flags2;
  __off_t _old_offset;
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  void *__pad3;
  void *__pad4;
  size_t __pad5;
  int _mode;
  char _unused2[15 * sizeof (int) - 4 * sizeof (void *) - sizeof (size_t)];
};
typedef struct _IO_FILE _IO_FILE;
struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_2_1_stdin_;
extern struct _IO_FILE_plus _IO_2_1_stdout_;
extern struct _IO_FILE_plus _IO_2_1_stderr_;
typedef __ssize_t __io_read_fn (void *__cookie, char *__buf, size_t __nbytes);
typedef __ssize_t __io_write_fn (void *__cookie, const char *__buf, size_t __n);
typedef int __io_seek_fn (void *__cookie, __off64_t * __pos, int __w);
typedef int __io_close_fn (void *__cookie);
extern int __underflow (_IO_FILE *);
extern int __uflow (_IO_FILE *);
extern int __overflow (_IO_FILE *, int);
extern int _IO_getc (_IO_FILE * __fp);
extern int _IO_putc (int __c, _IO_FILE * __fp);
extern int _IO_feof (_IO_FILE * __fp);
extern int _IO_ferror (_IO_FILE * __fp);
extern int _IO_peekc_locked (_IO_FILE * __fp);
extern void _IO_flockfile (_IO_FILE *);
extern void _IO_funlockfile (_IO_FILE *);
extern int _IO_ftrylockfile (_IO_FILE *);
extern int _IO_vfscanf (_IO_FILE *, const char *, __gnuc_va_list, int *);
extern int _IO_vfprintf (_IO_FILE *, const char *, __gnuc_va_list);
extern __ssize_t _IO_padn (_IO_FILE *, int, __ssize_t);
extern size_t _IO_sgetn (_IO_FILE *, void *, size_t);
extern __off64_t _IO_seekoff (_IO_FILE *, __off64_t, int, int);
extern __off64_t _IO_seekpos (_IO_FILE *, __off64_t, int);
extern void _IO_free_backup_area (_IO_FILE *);
typedef _G_fpos_t fpos_t;
extern struct _IO_FILE *stdin;
extern struct _IO_FILE *stdout;
extern struct _IO_FILE *stderr;
extern int remove (const char *__filename);
extern int rename (const char *__old, const char *__new);
extern FILE *tmpfile (void);
extern char *tmpnam (char *__s);
extern char *tmpnam_r (char *__s);
extern char *tempnam (const char *__dir, const char *__pfx);
extern int fclose (FILE * __stream);
extern int fflush (FILE * __stream);
extern int fflush_unlocked (FILE * __stream);
extern FILE *fopen (const char *__filename, const char *__modes);
extern FILE *freopen (const char *__filename, const char *__modes, FILE * __stream);
extern FILE *fdopen (int __fd, const char *__modes);
extern void setbuf (FILE * __stream, char *__buf);
extern int setvbuf (FILE * __stream, char *__buf, int __modes, size_t __n);
extern void setbuffer (FILE * __stream, char *__buf, size_t __size);
extern void setlinebuf (FILE * __stream);
extern int fprintf (FILE * __stream, const char *__format, ...);
extern int printf (const char *__format, ...);
extern int sprintf (char *__s, const char *__format, ...);
extern int vfprintf (FILE * __s, const char *__format, __gnuc_va_list __arg);
extern int vprintf (const char *__format, __gnuc_va_list __arg);
extern int vsprintf (char *__s, const char *__format, __gnuc_va_list __arg);
extern int snprintf (char *__s, size_t __maxlen, const char *__format, ...);
extern int vsnprintf (char *__s, size_t __maxlen, const char *__format, __gnuc_va_list __arg);
extern int fscanf (FILE * __stream, const char *__format, ...);
extern int scanf (const char *__format, ...);
extern int sscanf (const char *__s, const char *__format, ...);
extern int fgetc (FILE * __stream);
extern int getc (FILE * __stream);
extern int getchar (void);
extern int getc_unlocked (FILE * __stream);
extern int getchar_unlocked (void);
extern int fgetc_unlocked (FILE * __stream);
extern int fputc (int __c, FILE * __stream);
extern int putc (int __c, FILE * __stream);
extern int putchar (int __c);
extern int fputc_unlocked (int __c, FILE * __stream);
extern int putc_unlocked (int __c, FILE * __stream);
extern int putchar_unlocked (int __c);
extern int getw (FILE * __stream);
extern int putw (int __w, FILE * __stream);
extern char *fgets (char *__s, int __n, FILE * __stream);
extern char *gets (char *__s);
extern int fputs (const char *__s, FILE * __stream);
extern int puts (const char *__s);
extern int ungetc (int __c, FILE * __stream);
extern size_t fread (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t fwrite (const void *__ptr, size_t __size, size_t __n, FILE * __s);
extern size_t fread_unlocked (void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern size_t fwrite_unlocked (const void *__ptr, size_t __size, size_t __n, FILE * __stream);
extern int fseek (FILE * __stream, long int __off, int __whence);
extern long int ftell (FILE * __stream);
extern void rewind (FILE * __stream);
extern int fseeko (FILE * __stream, __off_t __off, int __whence);
extern __off_t ftello (FILE * __stream);
extern int fgetpos (FILE * __stream, fpos_t * __pos);
extern int fsetpos (FILE * __stream, const fpos_t * __pos);
extern void clearerr (FILE * __stream);
extern int feof (FILE * __stream);
extern int ferror (FILE * __stream);
extern void clearerr_unlocked (FILE * __stream);
extern int feof_unlocked (FILE * __stream);
extern int ferror_unlocked (FILE * __stream);
extern void perror (const char *__s);
extern int sys_nerr;
extern const char *const sys_errlist[];
extern int fileno (FILE * __stream);
extern int fileno_unlocked (FILE * __stream);
extern FILE *popen (const char *__command, const char *__modes);
extern int pclose (FILE * __stream);
extern char *ctermid (char *__s);
extern void flockfile (FILE * __stream);
extern int ftrylockfile (FILE * __stream);
extern void funlockfile (FILE * __stream);
typedef __gnuc_va_list va_list;
typedef int jint;
typedef long long jlong;
typedef signed char jbyte;
typedef unsigned char jboolean;
typedef unsigned short jchar;
typedef short jshort;
typedef float jfloat;
typedef double jdouble;
typedef jint jsize;
struct _jobject;
typedef struct _jobject *jobject;
typedef jobject jclass;
typedef jobject jthrowable;
typedef jobject jstring;
typedef jobject jarray;
typedef jarray jbooleanArray;
typedef jarray jbyteArray;
typedef jarray jcharArray;
typedef jarray jshortArray;
typedef jarray jintArray;
typedef jarray jlongArray;
typedef jarray jfloatArray;
typedef jarray jdoubleArray;
typedef jarray jobjectArray;
typedef jobject jweak;
typedef union jvalue
{
  jboolean z;
  jbyte b;
  jchar c;
  jshort s;
  jint i;
  jlong j;
  jfloat f;
  jdouble d;
  jobject l;
} jvalue;
struct _jfieldID;
typedef struct _jfieldID *jfieldID;
struct _jmethodID;
typedef struct _jmethodID *jmethodID;
typedef enum _jobjectType
{
  JNIInvalidRefType = 0,
  JNILocalRefType = 1,
  JNIGlobalRefType = 2,
  JNIWeakGlobalRefType = 3
} jobjectRefType;
typedef struct
{
  char *name;
  char *signature;
  void *fnPtr;
} JNINativeMethod;
struct JNINativeInterface_;
struct JNIEnv_;
typedef const struct JNINativeInterface_ *JNIEnv;
struct JNIInvokeInterface_;
struct JavaVM_;
typedef const struct JNIInvokeInterface_ *JavaVM;
struct JNINativeInterface_
{
  void *reserved0;
  void *reserved1;
  void *reserved2;
  void *reserved3;
    jint (*GetVersion) (JNIEnv * env);
    jclass (*DefineClass) (JNIEnv * env, const char *name, jobject loader, const jbyte * buf, jsize len);
    jclass (*FindClass) (JNIEnv * env, const char *name);
    jmethodID (*FromReflectedMethod) (JNIEnv * env, jobject method);
    jfieldID (*FromReflectedField) (JNIEnv * env, jobject field);
    jobject (*ToReflectedMethod) (JNIEnv * env, jclass cls, jmethodID methodID, jboolean isStatic);
    jclass (*GetSuperclass) (JNIEnv * env, jclass sub);
    jboolean (*IsAssignableFrom) (JNIEnv * env, jclass sub, jclass sup);
    jobject (*ToReflectedField) (JNIEnv * env, jclass cls, jfieldID fieldID, jboolean isStatic);
    jint (*Throw) (JNIEnv * env, jthrowable obj);
    jint (*ThrowNew) (JNIEnv * env, jclass clazz, const char *msg);
    jthrowable (*ExceptionOccurred) (JNIEnv * env);
  void (*ExceptionDescribe) (JNIEnv * env);
  void (*ExceptionClear) (JNIEnv * env);
  void (*FatalError) (JNIEnv * env, const char *msg);
    jint (*PushLocalFrame) (JNIEnv * env, jint capacity);
    jobject (*PopLocalFrame) (JNIEnv * env, jobject result);
    jobject (*NewGlobalRef) (JNIEnv * env, jobject lobj);
  void (*DeleteGlobalRef) (JNIEnv * env, jobject gref);
  void (*DeleteLocalRef) (JNIEnv * env, jobject obj);
    jboolean (*IsSameObject) (JNIEnv * env, jobject obj1, jobject obj2);
    jobject (*NewLocalRef) (JNIEnv * env, jobject ref);
    jint (*EnsureLocalCapacity) (JNIEnv * env, jint capacity);
    jobject (*AllocObject) (JNIEnv * env, jclass clazz);
    jobject (*NewObject) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jobject (*NewObjectV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jobject (*NewObjectA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jclass (*GetObjectClass) (JNIEnv * env, jobject obj);
    jboolean (*IsInstanceOf) (JNIEnv * env, jobject obj, jclass clazz);
    jmethodID (*GetMethodID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*CallObjectMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jobject (*CallObjectMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jobject (*CallObjectMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jboolean (*CallBooleanMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jboolean (*CallBooleanMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jboolean (*CallBooleanMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jbyte (*CallByteMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jbyte (*CallByteMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jbyte (*CallByteMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jchar (*CallCharMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jchar (*CallCharMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jchar (*CallCharMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jshort (*CallShortMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jshort (*CallShortMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jshort (*CallShortMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jint (*CallIntMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jint (*CallIntMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jint (*CallIntMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jlong (*CallLongMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jlong (*CallLongMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jlong (*CallLongMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jfloat (*CallFloatMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jfloat (*CallFloatMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jfloat (*CallFloatMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jdouble (*CallDoubleMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
    jdouble (*CallDoubleMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
    jdouble (*CallDoubleMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
  void (*CallVoidMethod) (JNIEnv * env, jobject obj, jmethodID methodID, ...);
  void (*CallVoidMethodV) (JNIEnv * env, jobject obj, jmethodID methodID, va_list args);
  void (*CallVoidMethodA) (JNIEnv * env, jobject obj, jmethodID methodID, const jvalue * args);
    jobject (*CallNonvirtualObjectMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jobject (*CallNonvirtualObjectMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jobject (*CallNonvirtualObjectMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jboolean (*CallNonvirtualBooleanMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jboolean (*CallNonvirtualBooleanMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jboolean (*CallNonvirtualBooleanMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jbyte (*CallNonvirtualByteMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jbyte (*CallNonvirtualByteMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jbyte (*CallNonvirtualByteMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jchar (*CallNonvirtualCharMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jchar (*CallNonvirtualCharMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jchar (*CallNonvirtualCharMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jshort (*CallNonvirtualShortMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jshort (*CallNonvirtualShortMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jshort (*CallNonvirtualShortMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jint (*CallNonvirtualIntMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jint (*CallNonvirtualIntMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jint (*CallNonvirtualIntMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jlong (*CallNonvirtualLongMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jlong (*CallNonvirtualLongMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jlong (*CallNonvirtualLongMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jfloat (*CallNonvirtualFloatMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jfloat (*CallNonvirtualFloatMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jfloat (*CallNonvirtualFloatMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jdouble (*CallNonvirtualDoubleMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
    jdouble (*CallNonvirtualDoubleMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
    jdouble (*CallNonvirtualDoubleMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
  void (*CallNonvirtualVoidMethod) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, ...);
  void (*CallNonvirtualVoidMethodV) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, va_list args);
  void (*CallNonvirtualVoidMethodA) (JNIEnv * env, jobject obj, jclass clazz, jmethodID methodID, const jvalue * args);
    jfieldID (*GetFieldID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*GetObjectField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jboolean (*GetBooleanField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jbyte (*GetByteField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jchar (*GetCharField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jshort (*GetShortField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jint (*GetIntField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jlong (*GetLongField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jfloat (*GetFloatField) (JNIEnv * env, jobject obj, jfieldID fieldID);
    jdouble (*GetDoubleField) (JNIEnv * env, jobject obj, jfieldID fieldID);
  void (*SetObjectField) (JNIEnv * env, jobject obj, jfieldID fieldID, jobject val);
  void (*SetBooleanField) (JNIEnv * env, jobject obj, jfieldID fieldID, jboolean val);
  void (*SetByteField) (JNIEnv * env, jobject obj, jfieldID fieldID, jbyte val);
  void (*SetCharField) (JNIEnv * env, jobject obj, jfieldID fieldID, jchar val);
  void (*SetShortField) (JNIEnv * env, jobject obj, jfieldID fieldID, jshort val);
  void (*SetIntField) (JNIEnv * env, jobject obj, jfieldID fieldID, jint val);
  void (*SetLongField) (JNIEnv * env, jobject obj, jfieldID fieldID, jlong val);
  void (*SetFloatField) (JNIEnv * env, jobject obj, jfieldID fieldID, jfloat val);
  void (*SetDoubleField) (JNIEnv * env, jobject obj, jfieldID fieldID, jdouble val);
    jmethodID (*GetStaticMethodID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*CallStaticObjectMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jobject (*CallStaticObjectMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jobject (*CallStaticObjectMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jboolean (*CallStaticBooleanMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jboolean (*CallStaticBooleanMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jboolean (*CallStaticBooleanMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jbyte (*CallStaticByteMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jbyte (*CallStaticByteMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jbyte (*CallStaticByteMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jchar (*CallStaticCharMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jchar (*CallStaticCharMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jchar (*CallStaticCharMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jshort (*CallStaticShortMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jshort (*CallStaticShortMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jshort (*CallStaticShortMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jint (*CallStaticIntMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jint (*CallStaticIntMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jint (*CallStaticIntMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jlong (*CallStaticLongMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jlong (*CallStaticLongMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jlong (*CallStaticLongMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jfloat (*CallStaticFloatMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jfloat (*CallStaticFloatMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jfloat (*CallStaticFloatMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
    jdouble (*CallStaticDoubleMethod) (JNIEnv * env, jclass clazz, jmethodID methodID, ...);
    jdouble (*CallStaticDoubleMethodV) (JNIEnv * env, jclass clazz, jmethodID methodID, va_list args);
    jdouble (*CallStaticDoubleMethodA) (JNIEnv * env, jclass clazz, jmethodID methodID, const jvalue * args);
  void (*CallStaticVoidMethod) (JNIEnv * env, jclass cls, jmethodID methodID, ...);
  void (*CallStaticVoidMethodV) (JNIEnv * env, jclass cls, jmethodID methodID, va_list args);
  void (*CallStaticVoidMethodA) (JNIEnv * env, jclass cls, jmethodID methodID, const jvalue * args);
    jfieldID (*GetStaticFieldID) (JNIEnv * env, jclass clazz, const char *name, const char *sig);
    jobject (*GetStaticObjectField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jboolean (*GetStaticBooleanField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jbyte (*GetStaticByteField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jchar (*GetStaticCharField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jshort (*GetStaticShortField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jint (*GetStaticIntField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jlong (*GetStaticLongField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jfloat (*GetStaticFloatField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
    jdouble (*GetStaticDoubleField) (JNIEnv * env, jclass clazz, jfieldID fieldID);
  void (*SetStaticObjectField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jobject value);
  void (*SetStaticBooleanField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jboolean value);
  void (*SetStaticByteField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jbyte value);
  void (*SetStaticCharField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jchar value);
  void (*SetStaticShortField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jshort value);
  void (*SetStaticIntField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jint value);
  void (*SetStaticLongField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jlong value);
  void (*SetStaticFloatField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jfloat value);
  void (*SetStaticDoubleField) (JNIEnv * env, jclass clazz, jfieldID fieldID, jdouble value);
    jstring (*NewString) (JNIEnv * env, const jchar * unicode, jsize len);
    jsize (*GetStringLength) (JNIEnv * env, jstring str);
  const jchar *(*GetStringChars) (JNIEnv * env, jstring str, jboolean * isCopy);
  void (*ReleaseStringChars) (JNIEnv * env, jstring str, const jchar * chars);
    jstring (*NewStringUTF) (JNIEnv * env, const char *utf);
    jsize (*GetStringUTFLength) (JNIEnv * env, jstring str);
  const char *(*GetStringUTFChars) (JNIEnv * env, jstring str, jboolean * isCopy);
  void (*ReleaseStringUTFChars) (JNIEnv * env, jstring str, const char *chars);
    jsize (*GetArrayLength) (JNIEnv * env, jarray array);
    jobjectArray (*NewObjectArray) (JNIEnv * env, jsize len, jclass clazz, jobject init);
    jobject (*GetObjectArrayElement) (JNIEnv * env, jobjectArray array, jsize index);
  void (*SetObjectArrayElement) (JNIEnv * env, jobjectArray array, jsize index, jobject val);
    jbooleanArray (*NewBooleanArray) (JNIEnv * env, jsize len);
    jbyteArray (*NewByteArray) (JNIEnv * env, jsize len);
    jcharArray (*NewCharArray) (JNIEnv * env, jsize len);
    jshortArray (*NewShortArray) (JNIEnv * env, jsize len);
    jintArray (*NewIntArray) (JNIEnv * env, jsize len);
    jlongArray (*NewLongArray) (JNIEnv * env, jsize len);
    jfloatArray (*NewFloatArray) (JNIEnv * env, jsize len);
    jdoubleArray (*NewDoubleArray) (JNIEnv * env, jsize len);
  jboolean *(*GetBooleanArrayElements) (JNIEnv * env, jbooleanArray array, jboolean * isCopy);
  jbyte *(*GetByteArrayElements) (JNIEnv * env, jbyteArray array, jboolean * isCopy);
  jchar *(*GetCharArrayElements) (JNIEnv * env, jcharArray array, jboolean * isCopy);
  jshort *(*GetShortArrayElements) (JNIEnv * env, jshortArray array, jboolean * isCopy);
  jint *(*GetIntArrayElements) (JNIEnv * env, jintArray array, jboolean * isCopy);
  jlong *(*GetLongArrayElements) (JNIEnv * env, jlongArray array, jboolean * isCopy);
  jfloat *(*GetFloatArrayElements) (JNIEnv * env, jfloatArray array, jboolean * isCopy);
  jdouble *(*GetDoubleArrayElements) (JNIEnv * env, jdoubleArray array, jboolean * isCopy);
  void (*ReleaseBooleanArrayElements) (JNIEnv * env, jbooleanArray array, jboolean * elems, jint mode);
  void (*ReleaseByteArrayElements) (JNIEnv * env, jbyteArray array, jbyte * elems, jint mode);
  void (*ReleaseCharArrayElements) (JNIEnv * env, jcharArray array, jchar * elems, jint mode);
  void (*ReleaseShortArrayElements) (JNIEnv * env, jshortArray array, jshort * elems, jint mode);
  void (*ReleaseIntArrayElements) (JNIEnv * env, jintArray array, jint * elems, jint mode);
  void (*ReleaseLongArrayElements) (JNIEnv * env, jlongArray array, jlong * elems, jint mode);
  void (*ReleaseFloatArrayElements) (JNIEnv * env, jfloatArray array, jfloat * elems, jint mode);
  void (*ReleaseDoubleArrayElements) (JNIEnv * env, jdoubleArray array, jdouble * elems, jint mode);
  void (*GetBooleanArrayRegion) (JNIEnv * env, jbooleanArray array, jsize start, jsize l, jboolean * buf);
  void (*GetByteArrayRegion) (JNIEnv * env, jbyteArray array, jsize start, jsize len, jbyte * buf);
  void (*GetCharArrayRegion) (JNIEnv * env, jcharArray array, jsize start, jsize len, jchar * buf);
  void (*GetShortArrayRegion) (JNIEnv * env, jshortArray array, jsize start, jsize len, jshort * buf);
  void (*GetIntArrayRegion) (JNIEnv * env, jintArray array, jsize start, jsize len, jint * buf);
  void (*GetLongArrayRegion) (JNIEnv * env, jlongArray array, jsize start, jsize len, jlong * buf);
  void (*GetFloatArrayRegion) (JNIEnv * env, jfloatArray array, jsize start, jsize len, jfloat * buf);
  void (*GetDoubleArrayRegion) (JNIEnv * env, jdoubleArray array, jsize start, jsize len, jdouble * buf);
  void (*SetBooleanArrayRegion) (JNIEnv * env, jbooleanArray array, jsize start, jsize l, const jboolean * buf);
  void (*SetByteArrayRegion) (JNIEnv * env, jbyteArray array, jsize start, jsize len, const jbyte * buf);
  void (*SetCharArrayRegion) (JNIEnv * env, jcharArray array, jsize start, jsize len, const jchar * buf);
  void (*SetShortArrayRegion) (JNIEnv * env, jshortArray array, jsize start, jsize len, const jshort * buf);
  void (*SetIntArrayRegion) (JNIEnv * env, jintArray array, jsize start, jsize len, const jint * buf);
  void (*SetLongArrayRegion) (JNIEnv * env, jlongArray array, jsize start, jsize len, const jlong * buf);
  void (*SetFloatArrayRegion) (JNIEnv * env, jfloatArray array, jsize start, jsize len, const jfloat * buf);
  void (*SetDoubleArrayRegion) (JNIEnv * env, jdoubleArray array, jsize start, jsize len, const jdouble * buf);
    jint (*RegisterNatives) (JNIEnv * env, jclass clazz, const JNINativeMethod * methods, jint nMethods);
    jint (*UnregisterNatives) (JNIEnv * env, jclass clazz);
    jint (*MonitorEnter) (JNIEnv * env, jobject obj);
    jint (*MonitorExit) (JNIEnv * env, jobject obj);
    jint (*GetJavaVM) (JNIEnv * env, JavaVM ** vm);
  void (*GetStringRegion) (JNIEnv * env, jstring str, jsize start, jsize len, jchar * buf);
  void (*GetStringUTFRegion) (JNIEnv * env, jstring str, jsize start, jsize len, char *buf);
  void *(*GetPrimitiveArrayCritical) (JNIEnv * env, jarray array, jboolean * isCopy);
  void (*ReleasePrimitiveArrayCritical) (JNIEnv * env, jarray array, void *carray, jint mode);
  const jchar *(*GetStringCritical) (JNIEnv * env, jstring string, jboolean * isCopy);
  void (*ReleaseStringCritical) (JNIEnv * env, jstring string, const jchar * cstring);
    jweak (*NewWeakGlobalRef) (JNIEnv * env, jobject obj);
  void (*DeleteWeakGlobalRef) (JNIEnv * env, jweak ref);
    jboolean (*ExceptionCheck) (JNIEnv * env);
    jobject (*NewDirectByteBuffer) (JNIEnv * env, void *address, jlong capacity);
  void *(*GetDirectBufferAddress) (JNIEnv * env, jobject buf);
    jlong (*GetDirectBufferCapacity) (JNIEnv * env, jobject buf);
    jobjectRefType (*GetObjectRefType) (JNIEnv * env, jobject obj);
};
struct JNIEnv_
{
  const struct JNINativeInterface_ *functions;
};
typedef struct JavaVMOption
{
  char *optionString;
  void *extraInfo;
} JavaVMOption;
typedef struct JavaVMInitArgs
{
  jint version;
  jint nOptions;
  JavaVMOption *options;
  jboolean ignoreUnrecognized;
} JavaVMInitArgs;
typedef struct JavaVMAttachArgs
{
  jint version;
  char *name;
  jobject group;
} JavaVMAttachArgs;
struct JNIInvokeInterface_
{
  void *reserved0;
  void *reserved1;
  void *reserved2;
    jint (*DestroyJavaVM) (JavaVM * vm);
    jint (*AttachCurrentThread) (JavaVM * vm, void **penv, void *args);
    jint (*DetachCurrentThread) (JavaVM * vm);
    jint (*GetEnv) (JavaVM * vm, void **penv, jint version);
    jint (*AttachCurrentThreadAsDaemon) (JavaVM * vm, void **penv, void *args);
};
struct JavaVM_
{
  const struct JNIInvokeInterface_ *functions;
};
jint JNI_GetDefaultJavaVMInitArgs (void *args);
jint JNI_CreateJavaVM (JavaVM ** pvm, void **penv, void *args);
jint JNI_GetCreatedJavaVMs (JavaVM **, jsize, jsize *);
jint JNI_OnLoad (JavaVM * vm, void *reserved);
void JNI_OnUnload (JavaVM * vm, void *reserved);
void Java_org_sqlite_NativeDB__1open (JNIEnv *, jobject, jstring);
void Java_org_sqlite_NativeDB__1close (JNIEnv *, jobject);
void Java_org_sqlite_NativeDB_interrupt (JNIEnv *, jobject);
void Java_org_sqlite_NativeDB_busy_1timeout (JNIEnv *, jobject, jint);
jlong Java_org_sqlite_NativeDB_prepare (JNIEnv *, jobject, jstring);
jstring Java_org_sqlite_NativeDB_errmsg (JNIEnv *, jobject);
jstring Java_org_sqlite_NativeDB_libversion (JNIEnv *, jobject);
jint Java_org_sqlite_NativeDB_changes (JNIEnv *, jobject);
jint Java_org_sqlite_NativeDB_finalize (JNIEnv *, jobject, jlong);
jint Java_org_sqlite_NativeDB_step (JNIEnv *, jobject, jlong);
jint Java_org_sqlite_NativeDB_reset (JNIEnv *, jobject, jlong);
jint Java_org_sqlite_NativeDB_clear_1bindings (JNIEnv *, jobject, jlong);
jint Java_org_sqlite_NativeDB_bind_1parameter_1count (JNIEnv *, jobject, jlong);
jint Java_org_sqlite_NativeDB_column_1count (JNIEnv *, jobject, jlong);
jint Java_org_sqlite_NativeDB_column_1type (JNIEnv *, jobject, jlong, jint);
jstring Java_org_sqlite_NativeDB_column_1decltype (JNIEnv *, jobject, jlong, jint);
jstring Java_org_sqlite_NativeDB_column_1table_1name (JNIEnv *, jobject, jlong, jint);
jstring Java_org_sqlite_NativeDB_column_1name (JNIEnv *, jobject, jlong, jint);
jstring Java_org_sqlite_NativeDB_column_1text (JNIEnv *, jobject, jlong, jint);
jbyteArray Java_org_sqlite_NativeDB_column_1blob (JNIEnv *, jobject, jlong, jint);
jdouble Java_org_sqlite_NativeDB_column_1double (JNIEnv *, jobject, jlong, jint);
jlong Java_org_sqlite_NativeDB_column_1long (JNIEnv *, jobject, jlong, jint);
jint Java_org_sqlite_NativeDB_column_1int (JNIEnv *, jobject, jlong, jint);
jint Java_org_sqlite_NativeDB_bind_1null (JNIEnv *, jobject, jlong, jint);
jint Java_org_sqlite_NativeDB_bind_1int (JNIEnv *, jobject, jlong, jint, jint);
jint Java_org_sqlite_NativeDB_bind_1long (JNIEnv *, jobject, jlong, jint, jlong);
jint Java_org_sqlite_NativeDB_bind_1double (JNIEnv *, jobject, jlong, jint, jdouble);
jint Java_org_sqlite_NativeDB_bind_1text (JNIEnv *, jobject, jlong, jint, jstring);
jint Java_org_sqlite_NativeDB_bind_1blob (JNIEnv *, jobject, jlong, jint, jbyteArray);
void Java_org_sqlite_NativeDB_result_1null (JNIEnv *, jobject, jlong);
void Java_org_sqlite_NativeDB_result_1text (JNIEnv *, jobject, jlong, jstring);
void Java_org_sqlite_NativeDB_result_1blob (JNIEnv *, jobject, jlong, jbyteArray);
void Java_org_sqlite_NativeDB_result_1double (JNIEnv *, jobject, jlong, jdouble);
void Java_org_sqlite_NativeDB_result_1long (JNIEnv *, jobject, jlong, jlong);
void Java_org_sqlite_NativeDB_result_1int (JNIEnv *, jobject, jlong, jint);
void Java_org_sqlite_NativeDB_result_1error (JNIEnv *, jobject, jlong, jstring);
jint Java_org_sqlite_NativeDB_value_1bytes (JNIEnv *, jobject, jobject, jint);
jstring Java_org_sqlite_NativeDB_value_1text (JNIEnv *, jobject, jobject, jint);
jbyteArray Java_org_sqlite_NativeDB_value_1blob (JNIEnv *, jobject, jobject, jint);
jdouble Java_org_sqlite_NativeDB_value_1double (JNIEnv *, jobject, jobject, jint);
jlong Java_org_sqlite_NativeDB_value_1long (JNIEnv *, jobject, jobject, jint);
jint Java_org_sqlite_NativeDB_value_1int (JNIEnv *, jobject, jobject, jint);
jint Java_org_sqlite_NativeDB_value_1type (JNIEnv *, jobject, jobject, jint);
jint Java_org_sqlite_NativeDB_create_1function (JNIEnv *, jobject, jstring, jobject);
jint Java_org_sqlite_NativeDB_destroy_1function (JNIEnv *, jobject, jstring);
void Java_org_sqlite_NativeDB_free_1functions (JNIEnv *, jobject);
jobjectArray Java_org_sqlite_NativeDB_column_1metadata (JNIEnv *, jobject, jlong);
extern const char sqlite3_version[];
const char *sqlite3_libversion (void);
int sqlite3_libversion_number (void);
int sqlite3_threadsafe (void);
typedef struct sqlite3 sqlite3;
typedef long long int sqlite_int64;
typedef unsigned long long int sqlite_uint64;
typedef sqlite_int64 sqlite3_int64;
typedef sqlite_uint64 sqlite3_uint64;
int sqlite3_close (sqlite3 *);
typedef int (*sqlite3_callback) (void *, int, char **, char **);
int sqlite3_exec (sqlite3 *, const char *sql, int (*callback) (void *, int, char **, char **), void *, char **errmsg);
typedef struct sqlite3_file sqlite3_file;
struct sqlite3_file
{
  const struct sqlite3_io_methods *pMethods;
};
typedef struct sqlite3_io_methods sqlite3_io_methods;
struct sqlite3_io_methods
{
  int iVersion;
  int (*xClose) (sqlite3_file *);
  int (*xRead) (sqlite3_file *, void *, int iAmt, sqlite3_int64 iOfst);
  int (*xWrite) (sqlite3_file *, const void *, int iAmt, sqlite3_int64 iOfst);
  int (*xTruncate) (sqlite3_file *, sqlite3_int64 size);
  int (*xSync) (sqlite3_file *, int flags);
  int (*xFileSize) (sqlite3_file *, sqlite3_int64 * pSize);
  int (*xLock) (sqlite3_file *, int);
  int (*xUnlock) (sqlite3_file *, int);
  int (*xCheckReservedLock) (sqlite3_file *, int *pResOut);
  int (*xFileControl) (sqlite3_file *, int op, void *pArg);
  int (*xSectorSize) (sqlite3_file *);
  int (*xDeviceCharacteristics) (sqlite3_file *);
};
typedef struct sqlite3_mutex sqlite3_mutex;
typedef struct sqlite3_vfs sqlite3_vfs;
struct sqlite3_vfs
{
  int iVersion;
  int szOsFile;
  int mxPathname;
  sqlite3_vfs *pNext;
  const char *zName;
  void *pAppData;
  int (*xOpen) (sqlite3_vfs *, const char *zName, sqlite3_file *, int flags, int *pOutFlags);
  int (*xDelete) (sqlite3_vfs *, const char *zName, int syncDir);
  int (*xAccess) (sqlite3_vfs *, const char *zName, int flags, int *pResOut);
  int (*xFullPathname) (sqlite3_vfs *, const char *zName, int nOut, char *zOut);
  void *(*xDlOpen) (sqlite3_vfs *, const char *zFilename);
  void (*xDlError) (sqlite3_vfs *, int nByte, char *zErrMsg);
  void *(*xDlSym) (sqlite3_vfs *, void *, const char *zSymbol);
  void (*xDlClose) (sqlite3_vfs *, void *);
  int (*xRandomness) (sqlite3_vfs *, int nByte, char *zOut);
  int (*xSleep) (sqlite3_vfs *, int microseconds);
  int (*xCurrentTime) (sqlite3_vfs *, double *);
  int (*xGetLastError) (sqlite3_vfs *, int, char *);
};
int sqlite3_initialize (void);
int sqlite3_shutdown (void);
int sqlite3_os_init (void);
int sqlite3_os_end (void);
int sqlite3_config (int, ...);
typedef struct sqlite3_mem_methods sqlite3_mem_methods;
struct sqlite3_mem_methods
{
  void *(*xMalloc) (int);
  void (*xFree) (void *);
  void *(*xRealloc) (void *, int);
  int (*xSize) (void *);
  int (*xRoundup) (int);
  int (*xInit) (void *);
  void (*xShutdown) (void *);
  void *pAppData;
};
int sqlite3_extended_result_codes (sqlite3 *, int onoff);
sqlite3_int64 sqlite3_last_insert_rowid (sqlite3 *);
int sqlite3_changes (sqlite3 *);
int sqlite3_total_changes (sqlite3 *);
void sqlite3_interrupt (sqlite3 *);
int sqlite3_complete (const char *sql);
int sqlite3_complete16 (const void *sql);
int sqlite3_busy_handler (sqlite3 *, int (*)(void *, int), void *);
int sqlite3_busy_timeout (sqlite3 *, int ms);
int sqlite3_get_table (sqlite3 * db, const char *zSql, char ***pazResult, int *pnRow, int *pnColumn, char **pzErrmsg);
void sqlite3_free_table (char **result);
char *sqlite3_mprintf (const char *, ...);
char *sqlite3_vmprintf (const char *, va_list);
char *sqlite3_snprintf (int, char *, const char *, ...);
void *sqlite3_malloc (int);
void *sqlite3_realloc (void *, int);
void sqlite3_free (void *);
sqlite3_int64 sqlite3_memory_used (void);
sqlite3_int64 sqlite3_memory_highwater (int resetFlag);
void sqlite3_randomness (int N, void *P);
int sqlite3_set_authorizer (sqlite3 *, int (*xAuth) (void *, int, const char *, const char *, const char *, const char *), void *pUserData);
void *sqlite3_trace (sqlite3 *, void (*xTrace) (void *, const char *), void *);
void *sqlite3_profile (sqlite3 *, void (*xProfile) (void *, const char *, sqlite3_uint64), void *);
void sqlite3_progress_handler (sqlite3 *, int, int (*)(void *), void *);
int sqlite3_open (const char *filename, sqlite3 ** ppDb);
int sqlite3_open16 (const void *filename, sqlite3 ** ppDb);
int sqlite3_open_v2 (const char *filename, sqlite3 ** ppDb, int flags, const char *zVfs);
int sqlite3_errcode (sqlite3 * db);
const char *sqlite3_errmsg (sqlite3 *);
const void *sqlite3_errmsg16 (sqlite3 *);
typedef struct sqlite3_stmt sqlite3_stmt;
int sqlite3_limit (sqlite3 *, int id, int newVal);
int sqlite3_prepare (sqlite3 * db, const char *zSql, int nByte, sqlite3_stmt ** ppStmt, const char **pzTail);
int sqlite3_prepare_v2 (sqlite3 * db, const char *zSql, int nByte, sqlite3_stmt ** ppStmt, const char **pzTail);
int sqlite3_prepare16 (sqlite3 * db, const void *zSql, int nByte, sqlite3_stmt ** ppStmt, const void **pzTail);
int sqlite3_prepare16_v2 (sqlite3 * db, const void *zSql, int nByte, sqlite3_stmt ** ppStmt, const void **pzTail);
const char *sqlite3_sql (sqlite3_stmt * pStmt);
typedef struct Mem sqlite3_value;
typedef struct sqlite3_context sqlite3_context;
int sqlite3_bind_blob (sqlite3_stmt *, int, const void *, int n, void (*)(void *));
int sqlite3_bind_double (sqlite3_stmt *, int, double);
int sqlite3_bind_int (sqlite3_stmt *, int, int);
int sqlite3_bind_int64 (sqlite3_stmt *, int, sqlite3_int64);
int sqlite3_bind_null (sqlite3_stmt *, int);
int sqlite3_bind_text (sqlite3_stmt *, int, const char *, int n, void (*)(void *));
int sqlite3_bind_text16 (sqlite3_stmt *, int, const void *, int, void (*)(void *));
int sqlite3_bind_value (sqlite3_stmt *, int, const sqlite3_value *);
int sqlite3_bind_zeroblob (sqlite3_stmt *, int, int n);
int sqlite3_bind_parameter_count (sqlite3_stmt *);
const char *sqlite3_bind_parameter_name (sqlite3_stmt *, int);
int sqlite3_bind_parameter_index (sqlite3_stmt *, const char *zName);
int sqlite3_clear_bindings (sqlite3_stmt *);
int sqlite3_column_count (sqlite3_stmt * pStmt);
const char *sqlite3_column_name (sqlite3_stmt *, int N);
const void *sqlite3_column_name16 (sqlite3_stmt *, int N);
const char *sqlite3_column_database_name (sqlite3_stmt *, int);
const void *sqlite3_column_database_name16 (sqlite3_stmt *, int);
const char *sqlite3_column_table_name (sqlite3_stmt *, int);
const void *sqlite3_column_table_name16 (sqlite3_stmt *, int);
const char *sqlite3_column_origin_name (sqlite3_stmt *, int);
const void *sqlite3_column_origin_name16 (sqlite3_stmt *, int);
const char *sqlite3_column_decltype (sqlite3_stmt *, int);
const void *sqlite3_column_decltype16 (sqlite3_stmt *, int);
int sqlite3_step (sqlite3_stmt *);
int sqlite3_data_count (sqlite3_stmt * pStmt);
const void *sqlite3_column_blob (sqlite3_stmt *, int iCol);
int sqlite3_column_bytes (sqlite3_stmt *, int iCol);
int sqlite3_column_bytes16 (sqlite3_stmt *, int iCol);
double sqlite3_column_double (sqlite3_stmt *, int iCol);
int sqlite3_column_int (sqlite3_stmt *, int iCol);
sqlite3_int64 sqlite3_column_int64 (sqlite3_stmt *, int iCol);
const unsigned char *sqlite3_column_text (sqlite3_stmt *, int iCol);
const void *sqlite3_column_text16 (sqlite3_stmt *, int iCol);
int sqlite3_column_type (sqlite3_stmt *, int iCol);
sqlite3_value *sqlite3_column_value (sqlite3_stmt *, int iCol);
int sqlite3_finalize (sqlite3_stmt * pStmt);
int sqlite3_reset (sqlite3_stmt * pStmt);
int sqlite3_create_function (sqlite3 * db, const char *zFunctionName, int nArg, int eTextRep, void *pApp, void (*xFunc) (sqlite3_context *, int, sqlite3_value **), void (*xStep) (sqlite3_context *, int, sqlite3_value **), void (*xFinal) (sqlite3_context *));
int sqlite3_create_function16 (sqlite3 * db, const void *zFunctionName, int nArg, int eTextRep, void *pApp, void (*xFunc) (sqlite3_context *, int, sqlite3_value **), void (*xStep) (sqlite3_context *, int, sqlite3_value **), void (*xFinal) (sqlite3_context *));
int sqlite3_aggregate_count (sqlite3_context *);
int sqlite3_expired (sqlite3_stmt *);
int sqlite3_transfer_bindings (sqlite3_stmt *, sqlite3_stmt *);
int sqlite3_global_recover (void);
void sqlite3_thread_cleanup (void);
int sqlite3_memory_alarm (void (*)(void *, sqlite3_int64, int), void *, sqlite3_int64);
const void *sqlite3_value_blob (sqlite3_value *);
int sqlite3_value_bytes (sqlite3_value *);
int sqlite3_value_bytes16 (sqlite3_value *);
double sqlite3_value_double (sqlite3_value *);
int sqlite3_value_int (sqlite3_value *);
sqlite3_int64 sqlite3_value_int64 (sqlite3_value *);
const unsigned char *sqlite3_value_text (sqlite3_value *);
const void *sqlite3_value_text16 (sqlite3_value *);
const void *sqlite3_value_text16le (sqlite3_value *);
const void *sqlite3_value_text16be (sqlite3_value *);
int sqlite3_value_type (sqlite3_value *);
int sqlite3_value_numeric_type (sqlite3_value *);
void *sqlite3_aggregate_context (sqlite3_context *, int nBytes);
void *sqlite3_user_data (sqlite3_context *);
sqlite3 *sqlite3_context_db_handle (sqlite3_context *);
void *sqlite3_get_auxdata (sqlite3_context *, int N);
void sqlite3_set_auxdata (sqlite3_context *, int N, void *, void (*)(void *));
typedef void (*sqlite3_destructor_type) (void *);
void sqlite3_result_blob (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_double (sqlite3_context *, double);
void sqlite3_result_error (sqlite3_context *, const char *, int);
void sqlite3_result_error16 (sqlite3_context *, const void *, int);
void sqlite3_result_error_toobig (sqlite3_context *);
void sqlite3_result_error_nomem (sqlite3_context *);
void sqlite3_result_error_code (sqlite3_context *, int);
void sqlite3_result_int (sqlite3_context *, int);
void sqlite3_result_int64 (sqlite3_context *, sqlite3_int64);
void sqlite3_result_null (sqlite3_context *);
void sqlite3_result_text (sqlite3_context *, const char *, int, void (*)(void *));
void sqlite3_result_text16 (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_text16le (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_text16be (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_value (sqlite3_context *, sqlite3_value *);
void sqlite3_result_zeroblob (sqlite3_context *, int n);
int sqlite3_create_collation (sqlite3 *, const char *zName, int eTextRep, void *, int (*xCompare) (void *, int, const void *, int, const void *));
int sqlite3_create_collation_v2 (sqlite3 *, const char *zName, int eTextRep, void *, int (*xCompare) (void *, int, const void *, int, const void *), void (*xDestroy) (void *));
int sqlite3_create_collation16 (sqlite3 *, const void *zName, int eTextRep, void *, int (*xCompare) (void *, int, const void *, int, const void *));
int sqlite3_collation_needed (sqlite3 *, void *, void (*)(void *, sqlite3 *, int eTextRep, const char *));
int sqlite3_collation_needed16 (sqlite3 *, void *, void (*)(void *, sqlite3 *, int eTextRep, const void *));
int sqlite3_key (sqlite3 * db, const void *pKey, int nKey);
int sqlite3_rekey (sqlite3 * db, const void *pKey, int nKey);
int sqlite3_sleep (int);
extern char *sqlite3_temp_directory;
int sqlite3_get_autocommit (sqlite3 *);
sqlite3 *sqlite3_db_handle (sqlite3_stmt *);
sqlite3_stmt *sqlite3_next_stmt (sqlite3 * pDb, sqlite3_stmt * pStmt);
void *sqlite3_commit_hook (sqlite3 *, int (*)(void *), void *);
void *sqlite3_rollback_hook (sqlite3 *, void (*)(void *), void *);
void *sqlite3_update_hook (sqlite3 *, void (*)(void *, int, char const *, char const *, sqlite3_int64), void *);
int sqlite3_enable_shared_cache (int);
int sqlite3_release_memory (int);
void sqlite3_soft_heap_limit (int);
int sqlite3_table_column_metadata (sqlite3 * db, const char *zDbName, const char *zTableName, const char *zColumnName, char const **pzDataType, char const **pzCollSeq, int *pNotNull, int *pPrimaryKey, int *pAutoinc);
int sqlite3_load_extension (sqlite3 * db, const char *zFile, const char *zProc, char **pzErrMsg);
int sqlite3_enable_load_extension (sqlite3 * db, int onoff);
int sqlite3_auto_extension (void *xEntryPoint);
void sqlite3_reset_auto_extension (void);
typedef struct sqlite3_vtab sqlite3_vtab;
typedef struct sqlite3_index_info sqlite3_index_info;
typedef struct sqlite3_vtab_cursor sqlite3_vtab_cursor;
typedef struct sqlite3_module sqlite3_module;
struct sqlite3_module
{
  int iVersion;
  int (*xCreate) (sqlite3 *, void *pAux, int argc, const char *const *argv, sqlite3_vtab ** ppVTab, char **);
  int (*xConnect) (sqlite3 *, void *pAux, int argc, const char *const *argv, sqlite3_vtab ** ppVTab, char **);
  int (*xBestIndex) (sqlite3_vtab * pVTab, sqlite3_index_info *);
  int (*xDisconnect) (sqlite3_vtab * pVTab);
  int (*xDestroy) (sqlite3_vtab * pVTab);
  int (*xOpen) (sqlite3_vtab * pVTab, sqlite3_vtab_cursor ** ppCursor);
  int (*xClose) (sqlite3_vtab_cursor *);
  int (*xFilter) (sqlite3_vtab_cursor *, int idxNum, const char *idxStr, int argc, sqlite3_value ** argv);
  int (*xNext) (sqlite3_vtab_cursor *);
  int (*xEof) (sqlite3_vtab_cursor *);
  int (*xColumn) (sqlite3_vtab_cursor *, sqlite3_context *, int);
  int (*xRowid) (sqlite3_vtab_cursor *, sqlite3_int64 * pRowid);
  int (*xUpdate) (sqlite3_vtab *, int, sqlite3_value **, sqlite3_int64 *);
  int (*xBegin) (sqlite3_vtab * pVTab);
  int (*xSync) (sqlite3_vtab * pVTab);
  int (*xCommit) (sqlite3_vtab * pVTab);
  int (*xRollback) (sqlite3_vtab * pVTab);
  int (*xFindFunction) (sqlite3_vtab * pVtab, int nArg, const char *zName, void (**pxFunc) (sqlite3_context *, int, sqlite3_value **), void **ppArg);
  int (*xRename) (sqlite3_vtab * pVtab, const char *zNew);
};
struct sqlite3_index_info
{
  int nConstraint;
  struct sqlite3_index_constraint
  {
    int iColumn;
    unsigned char op;
    unsigned char usable;
    int iTermOffset;
  } *aConstraint;
  int nOrderBy;
  struct sqlite3_index_orderby
  {
    int iColumn;
    unsigned char desc;
  } *aOrderBy;
  struct sqlite3_index_constraint_usage
  {
    int argvIndex;
    unsigned char omit;
  } *aConstraintUsage;
  int idxNum;
  char *idxStr;
  int needToFreeIdxStr;
  int orderByConsumed;
  double estimatedCost;
};
int sqlite3_create_module (sqlite3 * db, const char *zName, const sqlite3_module *, void *);
int sqlite3_create_module_v2 (sqlite3 * db, const char *zName, const sqlite3_module *, void *, void (*xDestroy) (void *));
struct sqlite3_vtab
{
  const sqlite3_module *pModule;
  int nRef;
  char *zErrMsg;
};
struct sqlite3_vtab_cursor
{
  sqlite3_vtab *pVtab;
};
int sqlite3_declare_vtab (sqlite3 *, const char *zCreateTable);
int sqlite3_overload_function (sqlite3 *, const char *zFuncName, int nArg);
typedef struct sqlite3_blob sqlite3_blob;
int sqlite3_blob_open (sqlite3 *, const char *zDb, const char *zTable, const char *zColumn, sqlite3_int64 iRow, int flags, sqlite3_blob ** ppBlob);
int sqlite3_blob_close (sqlite3_blob *);
int sqlite3_blob_bytes (sqlite3_blob *);
int sqlite3_blob_read (sqlite3_blob *, void *Z, int N, int iOffset);
int sqlite3_blob_write (sqlite3_blob *, const void *z, int n, int iOffset);
sqlite3_vfs *sqlite3_vfs_find (const char *zVfsName);
int sqlite3_vfs_register (sqlite3_vfs *, int makeDflt);
int sqlite3_vfs_unregister (sqlite3_vfs *);
sqlite3_mutex *sqlite3_mutex_alloc (int);
void sqlite3_mutex_free (sqlite3_mutex *);
void sqlite3_mutex_enter (sqlite3_mutex *);
int sqlite3_mutex_try (sqlite3_mutex *);
void sqlite3_mutex_leave (sqlite3_mutex *);
typedef struct sqlite3_mutex_methods sqlite3_mutex_methods;
struct sqlite3_mutex_methods
{
  int (*xMutexInit) (void);
  int (*xMutexEnd) (void);
  sqlite3_mutex *(*xMutexAlloc) (int);
  void (*xMutexFree) (sqlite3_mutex *);
  void (*xMutexEnter) (sqlite3_mutex *);
  int (*xMutexTry) (sqlite3_mutex *);
  void (*xMutexLeave) (sqlite3_mutex *);
  int (*xMutexHeld) (sqlite3_mutex *);
  int (*xMutexNotheld) (sqlite3_mutex *);
};
int sqlite3_mutex_held (sqlite3_mutex *);
int sqlite3_mutex_notheld (sqlite3_mutex *);
int sqlite3_file_control (sqlite3 *, const char *zDbName, int op, void *);
int sqlite3_test_control (int op, ...);
int sqlite3_status (int op, int *pCurrent, int *pHighwater, int resetFlag);
typedef __useconds_t useconds_t;
typedef __intptr_t intptr_t;
typedef __socklen_t socklen_t;
extern int access (const char *__name, int __type);
extern __off_t lseek (int __fd, __off_t __offset, int __whence);
extern int close (int __fd);
extern ssize_t read (int __fd, void *__buf, size_t __nbytes);
extern ssize_t write (int __fd, const void *__buf, size_t __n);
extern int pipe (int __pipedes[2]);
extern unsigned int alarm (unsigned int __seconds);
extern unsigned int sleep (unsigned int __seconds);
extern __useconds_t ualarm (__useconds_t __value, __useconds_t __interval);
extern int usleep (__useconds_t __useconds);
extern int pause (void);
extern int chown (const char *__file, __uid_t __owner, __gid_t __group);
extern int fchown (int __fd, __uid_t __owner, __gid_t __group);
extern int lchown (const char *__file, __uid_t __owner, __gid_t __group);
extern int chdir (const char *__path);
extern int fchdir (int __fd);
extern char *getcwd (char *__buf, size_t __size);
extern char *getwd (char *__buf);
extern int dup (int __fd);
extern int dup2 (int __fd, int __fd2);
extern char **__environ;
extern int execve (const char *__path, char *const __argv[], char *const __envp[]);
extern int execv (const char *__path, char *const __argv[]);
extern int execle (const char *__path, const char *__arg, ...);
extern int execl (const char *__path, const char *__arg, ...);
extern int execvp (const char *__file, char *const __argv[]);
extern int execlp (const char *__file, const char *__arg, ...);
extern int nice (int __inc);
extern void _exit (int __status);
enum
{
  _PC_LINK_MAX,
  _PC_MAX_CANON,
  _PC_MAX_INPUT,
  _PC_NAME_MAX,
  _PC_PATH_MAX,
  _PC_PIPE_BUF,
  _PC_CHOWN_RESTRICTED,
  _PC_NO_TRUNC,
  _PC_VDISABLE,
  _PC_SYNC_IO,
  _PC_ASYNC_IO,
  _PC_PRIO_IO,
  _PC_SOCK_MAXBUF,
  _PC_FILESIZEBITS,
  _PC_REC_INCR_XFER_SIZE,
  _PC_REC_MAX_XFER_SIZE,
  _PC_REC_MIN_XFER_SIZE,
  _PC_REC_XFER_ALIGN,
  _PC_ALLOC_SIZE_MIN,
  _PC_SYMLINK_MAX,
  _PC_2_SYMLINKS
};
enum
{
  _SC_ARG_MAX,
  _SC_CHILD_MAX,
  _SC_CLK_TCK,
  _SC_NGROUPS_MAX,
  _SC_OPEN_MAX,
  _SC_STREAM_MAX,
  _SC_TZNAME_MAX,
  _SC_JOB_CONTROL,
  _SC_SAVED_IDS,
  _SC_REALTIME_SIGNALS,
  _SC_PRIORITY_SCHEDULING,
  _SC_TIMERS,
  _SC_ASYNCHRONOUS_IO,
  _SC_PRIORITIZED_IO,
  _SC_SYNCHRONIZED_IO,
  _SC_FSYNC,
  _SC_MAPPED_FILES,
  _SC_MEMLOCK,
  _SC_MEMLOCK_RANGE,
  _SC_MEMORY_PROTECTION,
  _SC_MESSAGE_PASSING,
  _SC_SEMAPHORES,
  _SC_SHARED_MEMORY_OBJECTS,
  _SC_AIO_LISTIO_MAX,
  _SC_AIO_MAX,
  _SC_AIO_PRIO_DELTA_MAX,
  _SC_DELAYTIMER_MAX,
  _SC_MQ_OPEN_MAX,
  _SC_MQ_PRIO_MAX,
  _SC_VERSION,
  _SC_PAGESIZE,
  _SC_RTSIG_MAX,
  _SC_SEM_NSEMS_MAX,
  _SC_SEM_VALUE_MAX,
  _SC_SIGQUEUE_MAX,
  _SC_TIMER_MAX,
  _SC_BC_BASE_MAX,
  _SC_BC_DIM_MAX,
  _SC_BC_SCALE_MAX,
  _SC_BC_STRING_MAX,
  _SC_COLL_WEIGHTS_MAX,
  _SC_EQUIV_CLASS_MAX,
  _SC_EXPR_NEST_MAX,
  _SC_LINE_MAX,
  _SC_RE_DUP_MAX,
  _SC_CHARCLASS_NAME_MAX,
  _SC_2_VERSION,
  _SC_2_C_BIND,
  _SC_2_C_DEV,
  _SC_2_FORT_DEV,
  _SC_2_FORT_RUN,
  _SC_2_SW_DEV,
  _SC_2_LOCALEDEF,
  _SC_PII,
  _SC_PII_XTI,
  _SC_PII_SOCKET,
  _SC_PII_INTERNET,
  _SC_PII_OSI,
  _SC_POLL,
  _SC_SELECT,
  _SC_UIO_MAXIOV,
  _SC_IOV_MAX = _SC_UIO_MAXIOV,
  _SC_PII_INTERNET_STREAM,
  _SC_PII_INTERNET_DGRAM,
  _SC_PII_OSI_COTS,
  _SC_PII_OSI_CLTS,
  _SC_PII_OSI_M,
  _SC_T_IOV_MAX,
  _SC_THREADS,
  _SC_THREAD_SAFE_FUNCTIONS,
  _SC_GETGR_R_SIZE_MAX,
  _SC_GETPW_R_SIZE_MAX,
  _SC_LOGIN_NAME_MAX,
  _SC_TTY_NAME_MAX,
  _SC_THREAD_DESTRUCTOR_ITERATIONS,
  _SC_THREAD_KEYS_MAX,
  _SC_THREAD_STACK_MIN,
  _SC_THREAD_THREADS_MAX,
  _SC_THREAD_ATTR_STACKADDR,
  _SC_THREAD_ATTR_STACKSIZE,
  _SC_THREAD_PRIORITY_SCHEDULING,
  _SC_THREAD_PRIO_INHERIT,
  _SC_THREAD_PRIO_PROTECT,
  _SC_THREAD_PROCESS_SHARED,
  _SC_NPROCESSORS_CONF,
  _SC_NPROCESSORS_ONLN,
  _SC_PHYS_PAGES,
  _SC_AVPHYS_PAGES,
  _SC_ATEXIT_MAX,
  _SC_PASS_MAX,
  _SC_XOPEN_VERSION,
  _SC_XOPEN_XCU_VERSION,
  _SC_XOPEN_UNIX,
  _SC_XOPEN_CRYPT,
  _SC_XOPEN_ENH_I18N,
  _SC_XOPEN_SHM,
  _SC_2_CHAR_TERM,
  _SC_2_C_VERSION,
  _SC_2_UPE,
  _SC_XOPEN_XPG2,
  _SC_XOPEN_XPG3,
  _SC_XOPEN_XPG4,
  _SC_CHAR_BIT,
  _SC_CHAR_MAX,
  _SC_CHAR_MIN,
  _SC_INT_MAX,
  _SC_INT_MIN,
  _SC_LONG_BIT,
  _SC_WORD_BIT,
  _SC_MB_LEN_MAX,
  _SC_NZERO,
  _SC_SSIZE_MAX,
  _SC_SCHAR_MAX,
  _SC_SCHAR_MIN,
  _SC_SHRT_MAX,
  _SC_SHRT_MIN,
  _SC_UCHAR_MAX,
  _SC_UINT_MAX,
  _SC_ULONG_MAX,
  _SC_USHRT_MAX,
  _SC_NL_ARGMAX,
  _SC_NL_LANGMAX,
  _SC_NL_MSGMAX,
  _SC_NL_NMAX,
  _SC_NL_SETMAX,
  _SC_NL_TEXTMAX,
  _SC_XBS5_ILP32_OFF32,
  _SC_XBS5_ILP32_OFFBIG,
  _SC_XBS5_LP64_OFF64,
  _SC_XBS5_LPBIG_OFFBIG,
  _SC_XOPEN_LEGACY,
  _SC_XOPEN_REALTIME,
  _SC_XOPEN_REALTIME_THREADS,
  _SC_ADVISORY_INFO,
  _SC_BARRIERS,
  _SC_BASE,
  _SC_C_LANG_SUPPORT,
  _SC_C_LANG_SUPPORT_R,
  _SC_CLOCK_SELECTION,
  _SC_CPUTIME,
  _SC_THREAD_CPUTIME,
  _SC_DEVICE_IO,
  _SC_DEVICE_SPECIFIC,
  _SC_DEVICE_SPECIFIC_R,
  _SC_FD_MGMT,
  _SC_FIFO,
  _SC_PIPE,
  _SC_FILE_ATTRIBUTES,
  _SC_FILE_LOCKING,
  _SC_FILE_SYSTEM,
  _SC_MONOTONIC_CLOCK,
  _SC_MULTI_PROCESS,
  _SC_SINGLE_PROCESS,
  _SC_NETWORKING,
  _SC_READER_WRITER_LOCKS,
  _SC_SPIN_LOCKS,
  _SC_REGEXP,
  _SC_REGEX_VERSION,
  _SC_SHELL,
  _SC_SIGNALS,
  _SC_SPAWN,
  _SC_SPORADIC_SERVER,
  _SC_THREAD_SPORADIC_SERVER,
  _SC_SYSTEM_DATABASE,
  _SC_SYSTEM_DATABASE_R,
  _SC_TIMEOUTS,
  _SC_TYPED_MEMORY_OBJECTS,
  _SC_USER_GROUPS,
  _SC_USER_GROUPS_R,
  _SC_2_PBS,
  _SC_2_PBS_ACCOUNTING,
  _SC_2_PBS_LOCATE,
  _SC_2_PBS_MESSAGE,
  _SC_2_PBS_TRACK,
  _SC_SYMLOOP_MAX,
  _SC_STREAMS,
  _SC_2_PBS_CHECKPOINT,
  _SC_V6_ILP32_OFF32,
  _SC_V6_ILP32_OFFBIG,
  _SC_V6_LP64_OFF64,
  _SC_V6_LPBIG_OFFBIG,
  _SC_HOST_NAME_MAX,
  _SC_TRACE,
  _SC_TRACE_EVENT_FILTER,
  _SC_TRACE_INHERIT,
  _SC_TRACE_LOG,
  _SC_LEVEL1_ICACHE_SIZE,
  _SC_LEVEL1_ICACHE_ASSOC,
  _SC_LEVEL1_ICACHE_LINESIZE,
  _SC_LEVEL1_DCACHE_SIZE,
  _SC_LEVEL1_DCACHE_ASSOC,
  _SC_LEVEL1_DCACHE_LINESIZE,
  _SC_LEVEL2_CACHE_SIZE,
  _SC_LEVEL2_CACHE_ASSOC,
  _SC_LEVEL2_CACHE_LINESIZE,
  _SC_LEVEL3_CACHE_SIZE,
  _SC_LEVEL3_CACHE_ASSOC,
  _SC_LEVEL3_CACHE_LINESIZE,
  _SC_LEVEL4_CACHE_SIZE,
  _SC_LEVEL4_CACHE_ASSOC,
  _SC_LEVEL4_CACHE_LINESIZE,
  _SC_IPV6 = _SC_LEVEL1_ICACHE_SIZE + 50,
  _SC_RAW_SOCKETS
};
enum
{
  _CS_PATH,
  _CS_V6_WIDTH_RESTRICTED_ENVS,
  _CS_GNU_LIBC_VERSION,
  _CS_GNU_LIBPTHREAD_VERSION,
  _CS_LFS_CFLAGS = 1000,
  _CS_LFS_LDFLAGS,
  _CS_LFS_LIBS,
  _CS_LFS_LINTFLAGS,
  _CS_LFS64_CFLAGS,
  _CS_LFS64_LDFLAGS,
  _CS_LFS64_LIBS,
  _CS_LFS64_LINTFLAGS,
  _CS_XBS5_ILP32_OFF32_CFLAGS = 1100,
  _CS_XBS5_ILP32_OFF32_LDFLAGS,
  _CS_XBS5_ILP32_OFF32_LIBS,
  _CS_XBS5_ILP32_OFF32_LINTFLAGS,
  _CS_XBS5_ILP32_OFFBIG_CFLAGS,
  _CS_XBS5_ILP32_OFFBIG_LDFLAGS,
  _CS_XBS5_ILP32_OFFBIG_LIBS,
  _CS_XBS5_ILP32_OFFBIG_LINTFLAGS,
  _CS_XBS5_LP64_OFF64_CFLAGS,
  _CS_XBS5_LP64_OFF64_LDFLAGS,
  _CS_XBS5_LP64_OFF64_LIBS,
  _CS_XBS5_LP64_OFF64_LINTFLAGS,
  _CS_XBS5_LPBIG_OFFBIG_CFLAGS,
  _CS_XBS5_LPBIG_OFFBIG_LDFLAGS,
  _CS_XBS5_LPBIG_OFFBIG_LIBS,
  _CS_XBS5_LPBIG_OFFBIG_LINTFLAGS,
  _CS_POSIX_V6_ILP32_OFF32_CFLAGS,
  _CS_POSIX_V6_ILP32_OFF32_LDFLAGS,
  _CS_POSIX_V6_ILP32_OFF32_LIBS,
  _CS_POSIX_V6_ILP32_OFF32_LINTFLAGS,
  _CS_POSIX_V6_ILP32_OFFBIG_CFLAGS,
  _CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS,
  _CS_POSIX_V6_ILP32_OFFBIG_LIBS,
  _CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS,
  _CS_POSIX_V6_LP64_OFF64_CFLAGS,
  _CS_POSIX_V6_LP64_OFF64_LDFLAGS,
  _CS_POSIX_V6_LP64_OFF64_LIBS,
  _CS_POSIX_V6_LP64_OFF64_LINTFLAGS,
  _CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS,
  _CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS,
  _CS_POSIX_V6_LPBIG_OFFBIG_LIBS,
  _CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS
};
extern long int pathconf (const char *__path, int __name);
extern long int fpathconf (int __fd, int __name);
extern long int sysconf (int __name);
extern size_t confstr (int __name, char *__buf, size_t __len);
extern __pid_t getpid (void);
extern __pid_t getppid (void);
extern __pid_t getpgrp (void);
extern __pid_t __getpgid (__pid_t __pid);
extern int setpgid (__pid_t __pid, __pid_t __pgid);
extern int setpgrp (void);
extern __pid_t setsid (void);
extern __uid_t getuid (void);
extern __uid_t geteuid (void);
extern __gid_t getgid (void);
extern __gid_t getegid (void);
extern int getgroups (int __size, __gid_t __list[]);
extern int setuid (__uid_t __uid);
extern int setreuid (__uid_t __ruid, __uid_t __euid);
extern int seteuid (__uid_t __uid);
extern int setgid (__gid_t __gid);
extern int setregid (__gid_t __rgid, __gid_t __egid);
extern int setegid (__gid_t __gid);
extern __pid_t fork (void);
extern __pid_t vfork (void);
extern char *ttyname (int __fd);
extern int ttyname_r (int __fd, char *__buf, size_t __buflen);
extern int isatty (int __fd);
extern int ttyslot (void);
extern int link (const char *__from, const char *__to);
extern int symlink (const char *__from, const char *__to);
extern ssize_t readlink (const char *__path, char *__buf, size_t __len);
extern int unlink (const char *__name);
extern int rmdir (const char *__path);
extern __pid_t tcgetpgrp (int __fd);
extern int tcsetpgrp (int __fd, __pid_t __pgrp_id);
extern char *getlogin (void);
extern int getlogin_r (char *__name, size_t __name_len);
extern int setlogin (const char *__name);
extern char *optarg;
extern int optind;
extern int opterr;
extern int optopt;
extern int getopt (int ___argc, char *const *___argv, const char *__shortopts);
extern int gethostname (char *__name, size_t __len);
extern int sethostname (const char *__name, size_t __len);
extern int sethostid (long int __id);
extern int getdomainname (char *__name, size_t __len);
extern int setdomainname (const char *__name, size_t __len);
extern int vhangup (void);
extern int revoke (const char *__file);
extern int profil (unsigned short int *__sample_buffer, size_t __size, size_t __offset, unsigned int __scale);
extern int acct (const char *__name);
extern char *getusershell (void);
extern void endusershell (void);
extern void setusershell (void);
extern int daemon (int __nochdir, int __noclose);
extern int chroot (const char *__path);
extern char *getpass (const char *__prompt);
extern int fsync (int __fd);
extern long int gethostid (void);
extern void sync (void);
extern int getpagesize (void);
extern int getdtablesize (void);
extern int truncate (const char *__file, __off_t __length);
extern int ftruncate (int __fd, __off_t __length);
extern int brk (void *__addr);
extern void *sbrk (intptr_t __delta);
extern long int syscall (long int __sysno, ...);
extern int lockf (int __fd, int __cmd, __off_t __len);
extern int fdatasync (int __fildes);
static jclass dbclass = 0;
static jclass fclass = 0;
static jclass aclass = 0;
static void *
toref (jlong value)
{
  jvalue ret;
  ret.j = value;
  return (void *) ret.l;
}
static jlong
fromref (void *value)
{
  jvalue ret;
  ret.l = value;
  return ret.j;
}
static void
throwex (JNIEnv * env, jobject this)
{
  static jmethodID mth_throwex = 0;
  if (!mth_throwex)
    mth_throwex = (*env)->GetMethodID (env, dbclass, "throwex", "()V");
  (*env)->CallVoidMethod (env, this, mth_throwex);
}
static void
throwexmsg (JNIEnv * env, const char *str)
{
  static jmethodID mth_throwexmsg = 0;
  if (!mth_throwexmsg)
    mth_throwexmsg = (*env)->GetStaticMethodID (env, dbclass, "throwex", "(Ljava/lang/String;)V");
  (*env)->CallStaticVoidMethod (env, dbclass, mth_throwexmsg, (*env)->NewStringUTF (env, str));
}
static sqlite3 *
gethandle (JNIEnv * env, jobject this)
{
  static jfieldID pointer = 0;
  if (!pointer)
    pointer = (*env)->GetFieldID (env, dbclass, "pointer", "J");
  return (sqlite3 *) toref ((*env)->GetLongField (env, this, pointer));
}
static void
sethandle (JNIEnv * env, jobject this, sqlite3 * ref)
{
  static jfieldID pointer = 0;
  if (!pointer)
    pointer = (*env)->GetFieldID (env, dbclass, "pointer", "J");
  (*env)->SetLongField (env, this, pointer, fromref (ref));
}
static jsize
jstrlen (const jchar * str)
{
  const jchar *s;
  for (s = str; *s; s++);
  return (jsize) (s - str);
}
struct UDFData
{
  JavaVM *vm;
  jobject func;
  struct UDFData *next;
};
static sqlite3_value *
tovalue (JNIEnv * env, jobject function, jint arg)
{
  jlong value_pntr = 0;
  jint numArgs = 0;
  static jfieldID func_value = 0, func_args = 0;
  if (!func_value || !func_args)
    {
      func_value = (*env)->GetFieldID (env, fclass, "value", "J");
      func_args = (*env)->GetFieldID (env, fclass, "args", "I");
    }
  if (arg < 0)
    {
      throwexmsg (env, "negative arg out of range");
      return 0;
    }
  if (!function)
    {
      throwexmsg (env, "inconstent function");
      return 0;
    }
  value_pntr = (*env)->GetLongField (env, function, func_value);
  numArgs = (*env)->GetIntField (env, function, func_args);
  if (value_pntr == 0)
    {
      throwexmsg (env, "no current value");
      return 0;
    }
  if (arg >= numArgs)
    {
      throwexmsg (env, "arg out of range");
      return 0;
    }
  return ((sqlite3_value **) toref (value_pntr))[arg];
}
static void
xFunc_error (sqlite3_context * context, JNIEnv * env)
{
  const char *strmsg = 0;
  jstring msg = 0;
  jint msgsize = 0;
  jclass exclass = 0;
  static jmethodID exp_msg = 0;
  jthrowable ex = (*env)->ExceptionOccurred (env);
  (*env)->ExceptionClear (env);
  if (!exp_msg)
    {
      exclass = (*env)->FindClass (env, "java/lang/Throwable");
      exp_msg = (*env)->GetMethodID (env, exclass, "toString", "()Ljava/lang/String;");
    }
  msg = (jstring) (*env)->CallObjectMethod (env, ex, exp_msg);
  if (!msg)
    {
      sqlite3_result_error (context, "unknown error", 13);
      return;
    }
  msgsize = (*env)->GetStringUTFLength (env, msg);
  strmsg = (*env)->GetStringUTFChars (env, msg, 0);
  ((strmsg) ? (void) (0) : __assert_fail ("strmsg", "src/org/sqlite/NativeDB.c", 150, ""));
  sqlite3_result_error (context, strmsg, msgsize);
  (*env)->ReleaseStringUTFChars (env, msg, strmsg);
}
static
xCall (sqlite3_context * context, int args, sqlite3_value ** value, jobject func, jmethodID method)
{
  static jfieldID fld_context = 0, fld_value = 0, fld_args = 0;
  JNIEnv *env = 0;
  struct UDFData *udf = 0;
  udf = (struct UDFData *) sqlite3_user_data (context);
  ((udf) ? (void) (0) : __assert_fail ("udf", "src/org/sqlite/NativeDB.c", 172, ""));
  (*udf->vm)->AttachCurrentThread (udf->vm, (void **) &env, 0);
  if (!func)
    func = udf->func;
  if (!fld_context || !fld_value || !fld_args)
    {
      fld_context = (*env)->GetFieldID (env, fclass, "context", "J");
      fld_value = (*env)->GetFieldID (env, fclass, "value", "J");
      fld_args = (*env)->GetFieldID (env, fclass, "args", "I");
    }
  (*env)->SetLongField (env, func, fld_context, fromref (context));
  (*env)->SetLongField (env, func, fld_value, value ? fromref (value) : 0);
  (*env)->SetIntField (env, func, fld_args, args);
  (*env)->CallVoidMethod (env, func, method);
  (*env)->SetLongField (env, func, fld_context, 0);
  (*env)->SetLongField (env, func, fld_value, 0);
  (*env)->SetIntField (env, func, fld_args, 0);
  if ((*env)->ExceptionCheck (env))
    xFunc_error (context, env);
}
void
xFunc (sqlite3_context * context, int args, sqlite3_value ** value)
{
  static jmethodID mth = 0;
  if (!mth)
    {
      JNIEnv *env;
      struct UDFData *udf = (struct UDFData *) sqlite3_user_data (context);
      (*udf->vm)->AttachCurrentThread (udf->vm, (void **) &env, 0);
      mth = (*env)->GetMethodID (env, fclass, "xFunc", "()V");
    }
  xCall (context, args, value, 0, mth);
}
void
xStep (sqlite3_context * context, int args, sqlite3_value ** value)
{
  JNIEnv *env;
  struct UDFData *udf;
  jobject *func = 0;
  static jmethodID mth = 0;
  static jmethodID clone = 0;
  if (!mth || !clone)
    {
      udf = (struct UDFData *) sqlite3_user_data (context);
      (*udf->vm)->AttachCurrentThread (udf->vm, (void **) &env, 0);
      mth = (*env)->GetMethodID (env, aclass, "xStep", "()V");
      clone = (*env)->GetMethodID (env, aclass, "clone", "()Ljava/lang/Object;");
    }
  func = sqlite3_aggregate_context (context, sizeof (jobject));
  if (!*func)
    {
      udf = (struct UDFData *) sqlite3_user_data (context);
      (*udf->vm)->AttachCurrentThread (udf->vm, (void **) &env, 0);
      *func = (*env)->CallObjectMethod (env, udf->func, clone);
      *func = (*env)->NewGlobalRef (env, *func);
    }
  xCall (context, args, value, *func, mth);
}
void
xFinal (sqlite3_context * context)
{
  JNIEnv *env = 0;
  struct UDFData *udf = 0;
  jobject *func = 0;
  static jmethodID mth = 0;
  udf = (struct UDFData *) sqlite3_user_data (context);
  (*udf->vm)->AttachCurrentThread (udf->vm, (void **) &env, 0);
  if (!mth)
    mth = (*env)->GetMethodID (env, aclass, "xFinal", "()V");
  func = sqlite3_aggregate_context (context, sizeof (jobject));
  ((*func) ? (void) (0) : __assert_fail ("*func", "src/org/sqlite/NativeDB.c", 253, ""));
  xCall (context, 0, 0, *func, mth);
  (*env)->DeleteGlobalRef (env, *func);
}
jint
JNI_OnLoad (JavaVM * vm, void *reserved)
{
  JNIEnv *env = 0;
  if (0 != (*vm)->GetEnv (vm, (void **) &env, 0x00010002))
    return (-1);
  dbclass = (*env)->FindClass (env, "org/sqlite/NativeDB");
  if (!dbclass)
    return (-1);
  dbclass = (*env)->NewGlobalRef (env, dbclass);
  fclass = (*env)->FindClass (env, "org/sqlite/Function");
  if (!fclass)
    return (-1);
  fclass = (*env)->NewGlobalRef (env, fclass);
  aclass = (*env)->FindClass (env, "org/sqlite/Function$Aggregate");
  if (!aclass)
    return (-1);
  aclass = (*env)->NewGlobalRef (env, aclass);
  return 0x00010002;
}
void
Java_org_sqlite_NativeDB__1open (JNIEnv * env, jobject this, jstring file)
{
  int ret;
  sqlite3 *db = gethandle (env, this);
  const char *str;
  if (db)
    {
      throwexmsg (env, "DB already open");
      sqlite3_close (db);
      return;
    }
  str = (*env)->GetStringUTFChars (env, file, 0);
  if (sqlite3_open (str, &db))
    {
      throwex (env, this);
      sqlite3_close (db);
      return;
    }
  (*env)->ReleaseStringUTFChars (env, file, str);
  sethandle (env, this, db);
}
void
Java_org_sqlite_NativeDB__1close (JNIEnv * env, jobject this)
{
  if (sqlite3_close (gethandle (env, this)) != 0)
    {
      throwex (env, this);
    }
  sethandle (env, this, 0);
}
void
Java_org_sqlite_NativeDB_interrupt (JNIEnv * env, jobject this)
{
  sqlite3_interrupt (gethandle (env, this));
}
void
Java_org_sqlite_NativeDB_busy_1timeout (JNIEnv * env, jobject this, jint ms)
{
  sqlite3_busy_timeout (gethandle (env, this), ms);
}
jlong
Java_org_sqlite_NativeDB_prepare (JNIEnv * env, jobject this, jstring sql)
{
  sqlite3 *db = gethandle (env, this);
  sqlite3_stmt *stmt;
  const char *strsql = (*env)->GetStringUTFChars (env, sql, 0);
  int status = sqlite3_prepare_v2 (db, strsql, -1, &stmt, 0);
  (*env)->ReleaseStringUTFChars (env, sql, strsql);
  if (status != 0)
    {
      throwex (env, this);
      return fromref (0);
    }
  return fromref (stmt);
}
jstring
Java_org_sqlite_NativeDB_errmsg (JNIEnv * env, jobject this)
{
  return (*env)->NewStringUTF (env, sqlite3_errmsg (gethandle (env, this)));
}
jstring
Java_org_sqlite_NativeDB_libversion (JNIEnv * env, jobject this)
{
  return (*env)->NewStringUTF (env, sqlite3_libversion ());
}
jint
Java_org_sqlite_NativeDB_changes (JNIEnv * env, jobject this)
{
  return sqlite3_changes (gethandle (env, this));
}
jint
Java_org_sqlite_NativeDB_finalize (JNIEnv * env, jobject this, jlong stmt)
{
  return sqlite3_finalize (toref (stmt));
}
jint
Java_org_sqlite_NativeDB_step (JNIEnv * env, jobject this, jlong stmt)
{
  return sqlite3_step (toref (stmt));
}
jint
Java_org_sqlite_NativeDB_reset (JNIEnv * env, jobject this, jlong stmt)
{
  return sqlite3_reset (toref (stmt));
}
jint
Java_org_sqlite_NativeDB_clear_1bindings (JNIEnv * env, jobject this, jlong stmt)
{
  int i;
  int count = sqlite3_bind_parameter_count (toref (stmt));
  jint rc = 0;
  for (i = 1; rc == 0 && i <= count; i++)
    {
      rc = sqlite3_bind_null (toref (stmt), i);
    }
  return rc;
}
jint
Java_org_sqlite_NativeDB_bind_1parameter_1count (JNIEnv * env, jobject this, jlong stmt)
{
  return sqlite3_bind_parameter_count (toref (stmt));
}
jint
Java_org_sqlite_NativeDB_column_1count (JNIEnv * env, jobject this, jlong stmt)
{
  return sqlite3_column_count (toref (stmt));
}
jint
Java_org_sqlite_NativeDB_column_1type (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  return sqlite3_column_type (toref (stmt), col);
}
jstring
Java_org_sqlite_NativeDB_column_1decltype (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  const char *str = sqlite3_column_decltype (toref (stmt), col);
  return (*env)->NewStringUTF (env, str);
}
jstring
Java_org_sqlite_NativeDB_column_1table_1name (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  const void *str = sqlite3_column_table_name16 (toref (stmt), col);
  return str ? (*env)->NewString (env, str, jstrlen (str)) : ((void *) 0);
}
jstring
Java_org_sqlite_NativeDB_column_1name (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  const void *str = sqlite3_column_name16 (toref (stmt), col);
  return str ? (*env)->NewString (env, str, jstrlen (str)) : ((void *) 0);
}
jstring
Java_org_sqlite_NativeDB_column_1text (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  return (*env)->NewStringUTF (env, (const char *) sqlite3_column_text (toref (stmt), col));
}
jbyteArray
Java_org_sqlite_NativeDB_column_1blob (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  jsize length;
  jbyteArray jBlob;
  jbyte *a;
  const void *blob = sqlite3_column_blob (toref (stmt), col);
  if (!blob)
    return ((void *) 0);
  length = sqlite3_column_bytes (toref (stmt), col);
  jBlob = (*env)->NewByteArray (env, length);
  ((jBlob) ? (void) (0) : __assert_fail ("jBlob", "src/org/sqlite/NativeDB.c", 454, ""));
  a = (*env)->GetPrimitiveArrayCritical (env, jBlob, 0);
  memcpy (a, blob, length);
  (*env)->ReleasePrimitiveArrayCritical (env, jBlob, a, 0);
  return jBlob;
}
jdouble
Java_org_sqlite_NativeDB_column_1double (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  return sqlite3_column_double (toref (stmt), col);
}
jlong
Java_org_sqlite_NativeDB_column_1long (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  return sqlite3_column_int64 (toref (stmt), col);
}
jint
Java_org_sqlite_NativeDB_column_1int (JNIEnv * env, jobject this, jlong stmt, jint col)
{
  return sqlite3_column_int (toref (stmt), col);
}
jint
Java_org_sqlite_NativeDB_bind_1null (JNIEnv * env, jobject this, jlong stmt, jint pos)
{
  return sqlite3_bind_null (toref (stmt), pos);
}
jint
Java_org_sqlite_NativeDB_bind_1int (JNIEnv * env, jobject this, jlong stmt, jint pos, jint v)
{
  return sqlite3_bind_int (toref (stmt), pos, v);
}
jint
Java_org_sqlite_NativeDB_bind_1long (JNIEnv * env, jobject this, jlong stmt, jint pos, jlong v)
{
  return sqlite3_bind_int64 (toref (stmt), pos, v);
}
jint
Java_org_sqlite_NativeDB_bind_1double (JNIEnv * env, jobject this, jlong stmt, jint pos, jdouble v)
{
  return sqlite3_bind_double (toref (stmt), pos, v);
}
jint
Java_org_sqlite_NativeDB_bind_1text (JNIEnv * env, jobject this, jlong stmt, jint pos, jstring v)
{
  const char *chars = (*env)->GetStringUTFChars (env, v, 0);
  int rc = sqlite3_bind_text (toref (stmt), pos, chars, -1, ((sqlite3_destructor_type) - 1));
  (*env)->ReleaseStringUTFChars (env, v, chars);
  return rc;
}
jint
Java_org_sqlite_NativeDB_bind_1blob (JNIEnv * env, jobject this, jlong stmt, jint pos, jbyteArray v)
{
  jint rc;
  void *a;
  jsize size = (*env)->GetArrayLength (env, v);
  ((a = (*env)->GetPrimitiveArrayCritical (env, v, 0)) ? (void) (0) : __assert_fail ("a = (*env)->GetPrimitiveArrayCritical(env, v, 0)", "src/org/sqlite/NativeDB.c", 520, ""));
  rc = sqlite3_bind_blob (toref (stmt), pos, a, size, ((sqlite3_destructor_type) - 1));
  (*env)->ReleasePrimitiveArrayCritical (env, v, a, 2);
  return rc;
}
void
Java_org_sqlite_NativeDB_result_1null (JNIEnv * env, jobject this, jlong context)
{
  sqlite3_result_null (toref (context));
}
void
Java_org_sqlite_NativeDB_result_1text (JNIEnv * env, jobject this, jlong context, jstring value)
{
  const jchar *str;
  jsize size;
  if (value == ((void *) 0))
    {
      sqlite3_result_null (toref (context));
      return;
    }
  size = (*env)->GetStringLength (env, value) * 2;
  str = (*env)->GetStringCritical (env, value, 0);
  ((str) ? (void) (0) : __assert_fail ("str", "src/org/sqlite/NativeDB.c", 542, ""));
  sqlite3_result_text16 (toref (context), str, size, ((sqlite3_destructor_type) - 1));
  (*env)->ReleaseStringCritical (env, value, str);
}
void
Java_org_sqlite_NativeDB_result_1blob (JNIEnv * env, jobject this, jlong context, jobject value)
{
  jbyte *bytes;
  jsize size;
  if (value == ((void *) 0))
    {
      sqlite3_result_null (toref (context));
      return;
    }
  size = (*env)->GetArrayLength (env, value);
  bytes = (*env)->GetPrimitiveArrayCritical (env, value, 0);
  ((bytes) ? (void) (0) : __assert_fail ("bytes", "src/org/sqlite/NativeDB.c", 558, ""));
  sqlite3_result_blob (toref (context), bytes, size, ((sqlite3_destructor_type) - 1));
  (*env)->ReleasePrimitiveArrayCritical (env, value, bytes, 2);
}
void
Java_org_sqlite_NativeDB_result_1double (JNIEnv * env, jobject this, jlong context, jdouble value)
{
  sqlite3_result_double (toref (context), value);
}
void
Java_org_sqlite_NativeDB_result_1long (JNIEnv * env, jobject this, jlong context, jlong value)
{
  sqlite3_result_int64 (toref (context), value);
}
void
Java_org_sqlite_NativeDB_result_1int (JNIEnv * env, jobject this, jlong context, jint value)
{
  sqlite3_result_int (toref (context), value);
}
jstring
Java_org_sqlite_NativeDB_value_1text (JNIEnv * env, jobject this, jobject f, jint arg)
{
  jint length = 0;
  const void *str = 0;
  sqlite3_value *value = tovalue (env, f, arg);
  if (!value)
    return ((void *) 0);
  length = sqlite3_value_bytes16 (value) / 2;
  str = sqlite3_value_text16 (value);
  return str ? (*env)->NewString (env, str, length) : ((void *) 0);
}
jbyteArray
Java_org_sqlite_NativeDB_value_1blob (JNIEnv * env, jobject this, jobject f, jint arg)
{
  jsize length;
  jbyteArray jBlob;
  jbyte *a;
  const void *blob;
  sqlite3_value *value = tovalue (env, f, arg);
  if (!value)
    return ((void *) 0);
  blob = sqlite3_value_blob (value);
  if (!blob)
    return ((void *) 0);
  length = sqlite3_value_bytes (value);
  jBlob = (*env)->NewByteArray (env, length);
  ((jBlob) ? (void) (0) : __assert_fail ("jBlob", "src/org/sqlite/NativeDB.c", 612, ""));
  a = (*env)->GetPrimitiveArrayCritical (env, jBlob, 0);
  memcpy (a, blob, length);
  (*env)->ReleasePrimitiveArrayCritical (env, jBlob, a, 0);
  return jBlob;
}
jdouble
Java_org_sqlite_NativeDB_value_1double (JNIEnv * env, jobject this, jobject f, jint arg)
{
  sqlite3_value *value = tovalue (env, f, arg);
  return value ? sqlite3_value_double (value) : 0;
}
jlong
Java_org_sqlite_NativeDB_value_1long (JNIEnv * env, jobject this, jobject f, jint arg)
{
  sqlite3_value *value = tovalue (env, f, arg);
  return value ? sqlite3_value_int64 (value) : 0;
}
jint
Java_org_sqlite_NativeDB_value_1int (JNIEnv * env, jobject this, jobject f, jint arg)
{
  sqlite3_value *value = tovalue (env, f, arg);
  return value ? sqlite3_value_int (value) : 0;
}
jint
Java_org_sqlite_NativeDB_value_1type (JNIEnv * env, jobject this, jobject func, jint arg)
{
  return sqlite3_value_type (tovalue (env, func, arg));
}
jint
Java_org_sqlite_NativeDB_create_1function (JNIEnv * env, jobject this, jstring name, jobject func)
{
  jint ret = 0;
  const char *strname = 0;
  int isAgg = 0;
  static jfieldID udfdatalist = 0;
  struct UDFData *udf = malloc (sizeof (struct UDFData));
  ((udf) ? (void) (0) : __assert_fail ("udf", "src/org/sqlite/NativeDB.c", 659, ""));
  if (!udfdatalist)
    udfdatalist = (*env)->GetFieldID (env, dbclass, "udfdatalist", "J");
  isAgg = (*env)->IsInstanceOf (env, func, aclass);
  udf->func = (*env)->NewGlobalRef (env, func);
  (*env)->GetJavaVM (env, &udf->vm);
  udf->next = toref ((*env)->GetLongField (env, this, udfdatalist));
  (*env)->SetLongField (env, this, udfdatalist, fromref (udf));
  strname = (*env)->GetStringUTFChars (env, name, 0);
  ((strname) ? (void) (0) : __assert_fail ("strname", "src/org/sqlite/NativeDB.c", 673, ""));
  ret = sqlite3_create_function (gethandle (env, this), strname, -1, 4, udf, isAgg ? 0 : &xFunc, isAgg ? &xStep : 0, isAgg ? &xFinal : 0);
  (*env)->ReleaseStringUTFChars (env, name, strname);
  return ret;
}
jint
Java_org_sqlite_NativeDB_destroy_1function (JNIEnv * env, jobject this, jstring name)
{
  const char *strname = (*env)->GetStringUTFChars (env, name, 0);
  sqlite3_create_function (gethandle (env, this), strname, -1, 4, 0, 0, 0, 0);
  (*env)->ReleaseStringUTFChars (env, name, strname);
}
void
Java_org_sqlite_NativeDB_free_1functions (JNIEnv * env, jobject this)
{
  jfieldID udfdatalist;
  struct UDFData *udf, *udfpass;
  udfdatalist = (*env)->GetFieldID (env, dbclass, "udfdatalist", "J");
  udf = toref ((*env)->GetLongField (env, this, udfdatalist));
  (*env)->SetLongField (env, this, udfdatalist, 0);
  while (udf)
    {
      udfpass = udf->next;
      (*env)->DeleteGlobalRef (env, udf->func);
      free (udf);
      udf = udfpass;
    }
}
jobjectArray
Java_org_sqlite_NativeDB_column_1metadata (JNIEnv * env, jobject this, jlong stmt)
{
  const char *zTableName, *zColumnName;
  int pNotNull, pPrimaryKey, pAutoinc, i, colCount;
  jobjectArray array;
  jbooleanArray colData;
  jboolean *colDataRaw;
  sqlite3 *db;
  sqlite3_stmt *dbstmt;
  db = gethandle (env, this);
  dbstmt = toref (stmt);
  colCount = sqlite3_column_count (dbstmt);
  array = (*env)->NewObjectArray (env, colCount, (*env)->FindClass (env, "[Z"), ((void *) 0));
  ((array) ? (void) (0) : __assert_fail ("array", "src/org/sqlite/NativeDB.c", 741, ""));
  colDataRaw = (jboolean *) malloc (3 * sizeof (jboolean));
  ((colDataRaw) ? (void) (0) : __assert_fail ("colDataRaw", "src/org/sqlite/NativeDB.c", 744, ""));
  for (i = 0; i < colCount; i++)
    {
      zColumnName = sqlite3_column_name (dbstmt, i);
      zTableName = sqlite3_column_table_name (dbstmt, i);
      pNotNull = 0;
      pPrimaryKey = 0;
      pAutoinc = 0;
      if (zTableName && zColumnName)
	{
	  sqlite3_table_column_metadata (db, 0, zTableName, zColumnName, 0, 0, &pNotNull, &pPrimaryKey, &pAutoinc);
	}
      colDataRaw[0] = pNotNull;
      colDataRaw[1] = pPrimaryKey;
      colDataRaw[2] = pAutoinc;
      colData = (*env)->NewBooleanArray (env, 3);
      ((colData) ? (void) (0) : __assert_fail ("colData", "src/org/sqlite/NativeDB.c", 769, ""));
      (*env)->SetBooleanArrayRegion (env, colData, 0, 3, colDataRaw);
      (*env)->SetObjectArrayElement (env, array, i, colData);
    }
  free (colDataRaw);
  return array;
}
