typedef unsigned int size_t;
typedef int wchar_t;
typedef struct
{
  int quot;
  int rem;
} div_t;
typedef struct
{
  long int quot;
  long int rem;
} ldiv_t;
extern size_t __ctype_get_mb_cur_max (void);
extern double atof (const char *__nptr);
extern int atoi (const char *__nptr);
extern long int atol (const char *__nptr);
extern long long int atoll (const char *__nptr);
extern double strtod (const char *__nptr, char **__endptr);
extern long int strtol (const char *__nptr, char **__endptr, int __base);
extern unsigned long int strtoul (const char *__nptr, char **__endptr, int __base);
extern long long int strtoq (const char *__nptr, char **__endptr, int __base);
extern unsigned long long int strtouq (const char *__nptr, char **__endptr, int __base);
extern long long int strtoll (const char *__nptr, char **__endptr, int __base);
extern unsigned long long int strtoull (const char *__nptr, char **__endptr, int __base);
extern char *l64a (long int __n);
extern long int a64l (const char *__s);
typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef signed long long int __int64_t;
typedef unsigned long long int __uint64_t;
typedef long long int __quad_t;
typedef unsigned long long int __u_quad_t;
typedef __u_quad_t __dev_t;
typedef unsigned int __uid_t;
typedef unsigned int __gid_t;
typedef unsigned long int __ino_t;
typedef __u_quad_t __ino64_t;
typedef unsigned int __mode_t;
typedef unsigned int __nlink_t;
typedef long int __off_t;
typedef __quad_t __off64_t;
typedef int __pid_t;
typedef struct
{
  int __val[2];
} __fsid_t;
typedef long int __clock_t;
typedef unsigned long int __rlim_t;
typedef __u_quad_t __rlim64_t;
typedef unsigned int __id_t;
typedef long int __time_t;
typedef unsigned int __useconds_t;
typedef long int __suseconds_t;
typedef int __daddr_t;
typedef long int __swblk_t;
typedef int __key_t;
typedef int __clockid_t;
typedef void *__timer_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef __quad_t __blkcnt64_t;
typedef unsigned long int __fsblkcnt_t;
typedef __u_quad_t __fsblkcnt64_t;
typedef unsigned long int __fsfilcnt_t;
typedef __u_quad_t __fsfilcnt64_t;
typedef int __ssize_t;
typedef __off64_t __loff_t;
typedef __quad_t *__qaddr_t;
typedef char *__caddr_t;
typedef int __intptr_t;
typedef unsigned int __socklen_t;
typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __uid_t uid_t;
typedef __off_t off_t;
typedef __pid_t pid_t;
typedef __id_t id_t;
typedef __ssize_t ssize_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;
typedef __time_t time_t;
typedef __clockid_t clockid_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef int int8_t;
typedef int int16_t;
typedef int int32_t;
typedef int int64_t;
typedef unsigned int u_int8_t;
typedef unsigned int u_int16_t;
typedef unsigned int u_int32_t;
typedef unsigned int u_int64_t;
typedef int register_t;
typedef int __sig_atomic_t;
typedef struct
{
  unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
} __sigset_t;
typedef __sigset_t sigset_t;
struct timespec
{
  __time_t tv_sec;
  long int tv_nsec;
};
struct timeval
{
  __time_t tv_sec;
  __suseconds_t tv_usec;
};
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
{
  __fd_mask __fds_bits[1024 / (8 * sizeof (__fd_mask))];
}
fd_set;
typedef __fd_mask fd_mask;
extern int select (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, struct timeval *__timeout);
extern int pselect (int __nfds, fd_set * __readfds, fd_set * __writefds, fd_set * __exceptfds, const struct timespec *__timeout, const __sigset_t * __sigmask);
extern unsigned int gnu_dev_major (unsigned long long int __dev);
extern unsigned int gnu_dev_minor (unsigned long long int __dev);
extern unsigned long long int gnu_dev_makedev (unsigned int __major, unsigned int __minor);
typedef __blkcnt_t blkcnt_t;
typedef __fsblkcnt_t fsblkcnt_t;
typedef __fsfilcnt_t fsfilcnt_t;
typedef unsigned long int pthread_t;
typedef union
{
  char __size[36];
  long int __align;
} pthread_attr_t;
typedef struct __pthread_internal_slist
{
  struct __pthread_internal_slist *__next;
} __pthread_slist_t;
typedef union
{
  struct __pthread_mutex_s
  {
    int __lock;
    unsigned int __count;
    int __owner;
    int __kind;
    unsigned int __nusers;
    union
    {
      int __spins;
      __pthread_slist_t __list;
    };
  } __data;
  char __size[24];
  long int __align;
} pthread_mutex_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_mutexattr_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __futex;
    unsigned long long int __total_seq;
    unsigned long long int __wakeup_seq;
    unsigned long long int __woken_seq;
    void *__mutex;
    unsigned int __nwaiters;
    unsigned int __broadcast_seq;
  } __data;
  char __size[48];
  long long int __align;
} pthread_cond_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef int pthread_once_t;
typedef union
{
  struct
  {
    int __lock;
    unsigned int __nr_readers;
    unsigned int __readers_wakeup;
    unsigned int __writer_wakeup;
    unsigned int __nr_readers_queued;
    unsigned int __nr_writers_queued;
    unsigned char __flags;
    unsigned char __shared;
    unsigned char __pad1;
    unsigned char __pad2;
    int __writer;
  } __data;
  char __size[32];
  long int __align;
} pthread_rwlock_t;
typedef union
{
  char __size[8];
  long int __align;
} pthread_rwlockattr_t;
typedef volatile int pthread_spinlock_t;
typedef union
{
  char __size[20];
  long int __align;
} pthread_barrier_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_barrierattr_t;
extern long int random (void);
extern void srandom (unsigned int __seed);
extern char *initstate (unsigned int __seed, char *__statebuf, size_t __statelen);
extern char *setstate (char *__statebuf);
struct random_data
{
  int32_t *fptr;
  int32_t *rptr;
  int32_t *state;
  int rand_type;
  int rand_deg;
  int rand_sep;
  int32_t *end_ptr;
};
extern int random_r (struct random_data *__buf, int32_t * __result);
extern int srandom_r (unsigned int __seed, struct random_data *__buf);
extern int initstate_r (unsigned int __seed, char *__statebuf, size_t __statelen, struct random_data *__buf);
extern int setstate_r (char *__statebuf, struct random_data *__buf);
extern int rand (void);
extern void srand (unsigned int __seed);
extern int rand_r (unsigned int *__seed);
extern double drand48 (void);
extern double erand48 (unsigned short int __xsubi[3]);
extern long int lrand48 (void);
extern long int nrand48 (unsigned short int __xsubi[3]);
extern long int mrand48 (void);
extern long int jrand48 (unsigned short int __xsubi[3]);
extern void srand48 (long int __seedval);
extern unsigned short int *seed48 (unsigned short int __seed16v[3]);
extern void lcong48 (unsigned short int __param[7]);
struct drand48_data
{
  unsigned short int __x[3];
  unsigned short int __old_x[3];
  unsigned short int __c;
  unsigned short int __init;
  unsigned long long int __a;
};
extern int drand48_r (struct drand48_data *__buffer, double *__result);
extern int erand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, double *__result);
extern int lrand48_r (struct drand48_data *__buffer, long int *__result);
extern int nrand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, long int *__result);
extern int mrand48_r (struct drand48_data *__buffer, long int *__result);
extern int jrand48_r (unsigned short int __xsubi[3], struct drand48_data *__buffer, long int *__result);
extern int srand48_r (long int __seedval, struct drand48_data *__buffer);
extern int seed48_r (unsigned short int __seed16v[3], struct drand48_data *__buffer);
extern int lcong48_r (unsigned short int __param[7], struct drand48_data *__buffer);
extern void *malloc (size_t __size);
extern void *calloc (size_t __nmemb, size_t __size);
extern void *realloc (void *__ptr, size_t __size);
extern void free (void *__ptr);
extern void cfree (void *__ptr);
extern void *alloca (size_t __size);
extern void *valloc (size_t __size);
extern int posix_memalign (void **__memptr, size_t __alignment, size_t __size);
extern void abort (void);
extern int atexit (void (*__func) (void));
extern int on_exit (void (*__func) (int __status, void *__arg), void *__arg);
extern void exit (int __status);
extern char *getenv (const char *__name);
extern char *__secure_getenv (const char *__name);
extern int putenv (char *__string);
extern int setenv (const char *__name, const char *__value, int __replace);
extern int unsetenv (const char *__name);
extern int clearenv (void);
extern char *mktemp (char *__template);
extern int mkstemp (char *__template);
extern char *mkdtemp (char *__template);
extern int system (const char *__command);
extern char *realpath (const char *__name, char *__resolved);
typedef int (*__compar_fn_t) (const void *, const void *);
extern void *bsearch (const void *__key, const void *__base, size_t __nmemb, size_t __size, __compar_fn_t __compar);
extern void qsort (void *__base, size_t __nmemb, size_t __size, __compar_fn_t __compar);
extern int abs (int __x);
extern long int labs (long int __x);
extern div_t div (int __numer, int __denom);
extern ldiv_t ldiv (long int __numer, long int __denom);
extern char *ecvt (double __value, int __ndigit, int *__decpt, int *__sign);
extern char *fcvt (double __value, int __ndigit, int *__decpt, int *__sign);
extern char *gcvt (double __value, int __ndigit, char *__buf);
extern char *qecvt (long double __value, int __ndigit, int *__decpt, int *__sign);
extern char *qfcvt (long double __value, int __ndigit, int *__decpt, int *__sign);
extern char *qgcvt (long double __value, int __ndigit, char *__buf);
extern int ecvt_r (double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int fcvt_r (double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int qecvt_r (long double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int qfcvt_r (long double __value, int __ndigit, int *__decpt, int *__sign, char *__buf, size_t __len);
extern int mblen (const char *__s, size_t __n);
extern int mbtowc (wchar_t * __pwc, const char *__s, size_t __n);
extern int wctomb (char *__s, wchar_t __wchar);
extern size_t mbstowcs (wchar_t * __pwcs, const char *__s, size_t __n);
extern size_t wcstombs (char *__s, const wchar_t * __pwcs, size_t __n);
extern int rpmatch (const char *__response);
extern int posix_openpt (int __oflag);
extern int getloadavg (double __loadavg[], int __nelem);
typedef __builtin_va_list __gnuc_va_list;
typedef __gnuc_va_list va_list;
void mut_ThrowByName(JNIEnv *env, const char *name, const char *msg);
jbooleanArray mut_jbooleanArray(JNIEnv * env);
jbyteArray mut_jbyteArray(JNIEnv * env);
jcharArray mut_jcharArray(JNIEnv * env);
jshortArray mut_jshortArray(JNIEnv * env);
jintArray mut_jintArray(JNIEnv * env);
jlongArray mut_jlongArray(JNIEnv * env);
jfloatArray mut_jfloatArray(JNIEnv * env);
jdoubleArray mut_jdoubleArray(JNIEnv * env);
extern const char sqlite3_version[];
const char *sqlite3_libversion (void);
const char *sqlite3_sourceid (void);
int sqlite3_libversion_number (void);
int sqlite3_compileoption_used (const char *zOptName);
const char *sqlite3_compileoption_get (int N);
int sqlite3_threadsafe (void);
typedef struct sqlite3 sqlite3;
typedef long long int sqlite_int64;
typedef unsigned long long int sqlite_uint64;
typedef sqlite_int64 sqlite3_int64;
typedef sqlite_uint64 sqlite3_uint64;
int sqlite3_close (sqlite3 *);
typedef int (*sqlite3_callback) (void *, int, char **, char **);
int sqlite3_exec (sqlite3 *, const char *sql, int (*callback) (void *, int, char **, char **), void *, char **errmsg);
typedef struct sqlite3_file sqlite3_file;
struct sqlite3_file
{
  const struct sqlite3_io_methods *pMethods;
};
typedef struct sqlite3_io_methods sqlite3_io_methods;
struct sqlite3_io_methods
{
  int iVersion;
  int (*xClose) (sqlite3_file *);
  int (*xRead) (sqlite3_file *, void *, int iAmt, sqlite3_int64 iOfst);
  int (*xWrite) (sqlite3_file *, const void *, int iAmt, sqlite3_int64 iOfst);
  int (*xTruncate) (sqlite3_file *, sqlite3_int64 size);
  int (*xSync) (sqlite3_file *, int flags);
  int (*xFileSize) (sqlite3_file *, sqlite3_int64 * pSize);
  int (*xLock) (sqlite3_file *, int);
  int (*xUnlock) (sqlite3_file *, int);
  int (*xCheckReservedLock) (sqlite3_file *, int *pResOut);
  int (*xFileControl) (sqlite3_file *, int op, void *pArg);
  int (*xSectorSize) (sqlite3_file *);
  int (*xDeviceCharacteristics) (sqlite3_file *);
  int (*xShmMap) (sqlite3_file *, int iPg, int pgsz, int, void volatile **);
  int (*xShmLock) (sqlite3_file *, int offset, int n, int flags);
  void (*xShmBarrier) (sqlite3_file *);
  int (*xShmUnmap) (sqlite3_file *, int deleteFlag);
};
typedef struct sqlite3_mutex sqlite3_mutex;
typedef struct sqlite3_vfs sqlite3_vfs;
typedef void (*sqlite3_syscall_ptr) (void);
struct sqlite3_vfs
{
  int iVersion;
  int szOsFile;
  int mxPathname;
  sqlite3_vfs *pNext;
  const char *zName;
  void *pAppData;
  int (*xOpen) (sqlite3_vfs *, const char *zName, sqlite3_file *, int flags, int *pOutFlags);
  int (*xDelete) (sqlite3_vfs *, const char *zName, int syncDir);
  int (*xAccess) (sqlite3_vfs *, const char *zName, int flags, int *pResOut);
  int (*xFullPathname) (sqlite3_vfs *, const char *zName, int nOut, char *zOut);
  void *(*xDlOpen) (sqlite3_vfs *, const char *zFilename);
  void (*xDlError) (sqlite3_vfs *, int nByte, char *zErrMsg);
  void (*(*xDlSym) (sqlite3_vfs *, void *, const char *zSymbol)) (void);
  void (*xDlClose) (sqlite3_vfs *, void *);
  int (*xRandomness) (sqlite3_vfs *, int nByte, char *zOut);
  int (*xSleep) (sqlite3_vfs *, int microseconds);
  int (*xCurrentTime) (sqlite3_vfs *, double *);
  int (*xGetLastError) (sqlite3_vfs *, int, char *);
  int (*xCurrentTimeInt64) (sqlite3_vfs *, sqlite3_int64 *);
  int (*xSetSystemCall) (sqlite3_vfs *, const char *zName, sqlite3_syscall_ptr);
    sqlite3_syscall_ptr (*xGetSystemCall) (sqlite3_vfs *, const char *zName);
  const char *(*xNextSystemCall) (sqlite3_vfs *, const char *zName);
};
int sqlite3_initialize (void);
int sqlite3_shutdown (void);
int sqlite3_os_init (void);
int sqlite3_os_end (void);
int sqlite3_config (int, ...);
int sqlite3_db_config (sqlite3 *, int op, ...);
typedef struct sqlite3_mem_methods sqlite3_mem_methods;
struct sqlite3_mem_methods
{
  void *(*xMalloc) (int);
  void (*xFree) (void *);
  void *(*xRealloc) (void *, int);
  int (*xSize) (void *);
  int (*xRoundup) (int);
  int (*xInit) (void *);
  void (*xShutdown) (void *);
  void *pAppData;
};
int sqlite3_extended_result_codes (sqlite3 *, int onoff);
sqlite3_int64 sqlite3_last_insert_rowid (sqlite3 *);
int sqlite3_changes (sqlite3 *);
int sqlite3_total_changes (sqlite3 *);
void sqlite3_interrupt (sqlite3 *);
int sqlite3_complete (const char *sql);
int sqlite3_complete16 (const void *sql);
int sqlite3_busy_handler (sqlite3 *, int (*)(void *, int), void *);
int sqlite3_busy_timeout (sqlite3 *, int ms);
int sqlite3_get_table (sqlite3 * db, const char *zSql, char ***pazResult, int *pnRow, int *pnColumn, char **pzErrmsg);
void sqlite3_free_table (char **result);
char *sqlite3_mprintf (const char *, ...);
char *sqlite3_vmprintf (const char *, va_list);
char *sqlite3_snprintf (int, char *, const char *, ...);
char *sqlite3_vsnprintf (int, char *, const char *, va_list);
void *sqlite3_malloc (int);
void *sqlite3_realloc (void *, int);
void sqlite3_free (void *);
sqlite3_int64 sqlite3_memory_used (void);
sqlite3_int64 sqlite3_memory_highwater (int resetFlag);
void sqlite3_randomness (int N, void *P);
int sqlite3_set_authorizer (sqlite3 *, int (*xAuth) (void *, int, const char *, const char *, const char *, const char *), void *pUserData);
void *sqlite3_trace (sqlite3 *, void (*xTrace) (void *, const char *), void *);
void *sqlite3_profile (sqlite3 *, void (*xProfile) (void *, const char *, sqlite3_uint64), void *);
void sqlite3_progress_handler (sqlite3 *, int, int (*)(void *), void *);
int sqlite3_open (const char *filename, sqlite3 ** ppDb);
int sqlite3_open16 (const void *filename, sqlite3 ** ppDb);
int sqlite3_open_v2 (const char *filename, sqlite3 ** ppDb, int flags, const char *zVfs);
const char *sqlite3_uri_parameter (const char *zFilename, const char *zParam);
int sqlite3_errcode (sqlite3 * db);
int sqlite3_extended_errcode (sqlite3 * db);
const char *sqlite3_errmsg (sqlite3 *);
const void *sqlite3_errmsg16 (sqlite3 *);
typedef struct sqlite3_stmt sqlite3_stmt;
int sqlite3_limit (sqlite3 *, int id, int newVal);
int sqlite3_prepare (sqlite3 * db, const char *zSql, int nByte, sqlite3_stmt ** ppStmt, const char **pzTail);
int sqlite3_prepare_v2 (sqlite3 * db, const char *zSql, int nByte, sqlite3_stmt ** ppStmt, const char **pzTail);
int sqlite3_prepare16 (sqlite3 * db, const void *zSql, int nByte, sqlite3_stmt ** ppStmt, const void **pzTail);
int sqlite3_prepare16_v2 (sqlite3 * db, const void *zSql, int nByte, sqlite3_stmt ** ppStmt, const void **pzTail);
const char *sqlite3_sql (sqlite3_stmt * pStmt);
int sqlite3_stmt_readonly (sqlite3_stmt * pStmt);
typedef struct Mem sqlite3_value;
typedef struct sqlite3_context sqlite3_context;
int sqlite3_bind_blob (sqlite3_stmt *, int, const void *, int n, void (*)(void *));
int sqlite3_bind_double (sqlite3_stmt *, int, double);
int sqlite3_bind_int (sqlite3_stmt *, int, int);
int sqlite3_bind_int64 (sqlite3_stmt *, int, sqlite3_int64);
int sqlite3_bind_null (sqlite3_stmt *, int);
int sqlite3_bind_text (sqlite3_stmt *, int, const char *, int n, void (*)(void *));
int sqlite3_bind_text16 (sqlite3_stmt *, int, const void *, int, void (*)(void *));
int sqlite3_bind_value (sqlite3_stmt *, int, const sqlite3_value *);
int sqlite3_bind_zeroblob (sqlite3_stmt *, int, int n);
int sqlite3_bind_parameter_count (sqlite3_stmt *);
const char *sqlite3_bind_parameter_name (sqlite3_stmt *, int);
int sqlite3_bind_parameter_index (sqlite3_stmt *, const char *zName);
int sqlite3_clear_bindings (sqlite3_stmt *);
int sqlite3_column_count (sqlite3_stmt * pStmt);
const char *sqlite3_column_name (sqlite3_stmt *, int N);
const void *sqlite3_column_name16 (sqlite3_stmt *, int N);
const char *sqlite3_column_database_name (sqlite3_stmt *, int);
const void *sqlite3_column_database_name16 (sqlite3_stmt *, int);
const char *sqlite3_column_table_name (sqlite3_stmt *, int);
const void *sqlite3_column_table_name16 (sqlite3_stmt *, int);
const char *sqlite3_column_origin_name (sqlite3_stmt *, int);
const void *sqlite3_column_origin_name16 (sqlite3_stmt *, int);
const char *sqlite3_column_decltype (sqlite3_stmt *, int);
const void *sqlite3_column_decltype16 (sqlite3_stmt *, int);
int sqlite3_step (sqlite3_stmt *);
int sqlite3_data_count (sqlite3_stmt * pStmt);
const void *sqlite3_column_blob (sqlite3_stmt *, int iCol);
int sqlite3_column_bytes (sqlite3_stmt *, int iCol);
int sqlite3_column_bytes16 (sqlite3_stmt *, int iCol);
double sqlite3_column_double (sqlite3_stmt *, int iCol);
int sqlite3_column_int (sqlite3_stmt *, int iCol);
sqlite3_int64 sqlite3_column_int64 (sqlite3_stmt *, int iCol);
const unsigned char *sqlite3_column_text (sqlite3_stmt *, int iCol);
const void *sqlite3_column_text16 (sqlite3_stmt *, int iCol);
int sqlite3_column_type (sqlite3_stmt *, int iCol);
sqlite3_value *sqlite3_column_value (sqlite3_stmt *, int iCol);
int sqlite3_finalize (sqlite3_stmt * pStmt);
int sqlite3_reset (sqlite3_stmt * pStmt);
int sqlite3_create_function (sqlite3 * db, const char *zFunctionName, int nArg, int eTextRep, void *pApp, void (*xFunc) (sqlite3_context *, int, sqlite3_value **), void (*xStep) (sqlite3_context *, int, sqlite3_value **), void (*xFinal) (sqlite3_context *));
int sqlite3_create_function16 (sqlite3 * db, const void *zFunctionName, int nArg, int eTextRep, void *pApp, void (*xFunc) (sqlite3_context *, int, sqlite3_value **), void (*xStep) (sqlite3_context *, int, sqlite3_value **), void (*xFinal) (sqlite3_context *));
int sqlite3_create_function_v2 (sqlite3 * db, const char *zFunctionName, int nArg, int eTextRep, void *pApp, void (*xFunc) (sqlite3_context *, int, sqlite3_value **), void (*xStep) (sqlite3_context *, int, sqlite3_value **), void (*xFinal) (sqlite3_context *), void (*xDestroy) (void *));
int sqlite3_aggregate_count (sqlite3_context *);
int sqlite3_expired (sqlite3_stmt *);
int sqlite3_transfer_bindings (sqlite3_stmt *, sqlite3_stmt *);
int sqlite3_global_recover (void);
void sqlite3_thread_cleanup (void);
int sqlite3_memory_alarm (void (*)(void *, sqlite3_int64, int), void *, sqlite3_int64);
const void *sqlite3_value_blob (sqlite3_value *);
int sqlite3_value_bytes (sqlite3_value *);
int sqlite3_value_bytes16 (sqlite3_value *);
double sqlite3_value_double (sqlite3_value *);
int sqlite3_value_int (sqlite3_value *);
sqlite3_int64 sqlite3_value_int64 (sqlite3_value *);
const unsigned char *sqlite3_value_text (sqlite3_value *);
const void *sqlite3_value_text16 (sqlite3_value *);
const void *sqlite3_value_text16le (sqlite3_value *);
const void *sqlite3_value_text16be (sqlite3_value *);
int sqlite3_value_type (sqlite3_value *);
int sqlite3_value_numeric_type (sqlite3_value *);
void *sqlite3_aggregate_context (sqlite3_context *, int nBytes);
void *sqlite3_user_data (sqlite3_context *);
sqlite3 *sqlite3_context_db_handle (sqlite3_context *);
void *sqlite3_get_auxdata (sqlite3_context *, int N);
void sqlite3_set_auxdata (sqlite3_context *, int N, void *, void (*)(void *));
typedef void (*sqlite3_destructor_type) (void *);
void sqlite3_result_blob (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_double (sqlite3_context *, double);
void sqlite3_result_error (sqlite3_context *, const char *, int);
void sqlite3_result_error16 (sqlite3_context *, const void *, int);
void sqlite3_result_error_toobig (sqlite3_context *);
void sqlite3_result_error_nomem (sqlite3_context *);
void sqlite3_result_error_code (sqlite3_context *, int);
void sqlite3_result_int (sqlite3_context *, int);
void sqlite3_result_int64 (sqlite3_context *, sqlite3_int64);
void sqlite3_result_null (sqlite3_context *);
void sqlite3_result_text (sqlite3_context *, const char *, int, void (*)(void *));
void sqlite3_result_text16 (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_text16le (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_text16be (sqlite3_context *, const void *, int, void (*)(void *));
void sqlite3_result_value (sqlite3_context *, sqlite3_value *);
void sqlite3_result_zeroblob (sqlite3_context *, int n);
int sqlite3_create_collation (sqlite3 *, const char *zName, int eTextRep, void *pArg, int (*xCompare) (void *, int, const void *, int, const void *));
int sqlite3_create_collation_v2 (sqlite3 *, const char *zName, int eTextRep, void *pArg, int (*xCompare) (void *, int, const void *, int, const void *), void (*xDestroy) (void *));
int sqlite3_create_collation16 (sqlite3 *, const void *zName, int eTextRep, void *pArg, int (*xCompare) (void *, int, const void *, int, const void *));
int sqlite3_collation_needed (sqlite3 *, void *, void (*)(void *, sqlite3 *, int eTextRep, const char *));
int sqlite3_collation_needed16 (sqlite3 *, void *, void (*)(void *, sqlite3 *, int eTextRep, const void *));
int sqlite3_sleep (int);
extern char *sqlite3_temp_directory;
int sqlite3_get_autocommit (sqlite3 *);
sqlite3 *sqlite3_db_handle (sqlite3_stmt *);
sqlite3_stmt *sqlite3_next_stmt (sqlite3 * pDb, sqlite3_stmt * pStmt);
void *sqlite3_commit_hook (sqlite3 *, int (*)(void *), void *);
void *sqlite3_rollback_hook (sqlite3 *, void (*)(void *), void *);
void *sqlite3_update_hook (sqlite3 *, void (*)(void *, int, char const *, char const *, sqlite3_int64), void *);
int sqlite3_enable_shared_cache (int);
int sqlite3_release_memory (int);
sqlite3_int64 sqlite3_soft_heap_limit64 (sqlite3_int64 N);
void sqlite3_soft_heap_limit (int N);
int sqlite3_table_column_metadata (sqlite3 * db, const char *zDbName, const char *zTableName, const char *zColumnName, char const **pzDataType, char const **pzCollSeq, int *pNotNull, int *pPrimaryKey, int *pAutoinc);
int sqlite3_load_extension (sqlite3 * db, const char *zFile, const char *zProc, char **pzErrMsg);
int sqlite3_enable_load_extension (sqlite3 * db, int onoff);
int sqlite3_auto_extension (void (*xEntryPoint) (void));
void sqlite3_reset_auto_extension (void);
typedef struct sqlite3_vtab sqlite3_vtab;
typedef struct sqlite3_index_info sqlite3_index_info;
typedef struct sqlite3_vtab_cursor sqlite3_vtab_cursor;
typedef struct sqlite3_module sqlite3_module;
struct sqlite3_module
{
  int iVersion;
  int (*xCreate) (sqlite3 *, void *pAux, int argc, const char *const *argv, sqlite3_vtab ** ppVTab, char **);
  int (*xConnect) (sqlite3 *, void *pAux, int argc, const char *const *argv, sqlite3_vtab ** ppVTab, char **);
  int (*xBestIndex) (sqlite3_vtab * pVTab, sqlite3_index_info *);
  int (*xDisconnect) (sqlite3_vtab * pVTab);
  int (*xDestroy) (sqlite3_vtab * pVTab);
  int (*xOpen) (sqlite3_vtab * pVTab, sqlite3_vtab_cursor ** ppCursor);
  int (*xClose) (sqlite3_vtab_cursor *);
  int (*xFilter) (sqlite3_vtab_cursor *, int idxNum, const char *idxStr, int argc, sqlite3_value ** argv);
  int (*xNext) (sqlite3_vtab_cursor *);
  int (*xEof) (sqlite3_vtab_cursor *);
  int (*xColumn) (sqlite3_vtab_cursor *, sqlite3_context *, int);
  int (*xRowid) (sqlite3_vtab_cursor *, sqlite3_int64 * pRowid);
  int (*xUpdate) (sqlite3_vtab *, int, sqlite3_value **, sqlite3_int64 *);
  int (*xBegin) (sqlite3_vtab * pVTab);
  int (*xSync) (sqlite3_vtab * pVTab);
  int (*xCommit) (sqlite3_vtab * pVTab);
  int (*xRollback) (sqlite3_vtab * pVTab);
  int (*xFindFunction) (sqlite3_vtab * pVtab, int nArg, const char *zName, void (**pxFunc) (sqlite3_context *, int, sqlite3_value **), void **ppArg);
  int (*xRename) (sqlite3_vtab * pVtab, const char *zNew);
  int (*xSavepoint) (sqlite3_vtab * pVTab, int);
  int (*xRelease) (sqlite3_vtab * pVTab, int);
  int (*xRollbackTo) (sqlite3_vtab * pVTab, int);
};
struct sqlite3_index_info
{
  int nConstraint;
  struct sqlite3_index_constraint
  {
    int iColumn;
    unsigned char op;
    unsigned char usable;
    int iTermOffset;
  } *aConstraint;
  int nOrderBy;
  struct sqlite3_index_orderby
  {
    int iColumn;
    unsigned char desc;
  } *aOrderBy;
  struct sqlite3_index_constraint_usage
  {
    int argvIndex;
    unsigned char omit;
  } *aConstraintUsage;
  int idxNum;
  char *idxStr;
  int needToFreeIdxStr;
  int orderByConsumed;
  double estimatedCost;
};
int sqlite3_create_module (sqlite3 * db, const char *zName, const sqlite3_module * p, void *pClientData);
int sqlite3_create_module_v2 (sqlite3 * db, const char *zName, const sqlite3_module * p, void *pClientData, void (*xDestroy) (void *));
struct sqlite3_vtab
{
  const sqlite3_module *pModule;
  int nRef;
  char *zErrMsg;
};
struct sqlite3_vtab_cursor
{
  sqlite3_vtab *pVtab;
};
int sqlite3_declare_vtab (sqlite3 *, const char *zSQL);
int sqlite3_overload_function (sqlite3 *, const char *zFuncName, int nArg);
typedef struct sqlite3_blob sqlite3_blob;
int sqlite3_blob_open (sqlite3 *, const char *zDb, const char *zTable, const char *zColumn, sqlite3_int64 iRow, int flags, sqlite3_blob ** ppBlob);
int sqlite3_blob_reopen (sqlite3_blob *, sqlite3_int64);
int sqlite3_blob_close (sqlite3_blob *);
int sqlite3_blob_bytes (sqlite3_blob *);
int sqlite3_blob_read (sqlite3_blob *, void *Z, int N, int iOffset);
int sqlite3_blob_write (sqlite3_blob *, const void *z, int n, int iOffset);
sqlite3_vfs *sqlite3_vfs_find (const char *zVfsName);
int sqlite3_vfs_register (sqlite3_vfs *, int makeDflt);
int sqlite3_vfs_unregister (sqlite3_vfs *);
sqlite3_mutex *sqlite3_mutex_alloc (int);
void sqlite3_mutex_free (sqlite3_mutex *);
void sqlite3_mutex_enter (sqlite3_mutex *);
int sqlite3_mutex_try (sqlite3_mutex *);
void sqlite3_mutex_leave (sqlite3_mutex *);
typedef struct sqlite3_mutex_methods sqlite3_mutex_methods;
struct sqlite3_mutex_methods
{
  int (*xMutexInit) (void);
  int (*xMutexEnd) (void);
  sqlite3_mutex *(*xMutexAlloc) (int);
  void (*xMutexFree) (sqlite3_mutex *);
  void (*xMutexEnter) (sqlite3_mutex *);
  int (*xMutexTry) (sqlite3_mutex *);
  void (*xMutexLeave) (sqlite3_mutex *);
  int (*xMutexHeld) (sqlite3_mutex *);
  int (*xMutexNotheld) (sqlite3_mutex *);
};
int sqlite3_mutex_held (sqlite3_mutex *);
int sqlite3_mutex_notheld (sqlite3_mutex *);
sqlite3_mutex *sqlite3_db_mutex (sqlite3 *);
int sqlite3_file_control (sqlite3 *, const char *zDbName, int op, void *);
int sqlite3_test_control (int op, ...);
int sqlite3_status (int op, int *pCurrent, int *pHighwater, int resetFlag);
int sqlite3_db_status (sqlite3 *, int op, int *pCur, int *pHiwtr, int resetFlg);
int sqlite3_stmt_status (sqlite3_stmt *, int op, int resetFlg);
typedef struct sqlite3_pcache sqlite3_pcache;
typedef struct sqlite3_pcache_methods sqlite3_pcache_methods;
struct sqlite3_pcache_methods
{
  void *pArg;
  int (*xInit) (void *);
  void (*xShutdown) (void *);
  sqlite3_pcache *(*xCreate) (int szPage, int bPurgeable);
  void (*xCachesize) (sqlite3_pcache *, int nCachesize);
  int (*xPagecount) (sqlite3_pcache *);
  void *(*xFetch) (sqlite3_pcache *, unsigned key, int createFlag);
  void (*xUnpin) (sqlite3_pcache *, void *, int discard);
  void (*xRekey) (sqlite3_pcache *, void *, unsigned oldKey, unsigned newKey);
  void (*xTruncate) (sqlite3_pcache *, unsigned iLimit);
  void (*xDestroy) (sqlite3_pcache *);
};
typedef struct sqlite3_backup sqlite3_backup;
sqlite3_backup *sqlite3_backup_init (sqlite3 * pDest, const char *zDestName, sqlite3 * pSource, const char *zSourceName);
int sqlite3_backup_step (sqlite3_backup * p, int nPage);
int sqlite3_backup_finish (sqlite3_backup * p);
int sqlite3_backup_remaining (sqlite3_backup * p);
int sqlite3_backup_pagecount (sqlite3_backup * p);
int sqlite3_unlock_notify (sqlite3 * pBlocked, void (*xNotify) (void **apArg, int nArg), void *pNotifyArg);
int sqlite3_strnicmp (const char *, const char *, int);
void sqlite3_log (int iErrCode, const char *zFormat, ...);
void *sqlite3_wal_hook (sqlite3 *, int (*)(void *, sqlite3 *, const char *, int), void *);
int sqlite3_wal_autocheckpoint (sqlite3 * db, int N);
int sqlite3_wal_checkpoint (sqlite3 * db, const char *zDb);
int sqlite3_wal_checkpoint_v2 (sqlite3 * db, const char *zDb, int eMode, int *pnLog, int *pnCkpt);
int sqlite3_vtab_config (sqlite3 *, int op, ...);
int sqlite3_vtab_on_conflict (sqlite3 *);
typedef struct sqlite3_rtree_geometry sqlite3_rtree_geometry;
int sqlite3_rtree_geometry_callback (sqlite3 * db, const char *zGeom, int (*xGeom) (sqlite3_rtree_geometry *, int nCoord, double *aCoord, int *pRes), void *pContext);
struct sqlite3_rtree_geometry
{
  void *pContext;
  int nParam;
  double *aParam;
  void *pUser;
  void (*xDelUser) (void *);
};
struct metadata
{
  int pNotNull;
  int pPrimaryKey;
  int pAutoinc;
};
int
column_metadata_helper (sqlite3 * db, sqlite3_stmt * stmt, int col, struct metadata *p)
{
  const char *zTableName, *zColumnName;
  int rc = 0;
  p->pNotNull = 0;
  p->pPrimaryKey = 0;
  p->pAutoinc = 0;
  zTableName = sqlite3_column_table_name (stmt, col);
  zColumnName = sqlite3_column_name (stmt, col);
  if (zTableName && zColumnName)
    {
      rc = sqlite3_table_column_metadata (db, 0, zTableName, zColumnName, 0, 0, &p->pNotNull, &p->pPrimaryKey, &p->pAutoinc);
    }
  return rc;
}
extern int _call_java (int xType, int context, int args, int value);
void
xFunc_helper (sqlite3_context * context, int args, sqlite3_value ** value)
{
  _call_java (1, (int) context, args, (int) value);
}
void
xStep_helper (sqlite3_context * context, int args, sqlite3_value ** value)
{
  _call_java (2, (int) context, args, (int) value);
}
void
xFinal_helper (sqlite3_context * context)
{
  _call_java (3, (int) context, 0, 0);
}
int
create_function_helper (sqlite3 * db, const char *name, int pos, int agg)
{
  return sqlite3_create_function (db, name, -1, 5, (void *) pos, pos >= 0 && !agg ? &xFunc_helper : 0, pos >= 0 && agg ? &xStep_helper : 0, pos >= 0 && agg ? &xFinal_helper : 0);
}
